diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/jar/Attributes.java kaffe/libraries/javalib/java/util/jar/Attributes.java
--- kaffe_orig/libraries/javalib/java/util/jar/Attributes.java	2003-09-26 14:19:40.000000000 +1200
+++ kaffe/libraries/javalib/java/util/jar/Attributes.java	2003-09-27 23:01:30.000000000 +1200
@@ -1,175 +1,625 @@
-/* Class : Attributes
+/* Attributes.java -- Represents attribute name/value pairs from a Manifest
+   Copyright (C) 2000, 2002 Free Software Foundation, Inc.
 
-  Implementation of the 1.2 Java class Attributes.
+This file is part of GNU Classpath.
 
-  Copyright : Moses DeJong, dejong@cs.umn.edu, 1998.
-  Source code licensed under the GPL.
-  You can get a copy of the license from www.gnu.org.
-
-  This code is intended for use in the Kaffe project but you can use
-  it in other projects as long as you follow the license rules.
-*/
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.jar;
 
 import java.util.Collection;
-import java.util.HashMap;
+import java.util.Hashtable;
 import java.util.Map;
 import java.util.Set;
 
-public class Attributes implements Map, Cloneable {
-    protected Map map;
-
-    public Attributes() {
-	map = new HashMap();
-    }
-
-    public Attributes(Attributes attr) {
-	map = new HashMap(attr.map);
-    }
-
-    public Attributes(int size) {
-	map = new HashMap(size);
-    }
-    
-    public Object clone() {
-	return new Attributes(this); 
-    }
-
-    public Set entrySet() {
-	return map.entrySet();
-    }
-
-    public boolean equals(Object o) {
-	return map.equals(o);
-    }
-
-    public Object get(Object name) {
-	return map.get(name);
-    }
-
-    public String getValue(String name) {
-	return getValue(new Attributes.Name(name));
-    }
-
-    public String getValue(Attributes.Name name) {
-	return (String) get(name);
-    }
-
-    public int hashCode() {
-	return map.hashCode();
-    }
-
-    public Object put(Object name, Object value) {
-	return map.put((Attributes.Name)name, (String)value);
-    }
-
-    public String putValue(String name, String value) {
-	return (String)put(new Attributes.Name(name), value);
-    }
-
-    public Object remove(Object name) {
-	return map.remove(name);
-    }
-
-    public boolean containsValue(Object value) {
-	return map.containsValue(value);
-    }
-
-    public boolean containsKey(Object name) {
-	return map.containsKey(name);
-    }
-
-    public void putAll(Map attr) {
-	map.putAll((Attributes)attr);
-    }
-
-    public void clear() {
-	map.clear();
-    }
-
-    public int size() {
-	return map.size();
-    }
-
-    public boolean isEmpty() {
-	return map.isEmpty();
-    }
-
-    public Set keySet() {
-	return map.keySet();
-    }
-    
-    public Collection values() {
-	return map.values();
-    }
-
-    public static class Name {
-	private final String name;
-
-	public static final Name
-		MANIFEST_VERSION	= new Name("Manifest-Version");
-	public static final Name
-		SIGNATURE_VERSION	= new Name("Signature-Version");
-	public static final Name
-		CONTENT_TYPE		= new Name("Content-Type");
-	public static final Name
-		CLASS_PATH		= new Name("Class-Path");
-	public static final Name
-		MAIN_CLASS		= new Name("Main-Class");
-	public static final Name
-		SEALED			= new Name("Sealed");
-	public static final Name
-		IMPLEMENTATION_TITLE	= new Name("Implementation-Title");
-	public static final Name
-		IMPLEMENTATION_VERSION	= new Name("Implementation-Version");
-	public static final Name
-		IMPLEMENTATION_VENDOR	= new Name("Implementation-Vendor");
-	public static final Name
-		IMPLEMENTATION_VENDOR_ID= new Name("Implementation-Vendor-Id");
-	public static final Name
-		IMPLEMENTATION_VENDOR_URL=new Name("Implementation-Vendor-URL");
-	public static final Name
-		SPECIFICATION_TITLE	= new Name("Specification-Title");
-	public static final Name
-		SPECIFICATION_VERSION	= new Name("Specification-Version");
-	public static final Name
-		SPECIFICATION_VENDOR	= new Name("Specification-Vendor");
-	public static final Name
-		EXTENSION_LIST		= new Name("Extension-List");
-	public static final Name
-		EXTENSION_INSTALLATION	= new Name("Extension-Installation");
-
-	public Name(String name) {
-	    if (name.length() == 0) {
-	    	throw new IllegalArgumentException("empty attribute name");
-	    }
-	    for (int i = 0; i < name.length(); i++) {
-		char c = name.charAt(i);
-
-		if (!((c >= '0' && c <= '9') ||
-		      (c >= 'A' && c <= 'Z') ||
-		      (c >= 'a' && c <= 'z') ||
-		       c == '_' || c == '-' )) {
-		    throw new IllegalArgumentException("bogus attribute name: "
-			+ name);
-		}
-	    }
-	    this.name = name;
+/**
+ * Represents attribute name/value pairs from a Manifest as a Map.
+ * The names of an attribute are represented by the
+ * <code>Attributes.Name</code> class and should confirm to the restrictions
+ * described in that class. Note that the Map interface that Attributes
+ * implements allows you to put names and values into the attribute that don't
+ * follow these restriction (and are not really Atrribute.Names, but if you do
+ * that it might cause undefined behaviour later).
+ * <p>
+ * If you use the constants defined in the inner class Name then you can be
+ * sure that you always access the right attribute names. This makes
+ * manipulating the Attributes more or less type safe.
+ * <p>
+ * Most of the methods are wrappers to implement the Map interface. The really
+ * useful and often used methods are <code>getValue(Name)</code> and
+ * <code>getValue(String)</code>. If you actually want to set attributes you
+ * may want to use the <code>putValue(String, String)</code> method
+ * (sorry there is no public type safe <code>putValue(Name, String)</code>
+ * method).
+ *
+ * @see java.util.jar.Attributes.Name
+ * @author Mark Wielaard (mark@klomp.org)
+ */
+public class Attributes implements Cloneable, Map
+{
+
+  // Fields
+
+  /**
+   * The map that holds all the attribute name/value pairs. In this
+   * implementation it is actually a Hashtable, but that can be different in
+   * other implementations.
+   */
+  protected Map map;
+
+  // Inner class
+
+  /**
+   * Represents a name of a Manifest Attribute. Defines a couple of well
+   * know names for the general main attributes, stand alone application
+   * attributes, applet attributes, extension identification attributes,
+   * package versioning and sealing attributes, file contents attributes,
+   * bean objects attribute and signing attributes. See the 
+   * <p>
+   * The characters of a Name must obey the following restrictions:
+   * <ul>
+   * <li> Must contain at least one character
+   * <li> The first character must be alphanumeric (a-z, A-Z, 0-9)
+   * <li> All other characters must be alphanumeric, a '-' or a '_'
+   * </ul>
+   * <p>
+   * When comparing Names (with <code>equals</code>) all characters are
+   * converted to lowercase. But you can get the original case sensitive
+   * string with the <code>toString()</code> method.
+   *
+   * @since 1.2
+   * @author Mark Wielaard (mark@klomp.org)
+   */
+  public static class Name
+  {
+
+    // Fields
+
+    // General Main Attributes
+
+    /**
+     * General main attribute -
+     * the version of this Manifest file.
+     */
+    public static final Name MANIFEST_VERSION = new Name("Manifest-Version");
+    /**
+     * General main attribute -
+     * tool and version that created this Manifest file.
+     */
+    public static final Name CREATED_BY = new Name("Created-By");
+    /**
+     * General main attribute -
+     * the version of the jar file signature.
+     */
+    public static final Name SIGNATURE_VERSION
+      = new Name("Signature-Version");
+    /**
+     * General main attribute -
+     * (relative) URLs of the libraries/classpaths that the Classes in
+     * this jar file depend on.
+     */
+    public static final Name CLASS_PATH = new Name("Class-Path");
+
+    /**
+     * Stand alone application attribute -
+     * the entry (without the .class ending) that is the main
+     * class of this jar file.
+     */
+    public static final Name MAIN_CLASS = new Name("Main-Class");
+
+    /**
+     * Applet attribute -
+     * a list of extension libraries that the applet in this
+     * jar file depends on.
+     * For every named extension there should be some Attributes in the
+     * Manifest manifest file with the following Names:
+     * <ul>
+     * <li> &lt;extension&gt;-Extension-Name:
+     * unique name of the extension
+     * <li> &lt;extension&gt;-Specification-Version:
+     * minimum specification version
+     * <li> &lt;extension&gt;-Implementation-Version:
+     * minimum implementation version
+     * <li> &lt;extension&gt;-Implementation-Vendor-Id:
+     * unique id of implementation vendor
+     * <li> &lt;extension&gt;-Implementation-URL:
+     * where the latest version of the extension library can be found
+     * </ul>
+     */
+    public static final Name EXTENSION_LIST = new Name("Extension-List");
+
+    /**
+     * Extension identification attribute -
+     * the name if the extension library contained in the jar.
+     */
+    public static final Name EXTENSION_NAME = new Name("Extension-Name");
+    /**
+     * Extension identification attribute -
+     * synonym for <code>EXTENSTION_NAME</code>.
+     */
+    public static final Name EXTENSION_INSTALLATION = EXTENSION_NAME;
+
+    // Package versioning and sealing attributes
+    /**
+     * Package versioning -
+     * name of extension library contained in this jar.
+     */
+    public static final Name IMPLEMENTATION_TITLE
+      = new Name("Implementation-Title");
+    /**
+     * Package versioning -
+     * version of the extension library contained in this jar.
+     */
+    public static final Name IMPLEMENTATION_VERSION
+      = new Name("Implementation-Version");
+    /**
+     * Package versioning -
+     * name of extension library creator contained in this jar.
+     */
+    public static final Name IMPLEMENTATION_VENDOR
+      = new Name("Implementation-Vendor");
+    /**
+     * Package versioning -
+     * unique id of extension library creator.
+     */
+    public static final Name IMPLEMENTATION_VENDOR_ID
+      = new Name("Implementation-Vendor-Id");
+    /**
+     * Package versioning -
+     * location where this implementation can be downloaded.
+     */
+    public static final Name IMPLEMENTATION_URL
+      = new Name("Implementation-URL");
+    /**
+     * Package versioning -
+     * title of the specification contained in this jar.
+     */
+    public static final Name SPECIFICATION_TITLE
+      = new Name("Specification-Title");
+    /**
+     * Package versioning -
+     * version of the specification contained in this jar.
+     */
+    public static final Name SPECIFICATION_VERSION
+      = new Name("Specification-Version");
+    /**
+     * Package versioning -
+     * organisation that maintains the specification contains in this
+     * jar.
+     */
+    public static final Name SPECIFICATION_VENDOR
+      = new Name("Specification-Vendor");
+    /**
+     * Package sealing -
+     * whether (all) package(s) is(/are) sealed. Value is either "true"
+     * or "false".
+     */
+    public static final Name SEALED = new Name("Sealed");
+
+    /**
+     * File contents attribute -
+     * Mime type and subtype for the jar entry.
+     */
+    public static final Name CONTENT_TYPE = new Name("Content-Type");
+
+    /**
+     * Bean objects attribute -
+     * whether the entry is a Java Bean. Value is either "true" or "false".
+     */
+    public static final Name JAVA_BEAN = new Name("Java-Bean");
+
+    /**
+     * Signing attribute -
+     * application specific signing attribute. Must be understood by
+     * the manifest parser when present to validate the jar (entry).
+     */
+    public static final Name MAGIC = new Name("Magic");
+
+    /** The (lowercase) String representation of this Name */
+    private final String name;
+    /** The original String given to the constructor */
+    private final String origName;
+
+    // Constructor
+
+    /**
+     * Creates a new Name from the given String.
+     * Throws an IllegalArgumentException if the given String is empty or
+     * contains any illegal Name characters.
+     * 
+     * @param name the name of the new Name
+     * @exception IllegalArgumentException if name isn't a valid String
+     * representation of a Name
+     * @exception NullPointerException if name is null
+     */
+    public Name(String name) throws IllegalArgumentException,
+      NullPointerException
+    {
+      // name must not be null
+      // this will throw a NullPointerException if it is
+      char chars[] = name.toCharArray();
+
+      // there must be at least one character
+      if (chars.length == 0)
+	throw new
+	  IllegalArgumentException
+	  ("There must be at least one character in a name");
+
+      // first character must be alphanum
+      char c = chars[0];
+      if (!((c >= 'a' && c <= 'z') ||
+	    (c >= 'A' && c <= 'Z') || (c >= '0' && c <= '9')))
+	throw new
+	  IllegalArgumentException("First character must be alphanum");
+
+      // all other characters must be alphanums, '-' or '_'
+      for (int i = 1; i < chars.length; i++)
+	{
+	  c = chars[i];
+	  if (!((c >= 'a' && c <= 'z') ||
+		(c >= 'A' && c <= 'Z') ||
+		(c >= '0' && c <= '9') || (c == '-') || (c == '_')))
+	    throw new
+	      IllegalArgumentException
+	      ("Characters must be alphanums, '-' or '_'");
 	}
 
-	public boolean equals(Object o) {
-	    return ((o instanceof Name) &&
-		    name.equalsIgnoreCase(((Name)o).name));
+      // Still here? Then convert to lower case and be done.
+      // Store the original name for toString();
+      this.origName = name;
+      this.name = name.toLowerCase();
+    }
+
+    /**
+     * Returns the hash code of the (lowercase) String representation of
+     * this Name.
+     */
+    public int hashCode()
+    {
+      return name.hashCode();
+    }
+
+    /**
+     * Checks if another object is equal to this Name object.
+     * Another object is equal to this Name object if it is an instance of
+     * Name and the (lowercase) string representation of the name is equal.
+     */
+    public boolean equals(Object o)
+    {
+      // Quick and dirty check
+      if (name == o)
+	return true;
+
+      try
+	{
+	  // Note that the constructor already converts the strings to
+	  // lowercase.
+	  String otherName = ((Name) o).name;
+	  return name.equals(otherName);
 	}
-
-	public int hashCode() {
-	    return name.toUpperCase().hashCode();
+      catch (ClassCastException cce)
+	{
+	  return false;
 	}
-
-	public String toString() {
-	    return name;
+      catch (NullPointerException npe)
+	{
+	  return false;
 	}
     }
-}
 
+    /**
+     * Returns the string representation of this Name as given to the
+     * constructor (not neccesarily the lower case representation).
+     */
+    public String toString()
+    {
+      return origName;
+    }
+  }
+
+  // Constructors
+
+  /**
+   * Creates an empty Attributes map.
+   */
+  public Attributes()
+  {
+    map = new Hashtable();
+  }
+
+  /**
+   * Creates an empty Attributes map with the given initial size.
+   * @param size the initial size of the underlying map
+   */
+  public Attributes(int size)
+  {
+    map = new Hashtable(size);
+  }
+
+  /**
+   * Creates an Attributes map with the initial values taken from another
+   * Attributes map.
+   * @param attr Attributes map to take the initial values from
+   */
+  public Attributes(Attributes attr)
+  {
+    map = new Hashtable(attr.map);
+  }
+
+  // Methods
+
+  /**
+   * Gets the value of an attribute name given as a String.
+   *
+   * @param name a String describing the Name to look for
+   * @return the value gotten from the map of null when not found
+   */
+  public String getValue(String name)
+  {
+    return (String) get(new Name(name));
+  }
+
+  /**
+   * Gets the value of the given attribute name.
+   *
+   * @param name the Name to look for
+   * @return the value gotten from the map of null when not found
+   */
+  public String getValue(Name name)
+  {
+    return (String) get(name);
+  }
+
+  /**
+   * Stores an attribute name (represented by a String) and value in this
+   * Attributes map.
+   * When the (case insensitive string) name already exists the value is
+   * replaced and the old value is returned.
+   *
+   * @param name a (case insensitive) String representation of the attribite
+   * name to add/replace
+   * @param value the (new) value of the attribute name
+   * @returns the old value of the attribute name or null if it didn't exist
+   * yet
+   */
+  public String putValue(String name, String value)
+  {
+    return putValue(new Name(name), value);
+  }
+
+  /**
+   * Stores an attribute name (represented by a String) and value in this
+   * Attributes map.
+   * When the name already exists the value is replaced and the old value
+   * is returned.
+   * <p>
+   * I don't know why there is no public method with this signature. I think
+   * there should be one.
+   *
+   * @param name the attribite name to add/replace
+   * @param value the (new) value of the attribute name
+   * @returns the old value of the attribute name or null if it didn't exist
+   * yet
+   */
+  String putValue(Name name, String value)
+  {
+    return (String) put(name, value);
+  }
+
+  // Methods from Cloneable interface
+
+  /**
+   * Return a clone of this attribute map.
+   */
+  public Object clone()
+  {
+    return new Attributes(this);
+  }
+
+  // Methods from Map interface
+
+  /**
+   * Removes all attributes.
+   */
+  public void clear()
+  {
+    map.clear();
+  }
+
+  /**
+   * Checks to see if there is an attribute with the specified name.
+   * XXX - what if the object is a String?
+   *
+   * @param attrName the name of the attribute to check
+   * @return true if there is an attribute with the specified name, false
+   * otherwise
+   */
+  public boolean containsKey(Object attrName)
+  {
+    return map.containsKey(attrName);
+  }
+
+  /**
+   * Checks to see if there is an attribute name with the specified value.
+   *
+   * @param attrValue the value of a attribute to check
+   * @return true if there is an attribute name with the specified value,
+   * false otherwise
+   */
+  public boolean containsValue(Object attrValue)
+  {
+    return map.containsValue(attrValue);
+  }
+
+  /**
+   * Gives a Set of attribute name and values pairs as MapEntries.
+   * @see java.util.Map.Entry
+   * @see java.util.Map#entrySet()
+   *
+   * @return a set of attribute name value pairs
+   */
+  public Set entrySet()
+  {
+    return map.entrySet();
+  }
+
+  /**
+   * Checks to see if two Attributes are equal. The supplied object must be
+   * a real instance of Attributes and contain the same attribute name/value
+   * pairs.
+   *
+   * @param o another Attribute object which should be checked for equality
+   * @return true if the object is an instance of Attributes and contains the
+   * same name/value pairs, false otherwise
+   */
+  public boolean equals(Object o)
+  {
+    // quick and dirty check
+    if (this == o)
+      return true;
+
+    try
+      {
+	return map.equals(((Attributes) o).map);
+      }
+    catch (ClassCastException cce)
+      {
+	return false;
+      }
+    catch (NullPointerException npe)
+      {
+	return false;
+      }
+  }
+
+  /**
+   * Gets the value of a specified attribute name.
+   * XXX - what if the object is a String?
+   *
+   * @param attrName the name of the attribute we want the value of
+   * @return the value of the specified attribute name or null when there is
+   * no such attribute name
+   */
+  public Object get(Object attrName)
+  {
+    return map.get(attrName);
+  }
+
+  /**
+   * Returns the hashcode of the attribute name/value map.
+   */
+  public int hashCode()
+  {
+    return map.hashCode();
+  }
+
+  /**
+   * Returns true if there are no attributes set, false otherwise.
+   */
+  public boolean isEmpty()
+  {
+    return map.isEmpty();
+  }
+
+  /**
+   * Gives a Set of all the values of defined attribute names.
+   */
+  public Set keySet()
+  {
+    return map.keySet();
+  }
+
+  /**
+   * Adds or replaces a attribute name/value pair.
+   * XXX - What if the name is a string? What if the name is neither a Name
+   * nor a String? What if the value is not a string?
+   *
+   * @param name the name of the attribute
+   * @param value the (new) value of the attribute
+   * @return the old value of the attribute or null when there was no old
+   * attribute with this name
+   */
+  public Object put(Object name, Object value)
+  {
+    return map.put(name, value);
+  }
+
+  /**
+   * Adds or replaces all attribute name/value pairs from another
+   * Attributes object to this one. The supplied Map must be an instance of
+   * Attributes.
+   *
+   * @param attr the Attributes object to merge with this one
+   * @exception ClassCastException if the supplied map is not an instance of
+   * Attributes
+   */
+  public void putAll(Map attr)
+  {
+    if (!(attr instanceof Attributes))
+      {
+	throw new
+	  ClassCastException("Supplied Map is not an instance of Attributes");
+      }
+    map.putAll(attr);
+  }
+
+  /**
+   * Remove a attribute name/value pair.
+   * XXX - What if the name is a String?
+   *
+   * @param name the name of the attribute name/value pair to remove
+   * @return the old value of the attribute or null if the attribute didn't
+   * exist
+   */
+  public Object remove(Object name)
+  {
+    return map.remove(name);
+  }
+
+  /**
+   * Returns the number of defined attribute name/value pairs.
+   */
+  public int size()
+  {
+    return map.size();
+  }
+
+  /**
+   * Returns all the values of the defined attribute name/value pairs as a
+   * Collection.
+   */
+  public Collection values()
+  {
+    return map.values();
+  }
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/jar/JarEntry.java kaffe/libraries/javalib/java/util/jar/JarEntry.java
--- kaffe_orig/libraries/javalib/java/util/jar/JarEntry.java	2003-09-26 14:19:40.000000000 +1200
+++ kaffe/libraries/javalib/java/util/jar/JarEntry.java	2003-09-27 23:01:30.000000000 +1200
@@ -1,52 +1,165 @@
+/* JarEntry.java - Represents an entry in a jar file
+   Copyright (C) 2000 Free Software Foundation, Inc.
 
-/*
- * Java core library component.
- *
- * Copyright (c) 1999
- *	Archie L. Cobbs.  All rights reserved.
- * Copyright (c) 1999
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- *
- * Author: Archie L. Cobbs <archie@whistle.com>
- */
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.jar;
 
 import java.io.IOException;
-import java.util.zip.ZipEntry;
 import java.security.cert.Certificate;
+import java.util.zip.ZipEntry;
 
-public class JarEntry extends ZipEntry {
-	private final Attributes attr;
+/**
+ * Extension to a ZipEntry that contains manifest attributes and certificates.
+ * Both the Atrributes and the Certificates can be null when not set.
+ * Note that the <code>getCertificates()</code> method only returns a
+ * valid value after all of the data of the entry has been read.
+ * <p>
+ * There are no public methods to set the attributes or certificate of an
+ * Entru. Only JarEntries created by the classes in <code>java.util.jar</code>
+ * will have these properties set.
+ *
+ * @since 1.2
+ * @author Mark Wielaard (mark@klomp.org)
+ */
 
-	public JarEntry(String name) {
-		super(name);
-		attr = null;
-	}
-
-	public JarEntry(ZipEntry ze) {
-		super(ze);
-		attr = null;
-	}
-
-	public JarEntry(JarEntry je) {
-		super(je);
-		attr = je.attr;		// XXX	(Attributes)je.attr.clone();
-	}
-
-	JarEntry(ZipEntry ze, Attributes attr) {
-		super(ze);
-		this.attr = attr;	// XXX  (Attributes)attr.clone();
-	}
-
-	public Attributes getAttributes() throws IOException {
-		return attr;
-	}
-
-	public Certificate[] getCertificates() {
-		return null;
-	}
+public class JarEntry extends ZipEntry
+{
+  // (Package local) fields
+
+  Attributes attr;
+  Certificate certs[];
+
+  // Constructors
+
+  /**
+   * Creates a new JarEntry with the specified name and no attributes or
+   * or certificates. Calls <code>super(name)</code> so all other (zip)entry
+   * fields are null or -1.
+   *
+   * @param name the name of the new jar entry
+   * @exception NullPointerException when the supplied name is null
+   * @exception IllegalArgumentException when the supplied name is longer
+   * than 65535 bytes
+   */
+  public JarEntry(String name) throws NullPointerException,
+    IllegalArgumentException
+  {
+    super(name);
+    attr = null;
+    certs = null;
+  }
+
+  /**
+   * Creates a new JarEntry with the specified ZipEntry as template for
+   * all properties of the entry. Both attributes and certificates will be
+   * null.
+   *
+   * @param entry the ZipEntry whose fields should be copied
+   */
+  public JarEntry(ZipEntry entry)
+  {
+    super(entry);
+    attr = null;
+    certs = null;
+  }
+
+  /**
+   * Creates a new JarEntry with the specified JarEntry as template for
+   * all properties of the entry.
+   *
+   * @param entry the jarEntry whose fields should be copied
+   */
+  public JarEntry(JarEntry entry)
+  {
+    super(entry);
+    try
+      {
+	attr = entry.getAttributes();
+      }
+    catch (IOException _)
+      {
+      }
+    certs = entry.getCertificates();
+  }
+
+  // Methods
+
+  /**
+   * Returns a copy of the Attributes set for this entry.
+   * When no Attributes are set in the manifest null is returned.
+   *
+   * @return a copy of the Attributes set for this entry
+   * @exception IOException This will never be thrown. It is here for
+   * binary compatibility.
+   */
+  public Attributes getAttributes() throws IOException
+  {
+    if (attr != null)
+      {
+	return (Attributes) attr.clone();
+      }
+    else
+      {
+	return null;
+      }
+  }
+
+  /**
+   * Returns a copy of the certificates set for this entry.
+   * When no certificates are set or when not all data of this entry has
+   * been read null is returned.
+   * <p>
+   * To make sure that this call returns a valid value you must read all
+   * data from the JarInputStream for this entry.
+   * When you don't need the data for an entry but want to know the
+   * certificates that are set for the entry then you can skip all data by
+   * calling <code>skip(entry.getSize())</code> on the JarInputStream for
+   * the entry.
+   *
+   * @return a copy of the certificates set for this entry
+   */
+  public Certificate[] getCertificates()
+  {
+    if (certs != null)
+      {
+	return (Certificate[])certs.clone();
+      }
+    else
+      {
+	return null;
+      }
+  }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/jar/JarFile.java kaffe/libraries/javalib/java/util/jar/JarFile.java
--- kaffe_orig/libraries/javalib/java/util/jar/JarFile.java	2003-09-26 14:19:40.000000000 +1200
+++ kaffe/libraries/javalib/java/util/jar/JarFile.java	2003-09-27 23:01:30.000000000 +1200
@@ -1,106 +1,352 @@
+/* JarFile.java - Representation of a jar file
+   Copyright (C) 2000, 2003 Free Software Foundation, Inc.
 
-/*
- * Java core library component.
- *
- * Copyright (c) 1999
- *	Archie L. Cobbs.  All rights reserved.
- * Copyright (c) 1999
- *	Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- *
- * Author: Archie L. Cobbs <archie@whistle.com>
- */
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.jar;
 
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipException;
+import java.util.zip.ZipFile;
 import java.io.File;
-import java.io.IOException;
+import java.io.FileNotFoundException;
 import java.io.InputStream;
+import java.io.IOException;
 import java.util.Enumeration;
-import java.util.zip.ZipEntry;
-import java.util.zip.ZipFile;
-
-public class JarFile extends ZipFile {
-	public static final String MANIFEST_NAME = "META-INF/MANIFEST.MF";
-	private Manifest manifest;
-
-	public JarFile(String name) throws IOException {
-		this(name, true);
-	}
-
-	public JarFile(String name, boolean verify) throws IOException {
-		super(name);
-		if (verify) {
-			verifyIfSigned();
-		}
-	}
-
-	public JarFile(File file) throws IOException {
-		this(file, true);
-	}
-
-	public JarFile(File file, boolean verify) throws IOException {
-		super(file);
-		if (verify) {
-			verifyIfSigned();
-		}
-	}
-
-	private void verifyIfSigned() throws JarException {
-		// XXX FIXME: verify the JAR file if it's signed
-	}
 
-	public Manifest getManifest() throws IOException {
-		if (manifest == null) {
-			ZipEntry me = getEntry(MANIFEST_NAME);
-			if (me != null) {
-				manifest = new Manifest(getInputStream(me));
-			}
-		}
-		return manifest;
-	}
-
-	public JarEntry getJarEntry(String name) {
-		ZipEntry ze = getEntry(name);
-		if (ze == null) {
-			return null;
-		}
-		Attributes attr = null;
-		try {
-			Manifest manifest = getManifest();
-			if (manifest != null) {
-				attr = getManifest().getAttributes(name);
-			}
-		} catch (IOException e) {
-		}
-		return new JarEntry(ze, attr);
+/**
+ * Representation of a jar file.
+ * <p>
+ * Note that this class is not a subclass of java.io.File but a subclass of
+ * java.util.zip.ZipFile and you can only read JarFiles with it (although
+ * there are constructors that take a File object).
+ * <p>
+ * XXX - verification of Manifest signatures is not yet implemented.
+ *
+ * @since 1.2
+ * @author Mark Wielaard (mark@klomp.org)
+ */
+public class JarFile extends ZipFile
+{
+  // Fields
+
+  /** The name of the manifest entry: META-INF/MANIFEST.MF */
+  public static final String MANIFEST_NAME = "META-INF/MANIFEST.MF";
+
+  /**
+   * The manifest of this file, if any, otherwise null.
+   * Read when first needed.
+   */
+  private Manifest manifest;
+
+  /** Whether to verify the manifest and all entries. */
+  private boolean verify;
+
+  /** Whether the has already been loaded. */
+  private boolean manifestRead = false;
+
+  // Constructors
+
+  /**
+   * Creates a new JarFile. All jar entries are verified (when a Manifest file
+   * for this JarFile exists). You need to actually open and read the complete
+   * jar entry (with <code>getInputStream()</code>) to check its signature.
+   *
+   * @param fileName the name of the file to open
+   * @exception FileNotFoundException if the fileName cannot be found
+   * @exception IOException if another IO exception occurs while reading
+   */
+  public JarFile(String fileName) throws FileNotFoundException, IOException
+  {
+    this(fileName, true);
+  }
+
+  /**
+   * Creates a new JarFile. If verify is true then all jar entries are
+   * verified (when a Manifest file for this JarFile exists). You need to
+   * actually open and read the complete jar entry
+   * (with <code>getInputStream()</code>) to check its signature.
+   *
+   * @param fileName the name of the file to open
+   * @param verify checks manifest and entries when true and a manifest
+   * exists, when false no checks are made
+   * @exception FileNotFoundException if the fileName cannot be found
+   * @exception IOException if another IO exception occurs while reading
+   */
+  public JarFile(String fileName, boolean verify) throws
+    FileNotFoundException, IOException
+  {
+    super(fileName);
+    if (verify)
+      {
+	manifest = readManifest();
+	verify();
+      }
+  }
+
+  /**
+   * Creates a new JarFile. All jar entries are verified (when a Manifest file
+   * for this JarFile exists). You need to actually open and read the complete
+   * jar entry (with <code>getInputStream()</code>) to check its signature.
+   *
+   * @param file the file to open as a jar file
+   * @exception FileNotFoundException if the file does not exits
+   * @exception IOException if another IO exception occurs while reading
+   */
+  public JarFile(File file) throws FileNotFoundException, IOException
+  {
+    this(file, true);
+  }
+
+  /**
+   * Creates a new JarFile. If verify is true then all jar entries are
+   * verified (when a Manifest file for this JarFile exists). You need to
+   * actually open and read the complete jar entry
+   * (with <code>getInputStream()</code>) to check its signature.
+   *
+   * @param file the file to open to open as a jar file
+   * @param verify checks manifest and entries when true and a manifest
+   * exists, when false no checks are made
+   * @exception FileNotFoundException if file does not exist
+   * @exception IOException if another IO exception occurs while reading
+   */
+  public JarFile(File file, boolean verify) throws FileNotFoundException,
+    IOException
+  {
+    super(file);
+    if (verify)
+      {
+	manifest = readManifest();
+	verify();
+      }
+  }
+
+  /**
+   * Creates a new JarFile with the indicated mode. If verify is true then
+   * all jar entries are verified (when a Manifest file for this JarFile
+   * exists). You need to actually open and read the complete jar entry
+   * (with <code>getInputStream()</code>) to check its signature.
+   * manifest and if the manifest exists and verify is true verfies it.
+   *
+   * @param file the file to open to open as a jar file
+   * @param verify checks manifest and entries when true and a manifest
+   * exists, when false no checks are made
+   * @param mode either ZipFile.OPEN_READ or
+   *             (ZipFile.OPEN_READ | ZipFile.OPEN_DELETE)
+   * @exception FileNotFoundException if the file does not exist
+   * @exception IOException if another IO exception occurs while reading
+   * @exception IllegalArgumentException when given an illegal mode
+   * 
+   * @since 1.3
+   */
+  public JarFile(File file, boolean verify, int mode) throws
+    FileNotFoundException, IOException, IllegalArgumentException
+  {
+    super(file, mode);
+    if (verify)
+      {
+	manifest = readManifest();
+	verify();
+      }
+  }
+
+  // Methods
+
+  /**
+   * XXX - should verify the manifest file
+   */
+  private void verify()
+  {
+    // only check if manifest is not null
+    if (manifest == null)
+      {
+	verify = false;
+	return;
+      }
+
+    verify = true;
+    // XXX - verify manifest
+  }
+
+  /**
+   * Parses and returns the manifest if it exists, otherwise returns null.
+   */
+  private Manifest readManifest()
+  {
+    try
+      {
+	ZipEntry manEntry = super.getEntry(MANIFEST_NAME);
+	if (manEntry != null)
+	  {
+	    InputStream in = super.getInputStream(manEntry);
+	    manifestRead = true;
+	    return new Manifest(in);
+	  }
+	else
+	  {
+	    manifestRead = true;
+	    return null;
+	  }
+      }
+    catch (IOException ioe)
+      {
+	manifestRead = true;
+	return null;
+      }
+  }
+
+  /**
+   * Returns a enumeration of all the entries in the JarFile.
+   * Note that also the Jar META-INF entries are returned.
+   *
+   * @exception IllegalStateException when the JarFile is already closed
+   */
+  public Enumeration entries() throws IllegalStateException
+  {
+    return new JarEnumeration(super.entries());
+  }
+
+  /**
+   * Wraps a given Zip Entries Enumeration. For every zip entry a
+   * JarEntry is created and the corresponding Attributes are looked up.
+   * XXX - Should also look up the certificates.
+   */
+  private class JarEnumeration implements Enumeration
+  {
+
+    private final Enumeration entries;
+
+    JarEnumeration(Enumeration e)
+    {
+      entries = e;
+    }
+
+    public boolean hasMoreElements()
+    {
+      return entries.hasMoreElements();
+    }
+
+    public Object nextElement()
+    {
+      ZipEntry zip = (ZipEntry) entries.nextElement();
+      JarEntry jar = new JarEntry(zip);
+      Manifest manifest;
+      try
+	{
+	  manifest = getManifest();
 	}
-
-	public ZipEntry getEntry(String name) {
-		// XXX not sure why this method is overridden
-		return super.getEntry(name);
+      catch (IOException ioe)
+	{
+	  manifest = null;
 	}
 
-	public Enumeration entries() {
-		final Enumeration ents = super.entries();
-		return new Enumeration() {
-			public boolean hasMoreElements() {
-				return ents.hasMoreElements();
-			}
-			public Object nextElement() {
-				ZipEntry ze = (ZipEntry)ents.nextElement();
-				return getJarEntry(ze.getName());
-			}
-		};
+      if (manifest != null)
+	{
+	  jar.attr = manifest.getAttributes(jar.getName());
 	}
+      // XXX jar.certs
+      return jar;
+    }
+  }
+
+  /**
+   * XXX
+   * It actually returns a JarEntry not a zipEntry
+   * @param name XXX
+   */
+  public ZipEntry getEntry(String name)
+  {
+    ZipEntry entry = super.getEntry(name);
+    if (entry != null)
+      {
+	JarEntry jarEntry = new JarEntry(entry);
+	Manifest manifest;
+	try
+	  {
+	    manifest = getManifest();
+	  }
+	catch (IOException ioe)
+	  {
+	    manifest = null;
+	  }
+
+	if (manifest != null)
+	  {
+	    jarEntry.attr = manifest.getAttributes(name);
+	    // XXX jarEntry.certs
+	  }
+	return jarEntry;
+      }
+    return null;
+  }
+
+  /**
+   * XXX should verify the inputstream
+   * @param entry XXX
+   * @exception ZipException XXX
+   * @exception IOException XXX
+   */
+  public synchronized InputStream getInputStream(ZipEntry entry) throws
+    ZipException, IOException
+  {
+    return super.getInputStream(entry);	// XXX verify
+  }
+
+  /**
+   * Returns the JarEntry that belongs to the name if such an entry
+   * exists in the JarFile. Returns null otherwise
+   * Convenience method that just casts the result from <code>getEntry</code>
+   * to a JarEntry.
+   *
+   * @param name the jar entry name to look up
+   * @return the JarEntry if it exists, null otherwise
+   */
+  public JarEntry getJarEntry(String name)
+  {
+    return (JarEntry) getEntry(name);
+  }
+
+  /**
+   * Returns the manifest for this JarFile or null when the JarFile does not
+   * contain a manifest file.
+   */
+  public Manifest getManifest() throws IOException
+  {
+    if (!manifestRead)
+      manifest = readManifest();
 
-	public InputStream getInputStream(ZipEntry ze) throws IOException {
-		// XXX not sure why this method is overridden
-		//     maybe so the hash can be verified?
-		return super.getInputStream(ze);
-	}
+    return manifest;
+  }
 }
-
-
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/jar/JarInputStream.java kaffe/libraries/javalib/java/util/jar/JarInputStream.java
--- kaffe_orig/libraries/javalib/java/util/jar/JarInputStream.java	2003-09-26 14:19:40.000000000 +1200
+++ kaffe/libraries/javalib/java/util/jar/JarInputStream.java	2003-09-27 23:01:30.000000000 +1200
@@ -1,17 +1,39 @@
+/* JarInputStream.java - InputStream for reading jar files
+   Copyright (C) 2000 Free Software Foundation, Inc.
 
-/*
- * Java core library component.
- *
- * Copyright (c) 1999
- *	Archie L. Cobbs.  All rights reserved.
- * Copyright (c) 1999
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- *
- * Author: Archie L. Cobbs <archie@whistle.com>
- */
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.jar;
 
@@ -20,67 +42,160 @@
 import java.util.zip.ZipEntry;
 import java.util.zip.ZipInputStream;
 
-public class JarInputStream extends ZipInputStream {
-	private final Manifest manifest;
-	private boolean gotNext;
-	private ZipEntry next;
-
-	public JarInputStream(InputStream in) throws IOException {
-		this(in, true);
-	}
-
-	public JarInputStream(InputStream in, boolean vfy) throws IOException {
-		super(in);
-
-		// Try to read manifest, which must be first
-		next = super.getNextEntry();
-		if (next.getName().equals(JarFile.MANIFEST_NAME)) {
-			// Note: it is important that Manifest(this) doesn't
-			//   call the close() method of this.
-			manifest = new Manifest(this);
-			closeEntry();
-			if (vfy) {
-				verifyIfSigned();
-			}
-		} else {
-			manifest = null;
-			gotNext = true;
-		}
-	}
-
-	private void verifyIfSigned() throws JarException {
-		// XXX FIXME: verify the JAR file if it's signed
-		//   this probably means storing it in a temp file
-	}
-
-	public Manifest getManifest() {
-		return manifest;
-	}
-
-	public ZipEntry getNextEntry() throws IOException {
-		return getNextJarEntry();
-	}
-
-	public JarEntry getNextJarEntry() throws IOException {
-		if (gotNext) {
-			gotNext = false;
-		} else {
-			next = super.getNextEntry();
-		}
-		if (next == null) {
-			return null;
-		}
-		return new JarEntry(next, manifest == null ? null :
-		    manifest.getAttributes(next.getName()));
-	}
-
-	public int read(byte[] b, int off, int len) throws IOException {
-		return super.read(b, off, len);
-	}
-
-	protected ZipEntry createZipEntry(String name) {
-		// XXX why is this overridden?
-		return super.createZipEntry(name);
-	}
-}
+/**
+ * InputStream for reading jar files.
+ * XXX - verification of the signatures in the Manifest file is not yet
+ * implemented.
+ *
+ * @since 1.2
+ * @author Mark Wielaard (mark@klomp.org)
+ */
 
+public class JarInputStream extends ZipInputStream
+{
+  // Fields
+
+  /** The manifest for this file or null when there was no manifest. */
+  private Manifest manifest;
+
+  /** The first real JarEntry for this file. Used by readManifest() to store
+     an entry that isn't the manifest but that should be returned by
+     getNextEntry next time it is called. Null when no firstEntry was read
+     while searching for the manifest entry, or when it has already been
+     returned by getNextEntry(). */
+  private JarEntry firstEntry;
+
+  // Constructors
+
+  /**
+   * Creates a new JarInputStream and tries to read the manifest.
+   * If such a manifest is present the JarInputStream tries to verify all
+   * the entry signatures while reading.
+   *
+   * @param in InputStream to read the jar from
+   * @exception IOException when an error occurs when opening or reading
+   */
+  public JarInputStream(InputStream in) throws IOException
+  {
+    this(in, true);
+  }
+
+  /**
+   * Creates a new JarInputStream and tries to read the manifest.
+   * If such a manifest is present and verify is true, the JarInputStream
+   * tries to verify all the entry signatures while reading.
+   *
+   * @param in InputStream to read the jar from
+   * @param verify whether or not to verify the manifest entries
+   * @exception IOException when an error occurs when opening or reading
+   */
+  public JarInputStream(InputStream in, boolean verify) throws IOException
+  {
+    super(in);
+    readManifest(verify);
+  }
+
+  // Methods
+
+  /**
+   * Set the manifest if found. Skips all entries that start with "META-INF/"
+   *
+   * @param verify when true (and a Manifest is found) checks the Manifest,
+   * when false no check is performed
+   * @exception IOException if an error occurs while reading
+   */
+  private void readManifest(boolean verify) throws IOException
+  {
+    firstEntry = (JarEntry) super.getNextEntry();
+    while ((firstEntry != null) &&
+	   firstEntry.getName().startsWith("META-INF/"))
+      {
+	if (firstEntry.getName().equals(JarFile.MANIFEST_NAME))
+	  {
+	    manifest = new Manifest(this);
+	  }
+	firstEntry = (JarEntry) super.getNextEntry();
+      }
+    closeEntry();
+
+    if (verify)
+      {
+	// XXX
+      }
+  }
+
+  /**
+   * Creates a JarEntry for a particular name and consults the manifest
+   * for the Attributes of the entry.
+   * Used by <code>ZipEntry.getNextEntry()</code>
+   *
+   * @param name the name of the new entry
+   */
+  protected ZipEntry createZipEntry(String name)
+  {
+    ZipEntry zipEntry = super.createZipEntry(name);
+    JarEntry jarEntry = new JarEntry(zipEntry);
+    if (manifest != null)
+      {
+	jarEntry.attr = manifest.getAttributes(name);
+      }
+    return jarEntry;
+  }
+
+  /**
+   * Returns the Manifest for the jar file or null if there was no Manifest.
+   */
+  public Manifest getManifest()
+  {
+    return manifest;
+  }
+
+  /**
+   * Returns the next entry or null when there are no more entries.
+   * Does actually return a JarEntry, if you don't want to cast it yourself
+   * use <code>getNextJarEntry()</code>. Does not return any entries found
+   * at the beginning of the ZipFile that are special
+   * (those that start with "META-INF/").
+   *
+   * @exception IOException if an IO error occurs when reading the entry
+   */
+  public ZipEntry getNextEntry() throws IOException
+  {
+    ZipEntry entry;
+    if (firstEntry != null)
+      {
+	entry = firstEntry;
+	firstEntry = null;
+      }
+    else
+      {
+	entry = super.getNextEntry();
+      }
+    return entry;
+  }
+
+  /**
+   * Returns the next jar entry or null when there are no more entries.
+   *
+   * @exception IOException if an IO error occurs when reading the entry
+   */
+  public JarEntry getNextJarEntry() throws IOException
+  {
+    return (JarEntry) getNextEntry();
+  }
+
+  /**
+   * XXX
+   *
+   * @param buf XXX
+   * @param off XXX
+   * @param len XXX
+   * @return XXX
+   * @exception IOException XXX
+   */
+  public int read(byte[]buf, int off, int len) throws IOException
+  {
+    // XXX if (verify) {}
+    return super.read(buf, off, len);
+  }
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/jar/JarOutputStream.java kaffe/libraries/javalib/java/util/jar/JarOutputStream.java
--- kaffe_orig/libraries/javalib/java/util/jar/JarOutputStream.java	2003-09-26 14:19:40.000000000 +1200
+++ kaffe/libraries/javalib/java/util/jar/JarOutputStream.java	2003-09-27 23:01:30.000000000 +1200
@@ -1,54 +1,113 @@
-/* Class : JarOutputStream
+/* JarOutputStream.java - OutputStream for writing jar files
+   Copyright (C) 2000 Free Software Foundation, Inc.
 
-  Implementation of the 1.2 Java class JarOutputStream.
+This file is part of GNU Classpath.
 
-  Copyright : Moses DeJong, dejong@cs.umn.edu, 1998.
-  Source code licensed under the GPL.
-  You can get a copy of the license from www.gnu.org.
-
-  This code is intended for use in the Kaffe project but you can use
-  it in other projects as long as you follow the license rules.
-*/
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.jar;
 
-import java.io.IOException;
 import java.io.OutputStream;
+import java.io.IOException;
 import java.util.zip.ZipEntry;
 import java.util.zip.ZipOutputStream;
 
-public class JarOutputStream extends ZipOutputStream {
-
-    	public JarOutputStream(OutputStream out, Manifest manifest)
-			throws IOException {
-		super(out);
-		if (manifest == null) {
-			return;
-		}
-		JarEntry ent = new JarEntry(JarFile.MANIFEST_NAME);
-		putNextEntry(ent);
-		manifest.write(new OutputStream() {
-			public void write(int b) throws IOException {
-				JarOutputStream.this.write(b);
-			}
-			public void write(byte[] buf, int off, int len)
-					throws IOException {
-				JarOutputStream.this.write(buf, off, len);
-			}
-			public void flush() throws IOException {
-				JarOutputStream.this.flush();
-			}
-		});
-		closeEntry();
-	}
-
-	public JarOutputStream(OutputStream out) throws IOException {
-		super(out);
-	}
-
-	// Why is this method here?
-	public void putNextEntry(ZipEntry ze) throws IOException {
-		super.putNextEntry(ze);
-	}
+/**
+ * OutputStream for writing jar files.
+ * A special ZipOutputStream that can take JarEntries and can have a optional
+ * Manifest as first entry.
+ *
+ * @author Mark Wielaard (mark@klomp.org)
+ */
+
+public class JarOutputStream extends ZipOutputStream
+{
+  // Constructors
+
+  /**
+   * Creates a new JarOutputStream without a manifest entry.
+   *
+   * @param out the stream to create the new jar on
+   * @exception IOException if something unexpected happend
+   */
+  public JarOutputStream(OutputStream out) throws IOException
+  {
+    this(out, null);
+  }
+
+  /**
+   * Creates a new JarOutputStream with a manifest entry.
+   * The manifest will be the first entry in the jar.
+   *
+   * @param out the stream to create the new jar on
+   * @param man the manifest that should be put in the jar file or null
+   * for no manifest entry
+   * @exception IOException if something unexpected happend
+   */
+  public JarOutputStream(OutputStream out, Manifest man) throws IOException
+  {
+    super(out);
+    if (man != null)
+      writeManifest(man);
+  }
+
+  // Methods
+
+  /**
+   * Writes the manifest to a new JarEntry in this JarOutputStream with as
+   * name JarFile.MANIFEST_NAME.
+   *
+   * @param manifest the non null manifest to be written
+   * @exception IOException if something unexpected happend
+   */
+  private void writeManifest(Manifest manifest) throws IOException
+  {
+    // Create a new Jar Entry for the Manifest
+    JarEntry entry = new JarEntry(JarFile.MANIFEST_NAME);
+    putNextEntry(entry);
+    manifest.write(this);
+    closeEntry();
+  }
+
+  /**
+   * Prepares the JarOutputStream for writing the next entry. 
+   * This implementation just calls <code>super.putNextEntre()</code>.
+   *
+   * @param entry The information for the next entry
+   * @exception IOException when some unexpected I/O exception occurred
+   */
+  public void putNextEntry(ZipEntry entry) throws IOException
+  {
+    super.putNextEntry(entry);	// XXX
+  }
 }
-
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/jar/Manifest.java kaffe/libraries/javalib/java/util/jar/Manifest.java
--- kaffe_orig/libraries/javalib/java/util/jar/Manifest.java	2003-09-26 14:19:40.000000000 +1200
+++ kaffe/libraries/javalib/java/util/jar/Manifest.java	2003-09-27 23:01:30.000000000 +1200
@@ -1,285 +1,475 @@
+/* Attributes.java -- Reads, writes and manipulaties jar manifest files
+   Copyright (C) 2000 Free Software Foundation, Inc.
 
-/*
- * Java core library component.
- *
- * Copyright (c) 1999
- *	Archie L. Cobbs.  All rights reserved.
- * Copyright (c) 1999
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- *
- * Author: Archie L. Cobbs <archie@whistle.com>
- */
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.jar;
 
 import java.io.BufferedReader;
 import java.io.BufferedWriter;
-import java.io.EOFException;
+import java.io.IOException;
 import java.io.InputStream;
 import java.io.InputStreamReader;
-import java.io.IOException;
 import java.io.OutputStream;
 import java.io.OutputStreamWriter;
 import java.io.PrintWriter;
-import java.io.PushbackReader;
-import java.util.HashMap;
+import java.io.Reader;
+import java.io.Writer;
+import java.util.Hashtable;
 import java.util.Iterator;
 import java.util.Map;
+import java.util.Set;
 
-public class Manifest implements Cloneable {
-	private static final Attributes.Name NAME = new Attributes.Name("Name");
-	private static final String MANIFEST_ENCODING = "8859_1";
-
-	private Attributes main;	// main manifest attributes
-	private HashMap ents;		// per-entry attributes
-
-	public Manifest() {
-		main = new Attributes();
-		ents = new HashMap();
-	}
-
-	public Manifest(InputStream in) throws IOException {
-		main = new Attributes();
-		ents = new HashMap();
-		read(in, false);
-	}
-
-	public Manifest(Manifest man) {
-		main = (Attributes)man.main.clone();
-		ents = (HashMap)man.ents.clone();
-	}
-
-	public Attributes getMainAttributes() {
-		return main;
-	}
-
-	public Map getEntries() {
-		return ents;
-	}
-
-	public Attributes getAttributes(String name) {
-		return (Attributes)getEntries().get(name);
-	}
-
-	public void clear() {
-		main.clear();
-		ents.clear();
-	}
-
-	public void write(OutputStream outstream) throws IOException {
-		PrintWriter out = new PrintWriter(new BufferedWriter(
-		    new OutputStreamWriter(outstream, MANIFEST_ENCODING)));
-
-		// Manifest-Version is mandatory and should always be first
-		String mver = main.getValue(Attributes.Name.MANIFEST_VERSION);
-		if (mver == null) {
-			mver = "1.0";
-		}
-		out.println(Attributes.Name.MANIFEST_VERSION + ": " + mver);
-
-		// Do remaining manifest attributes
-		writeAttributes(out, main, Attributes.Name.MANIFEST_VERSION);
-		out.println();
-
-		// Do per-entry attributes, ``Name: '' header first
-		for (Iterator i = ents.entrySet().iterator(); i.hasNext(); ) {
-			Map.Entry e = (Map.Entry)i.next();
-			Attributes attr = (Attributes)e.getValue();
-
-			out.println("Name: " + attr.getValue(NAME));
-			writeAttributes(out, attr, NAME);
-			out.println();
-		}
-		out.flush();
-	}
-
-	private void writeAttributes(PrintWriter out,
-			Attributes attr, Attributes.Name avoid) {
-		for (Iterator i = attr.entrySet().iterator(); i.hasNext(); ) {
-			Map.Entry e = (Map.Entry)i.next();
-			Attributes.Name name = (Attributes.Name)e.getKey();
-			String value = (String)e.getValue();
-
-			if (name.equals(avoid)) {
-				continue;
-			}
-			out.println(name + ": " + value);
-		}
-	}
-
-	public void read(InputStream in) throws IOException {
-		read(in, true);
-	}
-
-	private void read(InputStream in, boolean merge) throws IOException {
-
-		// Parsing state
-		final int ST_START = 0;		// start of line
-		final int ST_NAME = 1;		// reading name
-		final int ST_VALUE = 2;		// reading value
-		final int ST_EOL = 3;		// after newine, middle of block
-		int state = ST_START;		// parsing state
-		int numChunks = 0;		// number of chunks read
-		int lineno = 1;			// input line number
-
-		// Input
-		PushbackReader p = new PushbackReader(new BufferedReader(
-		    new InputStreamReader(in, MANIFEST_ENCODING)));
-
-		// Parse input until we reach EOF
-		try {
-
-		    // Parse each chunk of headers (ie, attributes block)
-		    while (true) {
-			Attributes attr = new Attributes();
-			StringBuffer nbuf = null;
-			StringBuffer vbuf = null;
-getAttr:
-			// Read and parse one character at a time
-			while (true) {
-
-			    // Get next character
-			    int c = p.read();
-			    if (c == -1) {
-				if (state != ST_EOL) {
-				    throw new EOFException();
-				}
-			    }
-
-			    // Map all EOL possibilities to '\n'
-			    if (c == '\r') {
-				c = p.read();
-				if (c != -1 && c != '\n') {
-				    p.unread(c);
-				}
-				c = '\n';
-			    }
-			    if (c == '\n') {
-				lineno++;
-			    }
-
-			    // Update state
-			    switch (state) {
-			    case ST_START:
-				/* ouch. accept manifests that have a 0x00 at the end */
-				if (c == 0x00) {
-					int t = p.read();
-					if (t == -1) {
-						throw new EOFException();
-					}
-					p.unread (t);
-				}
-
-				if (c == '\n') {
-				    if (attr.size() == 0) {
-					continue;	// initial blank line
-				    } else {
-					break getAttr;	// end of block
-				    }
-				}
-				if (!((c >= '0' && c <= '9') ||
-				      (c >= 'A' && c <= 'Z') ||
-				      (c >= 'a' && c <= 'z'))) {
-				    throw new IOException(
-					"invalid manifest, line " + lineno);
-				}
-				nbuf = new StringBuffer();
-				nbuf.append((char)c);
-				state = ST_NAME;
-				break;
-
-			    case ST_NAME:
-				if (c == ':') {
-				    c = p.read();
-				    if (c != ' ') {
-					throw new IOException(
-					    "invalid manifest, line " + lineno);
-				    }
-				    vbuf = new StringBuffer();
-				    state = ST_VALUE;
-				    break;
-				}
-				if (!((c >= '0' && c <= '9') ||
-				      (c >= 'A' && c <= 'Z') ||
-				      (c >= 'a' && c <= 'z') ||
-				       c == '_' || c == '-')) {
-				    throw new IOException(
-					"invalid manifest, line " + lineno);
-				}
-				nbuf.append((char)c);
-				break;
-
-			    case ST_VALUE:
-				if (c == '\n') {
-				    state = ST_EOL;
-				    break;
-				}
-				vbuf.append((char)c);
-				break;
-
-			    case ST_EOL:
-				if (c == ' ' || c == '\t') {	// continuation
-				    state = ST_VALUE;
-				    break;
-				}
-				attr.putValue(nbuf.toString(), vbuf.toString());
-				state = ST_START;
-				if (c == -1) {
-				    // process last attributes
-				    break getAttr;
-				}
-				else {
-				    p.unread(c);
-				}
-				break;
-			    }
-			}
-
-			// Now set/merge in the attributes we just read
-			if (numChunks++ == 0) {
-			    if (merge) {
-			    	main.putAll(attr);
-			    } else {
-				main = attr;
-			    }
-			} else {
-			    String name = attr.getValue(NAME);
-			    if (name == null) {
-				throw new IOException("invalid manifest, line "
-				  + lineno + ": missing ``Name'' header");
-			    }
-			    Attributes attr0 = (Attributes)ents.get(name);
-			    if (attr0 == null) {
-				ents.put(name, attr);
-			    } else if (merge) {
-				attr0.putAll(attr);
-			    }
-			}
-		    }
-
-		// Jump here when we get EOF
-		} catch (EOFException e) {
-		    if (numChunks == 0 || state != ST_START) {
-			throw new IOException("premature EOF, line " + lineno);
-		    }
-		}
-	}
-
-	public boolean equals(Object o) {
-		return (o instanceof Manifest)
-		    && main.equals(((Manifest)o).main)
-		    && ents.equals(((Manifest)o).ents);
-	}
-
-	public int hashCode() {
-		return main.hashCode() ^ ents.hashCode();
-	}
-
-	public Object clone() {
-		return new Manifest(this);
-	}
-}
+/**
+ * Reads, writes and manipulaties jar manifest files.
+ * XXX
+ * 
+ * @since 1.2
+ * @author Mark Wielaard (mark@klomp.org)
+ */
+public class Manifest implements Cloneable
+{
+  // Fields
+
+  /** The main attributes of the manifest (jar file). */
+  private final Attributes mainAttr;
+
+  /** A map of atrributes for all entries described in this Manifest. */
+  private final Map entries;
+
+  // Constructors
+
+  /**
+   * Creates a new empty Manifest.
+   */
+  public Manifest()
+  {
+    mainAttr = new Attributes();
+    entries = new Hashtable();
+  }
+
+  /**
+   * Creates a Manifest from the supplied input stream.
+   *
+   * @see read(Inputstream)
+   * @see write(OutputStream)
+   *
+   * @param InputStream the input stream to read the manifest from
+   * @exception IOException when an i/o exception occurs or the input stream
+   * does not describe a valid manifest
+   */
+  public Manifest(InputStream in) throws IOException
+  {
+    this();
+    read(in);
+  }
+
+  /**
+   * Creates a Manifest from another Manifest.
+   * Makes a deep copy of the main attributes, but a shallow copy of
+   * the other entries. This means that you can freely add, change or remove
+   * the main attributes or the entries of the new manifest without effecting
+   * the original manifest, but adding, changing or removing attributes from
+   * a particular entry also changes the attributes of that entry in the
+   * original manifest.
+   *
+   * @see clone()
+   * @param man the Manifest to copy from
+   */
+  public Manifest(Manifest man)
+  {
+    mainAttr = new Attributes(man.getMainAttributes());
+    entries = new Hashtable(man.getEntries());
+  }
+
+  // Methods
+
+  /**
+   * Gets the main attributes of this Manifest.
+   */
+  public Attributes getMainAttributes()
+  {
+    return mainAttr;
+  }
+
+  /**
+   * Gets a map of entry Strings to Attributes for all the entries described
+   * in this manifest. Adding, changing or removing from this entries map
+   * changes the entries of this manifest.
+   */
+  public Map getEntries()
+  {
+    return entries;
+  }
+
+  /**
+   * Returns the Attributes associated with the Entry.
+   * <p>
+   * Implemented as:
+   * <code>return (Attributes)getEntries().get(entryName)</code>
+   *
+   * @param entryName the name of the entry to look up
+   * @return the attributes associated with the entry or null when none
+   */
+  public Attributes getAttributes(String entryName)
+  {
+    return (Attributes) getEntries().get(entryName);
+  }
+
+  /**
+   * Clears the main attributes and removes all the entries from the
+   * manifest.
+   */
+  public void clear()
+  {
+    mainAttr.clear();
+    entries.clear();
+  }
+
+  /**
+   * XXX
+   */
+  public void read(InputStream in) throws IOException
+  {
+    BufferedReader br =
+      new BufferedReader(new InputStreamReader(in, "8859_1"));
+    read_main_section(getMainAttributes(), br);
+    read_individual_sections(getEntries(), br);
+  }
+
+  // Private Static methods for reading the Manifest file from BufferedReader
+
+  private static void read_main_section(Attributes attr,
+					BufferedReader br) throws IOException
+  {
+    // According to the spec we should actually call read_version_info() here.
+    read_attributes(attr, br);
+    // Explicitly set Manifest-Version attribute if not set in Main
+    // attributes of Manifest.
+    if (attr.getValue(Attributes.Name.MANIFEST_VERSION) == null)
+	    attr.putValue(Attributes.Name.MANIFEST_VERSION, "0.0");
+  }
+
+  /**
+   * Pedantic method that requires the next attribute in the Manifest to be
+   * the "Manifest-Version". This follows the Manifest spec closely but
+   * reject some jar Manifest files out in the wild.
+   */
+  private static void read_version_info(Attributes attr,
+					BufferedReader br) throws IOException
+  {
+    String version_header = Attributes.Name.MANIFEST_VERSION.toString();
+    try
+      {
+	String value = expect_header(version_header, br);
+	attr.putValue(Attributes.Name.MANIFEST_VERSION, value);
+      }
+    catch (IOException ioe)
+      {
+	throw new JarException("Manifest should start with a " +
+			       version_header + ": " + ioe.getMessage());
+      }
+  }
+
+  private static String expect_header(String header, BufferedReader br)
+    throws IOException
+  {
+    String s = br.readLine();
+    if (s == null)
+      {
+	throw new JarException("unexpected end of file");
+      }
+    return expect_header(header, br, s);
+  }
+
+  private static String expect_header(String header, BufferedReader br,
+				      String s) throws IOException
+  {
+    try
+      {
+	String name = s.substring(0, header.length() + 1);
+	if (name.equalsIgnoreCase(header + ":"))
+	  {
+	    String value_start = s.substring(header.length() + 2);
+	    return read_header_value(value_start, br);
+	  }
+      }
+    catch (IndexOutOfBoundsException iobe)
+      {
+      }
+    // If we arrive here, something went wrong
+    throw new JarException("unexpected '" + s + "'");
+  }
+
+  private static String read_header_value(String s, BufferedReader br)
+    throws IOException
+  {
+    boolean try_next = true;
+    while (try_next)
+      {
+	// Lets see if there is something on the next line
+	br.mark(1);
+	if (br.read() == ' ')
+	  {
+	    s += br.readLine();
+	  }
+	else
+	  {
+	    br.reset();
+	    try_next = false;
+	  }
+      }
+    return s;
+  }
+
+  private static void read_attributes(Attributes attr,
+				      BufferedReader br) throws IOException
+  {
+    String s = br.readLine();
+    while (s != null && (!s.equals("")))
+      {
+	read_attribute(attr, s, br);
+	s = br.readLine();
+      }
+  }
+
+  private static void read_attribute(Attributes attr, String s,
+				     BufferedReader br) throws IOException
+  {
+    try
+      {
+	int colon = s.indexOf(": ");
+	String name = s.substring(0, colon);
+	String value_start = s.substring(colon + 2);
+	String value = read_header_value(value_start, br);
+	attr.putValue(name, value);
+      }
+    catch (IndexOutOfBoundsException iobe)
+      {
+	throw new JarException("Manifest contains a bad header: " + s);
+      }
+  }
+
+  private static void read_individual_sections(Map entries,
+					       BufferedReader br) throws
+    IOException
+  {
+    String s = br.readLine();
+    while (s != null && (!s.equals("")))
+      {
+	Attributes attr = read_section_name(s, br, entries);
+	read_attributes(attr, br);
+	s = br.readLine();
+      }
+  }
+
+  private static Attributes read_section_name(String s, BufferedReader br,
+					      Map entries) throws JarException
+  {
+    try
+      {
+	String name = expect_header("Name", br, s);
+	Attributes attr = new Attributes();
+	entries.put(name, attr);
+	return attr;
+      }
+    catch (IOException ioe)
+      {
+	throw new JarException
+	  ("Section should start with a Name header: " + ioe.getMessage());
+      }
+  }
+
+  /**
+   * XXX
+   */
+  public void write(OutputStream out) throws IOException
+  {
+    PrintWriter pw =
+      new PrintWriter(new
+		      BufferedWriter(new OutputStreamWriter(out, "8859_1")));
+    write_main_section(getMainAttributes(), pw);
+    pw.println();
+    write_individual_sections(getEntries(), pw);
+    if (pw.checkError())
+      {
+	throw new JarException("Error while writing manifest");
+      }
+  }
+
+  // Private Static functions for writing the Manifest file to a PrintWriter
+
+  private static void write_main_section(Attributes attr,
+					 PrintWriter pw) throws JarException
+  {
+    write_version_info(attr, pw);
+    write_main_attributes(attr, pw);
+  }
+
+  private static void write_version_info(Attributes attr, PrintWriter pw)
+  {
+    // First check if there is already a version attribute set
+    String version = attr.getValue(Attributes.Name.MANIFEST_VERSION);
+    if (version == null)
+      {
+	version = "1.0";
+      }
+    write_header(Attributes.Name.MANIFEST_VERSION.toString(), version, pw);
+  }
+
+  private static void write_header(String name, String value, PrintWriter pw)
+  {
+    pw.print(name + ": ");
+
+    int last = 68 - name.length();
+    if (last > value.length())
+      {
+	pw.println(value);
+      }
+    else
+      {
+	pw.println(value.substring(0, last));
+      }
+    while (last < value.length())
+      {
+	pw.print(" ");
+	int end = (last + 69);
+	if (end > value.length())
+	  {
+	    pw.println(value.substring(last));
+	  }
+	else
+	  {
+	    pw.println(value.substring(last, end));
+	  }
+	last = end;
+      }
+  }
+
+  private static void write_main_attributes(Attributes attr, PrintWriter pw) 
+    throws JarException
+  {
+    Iterator it = attr.entrySet().iterator();
+    while (it.hasNext())
+      {
+	Map.Entry entry = (Map.Entry) it.next();
+	// Don't print the manifest version again
+	if (!Attributes.Name.MANIFEST_VERSION.equals(entry.getKey()))
+	  {
+	    write_attribute_entry(entry, pw);
+	  }
+      }
+  }
+
+  private static void write_attribute_entry(Map.Entry entry, PrintWriter pw) 
+    throws JarException
+  {
+    String name = entry.getKey().toString();
+    String value = entry.getValue().toString();
+
+    if (name.equalsIgnoreCase("Name"))
+      {
+	throw new JarException("Attributes cannot be called 'Name'");
+      }
+    if (name.startsWith("From"))
+      {
+	throw new
+	  JarException("Header cannot start with the four letters 'From'" +
+		       name);
+      }
+    write_header(name, value, pw);
+  }
+
+  private static void write_individual_sections(Map entries, PrintWriter pw)
+    throws JarException
+  {
+
+    Iterator it = entries.entrySet().iterator();
+    while (it.hasNext())
+      {
+	Map.Entry entry = (Map.Entry) it.next();
+	write_header("Name", entry.getKey().toString(), pw);
+	write_entry_attributes((Attributes) entry.getValue(), pw);
+	pw.println();
+      }
+  }
+
+  private static void write_entry_attributes(Attributes attr, PrintWriter pw) 
+    throws JarException
+  {
+    Iterator it = attr.entrySet().iterator();
+    while (it.hasNext())
+      {
+	Map.Entry entry = (Map.Entry) it.next();
+	write_attribute_entry(entry, pw);
+      }
+  }
+
+  /**
+   * Makes a deep copy of the main attributes, but a shallow copy of
+   * the other entries. This means that you can freely add, change or remove
+   * the main attributes or the entries of the new manifest without effecting
+   * the original manifest, but adding, changing or removing attributes from
+   * a particular entry also changes the attributes of that entry in the
+   * original manifest. Calls <CODE>new Manifest(this)</CODE>.
+   */
+  public Object clone()
+  {
+    return new Manifest(this);
+  }
+
+  /**
+   * Checks if another object is equal to this Manifest object.
+   * Another Object is equal to this Manifest object if it is an instance of
+   * Manifest and the main attributes and the entries of the other manifest
+   * are equal to this one.
+   */
+  public boolean equals(Object o)
+  {
+    return (o instanceof Manifest) &&
+      (mainAttr.equals(((Manifest) o).mainAttr)) &&
+      (entries.equals(((Manifest) o).entries));
+  }
+
+  /**
+   * Calculates the hash code of the manifest. Implemented by a xor of the
+   * hash code of the main attributes with the hash code of the entries map.
+   */
+  public int hashCode()
+  {
+    return mainAttr.hashCode() ^ entries.hashCode();
+  }
 
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/Adler32.java kaffe/libraries/javalib/java/util/zip/Adler32.java
--- kaffe_orig/libraries/javalib/java/util/zip/Adler32.java	1998-07-15 05:02:10.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/Adler32.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,49 +1,205 @@
+/* Adler32.java - Computes Adler32 data checksum of a data stream
+   Copyright (C) 1999, 2000, 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
 /*
- * Java core library component.
+ * Written using on-line Java Platform 1.2 API Specification, as well
+ * as "The Java Class Libraries", 2nd edition (Addison-Wesley, 1998).
+ * The actual Adler32 algorithm is taken from RFC 1950.
+ * Status:  Believed complete and correct.
+ */
+
+/**
+ * Computes Adler32 checksum for a stream of data. An Adler32 
+ * checksum is not as reliable as a CRC32 checksum, but a lot faster to 
+ * compute.
+ *<p>
+ * The specification for Adler32 may be found in RFC 1950.
+ * (ZLIB Compressed Data Format Specification version 3.3)
+ *<p>
+ *<p>
+ * From that document:
+ *<p>
+ *      "ADLER32 (Adler-32 checksum)
+ *       This contains a checksum value of the uncompressed data
+ *       (excluding any dictionary data) computed according to Adler-32
+ *       algorithm. This algorithm is a 32-bit extension and improvement
+ *       of the Fletcher algorithm, used in the ITU-T X.224 / ISO 8073
+ *       standard. 
+ *<p>
+ *       Adler-32 is composed of two sums accumulated per byte: s1 is
+ *       the sum of all bytes, s2 is the sum of all s1 values. Both sums
+ *       are done modulo 65521. s1 is initialized to 1, s2 to zero.  The
+ *       Adler-32 checksum is stored as s2*65536 + s1 in most-
+ *       significant-byte first (network) order."
+ *<p>
+ * "8.2. The Adler-32 algorithm
+ *<p>
+ *    The Adler-32 algorithm is much faster than the CRC32 algorithm yet
+ *    still provides an extremely low probability of undetected errors.
+ *<p>
+ *    The modulo on unsigned long accumulators can be delayed for 5552
+ *    bytes, so the modulo operation time is negligible.  If the bytes
+ *    are a, b, c, the second sum is 3a + 2b + c + 3, and so is position
+ *    and order sensitive, unlike the first sum, which is just a
+ *    checksum.  That 65521 is prime is important to avoid a possible
+ *    large class of two-byte errors that leave the check unchanged.
+ *    (The Fletcher checksum uses 255, which is not prime and which also
+ *    makes the Fletcher check insensitive to single byte changes 0 <->
+ *    255.)
+ *<p>
+ *    The sum s1 is initialized to 1 instead of zero to make the length
+ *    of the sequence part of s2, so that the length does not have to be
+ *   checked separately. (Any sequence of zeroes has a Fletcher
+ *    checksum of zero.)"
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * @author John Leuner, Per Bothner
+ * @since JDK 1.1
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
+ * @see InflaterInputStream
+ * @see DeflaterOutputStream
  */
+public class Adler32 implements Checksum
+{
 
-package java.util.zip;
-
-public class Adler32 implements Checksum {
-
-  static {
-    System.loadLibrary("zip");
-  }
+  /** largest prime smaller than 65536 */
+  private static final int BASE = 65521;
 
-  private int adler;
+  private int checksum; //we do all in int.
 
-  public Adler32()
+  //Note that java doesn't have unsigned integers,
+  //so we have to be careful with what arithmetic 
+  //we do. We return the checksum as a long to 
+  //avoid sign confusion.
+
+  /**
+   * Creates a new instance of the <code>Adler32</code> class. 
+   * The checksum starts off with a value of 1. 
+   */
+  public Adler32 ()
   {
-    adler = 0;
+    reset();
   }
 
-  public void update(int b)
+  /**
+   * Resets the Adler32 checksum to the initial value.
+   */
+  public void reset () 
   {
-    update1(b);
+    checksum = 1; //Initialize to 1    
   }
 
-  public void update(byte b[])
+  /**
+   * Updates the checksum with the byte b. 
+   *
+   * @param bval the data value to add. The high byte of the int is ignored.
+   */
+  public void update (int bval)
   {
-    update(b, 0, b.length);
-  }
-
-  public void reset()
+    //We could make a length 1 byte array and call update again, but I
+    //would rather not have that overhead
+    int s1 = checksum & 0xffff;
+    int s2 = checksum >>> 16;
+    
+    s1 = (s1 + (bval & 0xFF)) % BASE;
+    s2 = (s1 + s2) % BASE;
+    
+    checksum = (s2 << 16) + s1;
+  }
+
+  /**
+   * Updates the checksum with the bytes taken from the array. 
+   * 
+   * @param buffer an array of bytes
+   */
+  public void update (byte[] buffer)
   {
-    adler = 0;
+    update(buffer, 0, buffer.length);
   }
 
+  /**
+   * Updates the checksum with the bytes taken from the array. 
+   * 
+   * @param buf an array of bytes
+   * @param off the start of the data used for this update
+   * @param len the number of bytes to use for this update
+   */
+  public void update (byte[] buf, int off, int len)
+  {
+    //(By Per Bothner)
+    int s1 = checksum & 0xffff;
+    int s2 = checksum >>> 16;
+
+    while (len > 0)
+      {
+	// We can defer the modulo operation:
+	// s1 maximally grows from 65521 to 65521 + 255 * 3800
+	// s2 maximally grows by 3800 * median(s1) = 2090079800 < 2^31
+	int n = 3800;
+	if (n > len)
+	  n = len;
+	len -= n;
+	while (--n >= 0)
+	  {
+	    s1 = s1 + (buf[off++] & 0xFF);
+	    s2 = s2 + s1;
+	  }
+	s1 %= BASE;
+	s2 %= BASE;
+      }
+
+    /*Old implementation, borrowed from somewhere:
+    int n;
+    
+    while (len-- > 0) {
+
+      s1 = (s1 + (bs[offset++] & 0xff)) % BASE; 
+      s2 = (s2 + s1) % BASE;
+    }*/
+    
+    checksum = (s2 << 16) | s1;
+  }
+
+  /**
+   * Returns the Adler32 data checksum computed so far.
+   */
   public long getValue()
   {
-    return (adler);
+    return (long) checksum & 0xffffffffL;
   }
-
-  public native void update(byte[] buf, int from, int len);
-  private native void update1(int val);
-
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/CRC32.java kaffe/libraries/javalib/java/util/zip/CRC32.java
--- kaffe_orig/libraries/javalib/java/util/zip/CRC32.java	1998-07-15 05:02:10.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/CRC32.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,49 +1,132 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* CRC32.java - Computes CRC32 data checksum of a data stream
+   Copyright (C) 1999. 2000, 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.zip;
 
-public class CRC32 implements Checksum {
+/*
+ * Written using on-line Java Platform 1.2 API Specification, as well
+ * as "The Java Class Libraries", 2nd edition (Addison-Wesley, 1998).
+ * The actual CRC32 algorithm is taken from RFC 1952.
+ * Status:  Believed complete and correct.
+ */
 
-  static {
-    System.loadLibrary("zip");
-  }
+/**
+ * Computes CRC32 data checksum of a data stream.
+ * The actual CRC32 algorithm is described in RFC 1952
+ * (GZIP file format specification version 4.3).
+ * Can be used to get the CRC32 over a stream if used with checked input/output
+ * streams.
+ *
+ * @see InflaterInputStream
+ * @see DeflaterOutputStream
+ *
+ * @author Per Bothner
+ * @date April 1, 1999.
+ */
+public class CRC32 implements Checksum
+{
+  /** The crc data checksum so far. */
+  private int crc = 0;
 
-  private int crc;
+  /** The fast CRC table. Computed once when the CRC32 class is loaded. */
+  private static int[] crc_table = make_crc_table();
 
-  public CRC32()
+  /** Make the table for a fast CRC. */
+  private static int[] make_crc_table ()
   {
-    crc = 0;
-  }
-
-  public void update(int b)
+    int[] crc_table = new int[256];
+    for (int n = 0; n < 256; n++)
+      {
+	int c = n;
+	for (int k = 8;  --k >= 0; )
+	  {
+	    if ((c & 1) != 0)
+	      c = 0xedb88320 ^ (c >>> 1);
+	    else
+	      c = c >>> 1;
+	  }
+	crc_table[n] = c;
+      }
+    return crc_table;
+  }
+
+  /**
+   * Returns the CRC32 data checksum computed so far.
+   */
+  public long getValue ()
   {
-    update1(b);
+    return (long) crc & 0xffffffffL;
   }
 
-  public void update(byte b[])
-  {
-    update(b, 0, b.length);
-  }
+  /**
+   * Resets the CRC32 data checksum as if no update was ever called.
+   */
+  public void reset () { crc = 0; }
 
-  public void reset()
+  /**
+   * Updates the checksum with the int bval. 
+   *
+   * @param bval (the byte is taken as the lower 8 bits of bval)
+   */
+
+  public void update (int bval)
   {
-    crc = 0;
+    int c = ~crc;
+    c = crc_table[(c ^ bval) & 0xff] ^ (c >>> 8);
+    crc = ~c;
   }
 
-  public long getValue()
+  /**
+   * Adds the byte array to the data checksum.
+   *
+   * @param buf the buffer which contains the data
+   * @param off the offset in the buffer where the data starts
+   * @param len the length of the data
+   */
+  public void update (byte[] buf, int off, int len)
   {
-    return (((long)crc) & 0xFFFFFFFFL);
+    int c = ~crc;
+    while (--len >= 0)
+      c = crc_table[(c ^ buf[off++]) & 0xff] ^ (c >>> 8);
+    crc = ~c;
   }
 
-  public native void update(byte b[], int off, int len);
-  private native void update1(int val);
-
+  /**
+   * Adds the complete byte array to the data checksum.
+   */
+  public void update (byte[] buf) { update(buf, 0, buf.length); }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/CheckedInputStream.java kaffe/libraries/javalib/java/util/zip/CheckedInputStream.java
--- kaffe_orig/libraries/javalib/java/util/zip/CheckedInputStream.java	1998-07-15 05:02:10.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/CheckedInputStream.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,51 +1,134 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* CheckedInputStream.java - Compute checksum of data being read
+   Copyright (C) 1999, 2000 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.zip;
 
-import java.io.InputStream;
 import java.io.FilterInputStream;
+import java.io.InputStream;
 import java.io.IOException;
 
-public class CheckedInputStream extends FilterInputStream {
-
-private Checksum cksum;
-
-public CheckedInputStream(InputStream in, Checksum sum)
-{
-	super(in);
-	cksum = sum;
-}
-
-public Checksum getChecksum()
-{
-	return (cksum);
-}
+/* Written using on-line Java Platform 1.2 API Specification
+ * and JCL book.
+ * Believed complete and correct.
+ */
 
-public int read() throws IOException
+/**
+ * InputStream that computes a checksum of the data being read using a
+ * supplied Checksum object.
+ *
+ * @see Checksum
+ *
+ * @author Tom Tromey
+ * @date May 17, 1999
+ */
+public class CheckedInputStream extends FilterInputStream
 {
-	int bval = in.read();
-	if (bval == -1) {
-		return (-1);
-	}
-	cksum.update(bval);
-	return (bval);
-}
+  /**
+   * Creates a new CheckInputStream on top of the supplied OutputStream
+   * using the supplied Checksum.
+   */
+  public CheckedInputStream (InputStream in, Checksum sum)
+  {
+    super (in);
+    this.sum = sum;
+  }
+
+  /**
+   * Returns the Checksum object used. To get the data checksum computed so
+   * far call <code>getChecksum.getValue()</code>.
+   */
+  public Checksum getChecksum ()
+  {
+    return sum;
+  }
+
+  /**
+   * Reads one byte, updates the checksum and returns the read byte
+   * (or -1 when the end of file was reached).
+   */
+  public int read () throws IOException
+  {
+    int x = in.read();
+    if (x != -1)
+      sum.update(x);
+    return x;
+  }
+
+  /**
+   * Reads at most len bytes in the supplied buffer and updates the checksum
+   * with it. Returns the number of bytes actually read or -1 when the end
+   * of file was reached.
+   */
+  public int read (byte[] buf, int off, int len) throws IOException
+  {
+    int r = in.read(buf, off, len);
+    if (r != -1)
+      sum.update(buf, off, r);
+    return r;
+  }
+
+  /**
+   * Skips n bytes by reading them in a temporary buffer and updating the
+   * the checksum with that buffer. Returns the actual number of bytes skiped
+   * which can be less then requested when the end of file is reached.
+   */
+  public long skip (long n) throws IOException
+  {
+    if (n == 0)
+      return 0;
+
+    int min = (int) Math.min(n, 1024);
+    byte[] buf = new byte[min];
+
+    long s = 0;
+    while (n > 0)
+      {
+	int r = in.read(buf, 0, min);
+	if (r == -1)
+	  break;
+	n -= r;
+	s += r;
+	min = (int) Math.min(n, 1024);
+	sum.update(buf, 0, r);
+      }
 
-public int read(byte[] buf, int off, int len) throws IOException
-{
-	int total = in.read(buf, off, len);
-	if (total > 0) {
-		cksum.update(buf, off, total);
-	}
-	return (total);
-}
+    return s;
+  }
 
+  /** The checksum object. */
+  private Checksum sum;
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/CheckedOutputStream.java kaffe/libraries/javalib/java/util/zip/CheckedOutputStream.java
--- kaffe_orig/libraries/javalib/java/util/zip/CheckedOutputStream.java	1998-07-15 05:02:10.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/CheckedOutputStream.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,12 +1,39 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* CheckedOutputStream.java - Compute checksum of data being written.
+   Copyright (C) 1999, 2000 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.zip;
 
@@ -14,31 +41,59 @@
 import java.io.OutputStream;
 import java.io.IOException;
 
-public class CheckedOutputStream extends FilterOutputStream {
-
-private Checksum cksum;
-
-public CheckedOutputStream(OutputStream out, Checksum sum)
-{
-	super(out);
-	cksum = sum;
-}
-
-public Checksum getChecksum()
-{
-	return (cksum);
-}
-
-public void write(int bval) throws IOException
-{
-	out.write(bval);
-	cksum.update(bval);
-}
+/* Written using on-line Java Platform 1.2 API Specification
+ * and JCL book.
+ * Believed complete and correct.
+ */
 
-public void write(byte[] buf, int off, int len) throws IOException
+/**
+ * OutputStream that computes a checksum of data being written using a
+ * supplied Checksum object.
+ *
+ * @see Checksum
+ *
+ * @author Tom Tromey
+ * @date May 17, 1999
+ */
+public class CheckedOutputStream extends FilterOutputStream
 {
-	out.write(buf, off, len);
-	cksum.update(buf, off, len);
-}
+  /**
+   * Creates a new CheckInputStream on top of the supplied OutputStream
+   * using the supplied Checksum.
+   */
+  public CheckedOutputStream (OutputStream out, Checksum cksum)
+  {
+    super (out);
+    this.sum = cksum;
+  }
+
+  /**
+   * Returns the Checksum object used. To get the data checksum computed so
+   * far call <code>getChecksum.getValue()</code>.
+   */
+  public Checksum getChecksum ()
+  {
+    return sum;
+  }
+
+  /**
+   * Writes one byte to the OutputStream and updates the Checksum.
+   */
+  public void write (int bval) throws IOException
+  {
+    out.write(bval);
+    sum.update(bval);
+  }
+
+  /**
+   * Writes the byte array to the OutputStream and updates the Checksum.
+   */
+  public void write (byte[] buf, int off, int len) throws IOException
+  {
+    out.write(buf, off, len);
+    sum.update(buf, off, len);
+  }
 
+  /** The checksum object. */
+  private Checksum sum;
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/Deflater.java kaffe/libraries/javalib/java/util/zip/Deflater.java
--- kaffe_orig/libraries/javalib/java/util/zip/Deflater.java	2002-07-04 13:12:02.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/Deflater.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,132 +1,523 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* java.util.zip.Deflater
+   Copyright (C) 2001 Free Software Foundation, Inc.
 
-package java.util.zip;
+This file is part of GNU Classpath.
 
-public class Deflater {
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-  static {
-    System.loadLibrary("zip");
-  }
+package java.util.zip;
 
-  public static final int DEFLATED = 8;
-  public static final int NO_COMPRESSION = 0;
-  public static final int BEST_SPEED = 1;
+/** 
+ * This is the Deflater class.  The deflater class compresses input
+ * with the deflate algorithm described in RFC 1951.  It has several
+ * compression levels and three different strategies described below.
+ *
+ * This class is <i>not</i> thread safe.  This is inherent in the API, due
+ * to the split of deflate and setInput.
+ *
+ * @author Jochen Hoenicke
+ * @date Jan 5, 2000 
+ */
+public class Deflater
+{
+  /**
+   * The best and slowest compression level.  This tries to find very
+   * long and distant string repetitions.  
+   */
   public static final int BEST_COMPRESSION = 9;
+  /**
+   * The worst but fastest compression level.  
+   */
+  public static final int BEST_SPEED = 1;
+  /**
+   * The default compression level.
+   */
   public static final int DEFAULT_COMPRESSION = -1;
-  public static final int FILTERED = 1;
-  public static final int HUFFMAN_ONLY = 2;
+  /**
+   * This level won't compress at all but output uncompressed blocks.
+   */
+  public static final int NO_COMPRESSION = 0;
+
+  /**
+   * The default strategy.
+   */
   public static final int DEFAULT_STRATEGY = 0;
+  /**
+   * This strategy will only allow longer string repetitions.  It is
+   * useful for random data with a small character set.
+   */
+  public static final int FILTERED = 1;
 
-  private int strm;	// The number of the deflater stream.
-  private byte[] buf;
-  private int off;
-  private int len;
-  private int level;
-  private int strategy;
-  private boolean finish;
-  private boolean finished;
+  /** 
+   * This strategy will not look for string repetitions at all.  It
+   * only encodes with Huffman trees (which means, that more common
+   * characters get a smaller encoding.  
+   */
+  public static final int HUFFMAN_ONLY = 2;
 
-  public Deflater(int lvl, boolean nowrap)
-  {
-    level = lvl;
-    buf = null;
-    len = 0;
-    off = 0;
-    strategy = DEFLATED;
-    finish = false;
-    finished = false;
-    init(nowrap);
-  }
+  /**
+   * The compression method.  This is the only method supported so far.
+   * There is no need to use this constant at all.
+   */
+  public static final int DEFLATED = 8;
 
-  public Deflater(int level)
-  {
-    this(level, false);
-  }
+  /*
+   * The Deflater can do the following state transitions:
+   *
+   * (1) -> INIT_STATE   ----> INIT_FINISHING_STATE ---.
+   *        /  | (2)      (5)                         |
+   *       /   v          (5)                         |
+   *   (3)| SETDICT_STATE ---> SETDICT_FINISHING_STATE |(3)
+   *       \   | (3)                 |        ,-------'
+   *        |  |                     | (3)   /
+   *        v  v          (5)        v      v
+   * (1) -> BUSY_STATE   ----> FINISHING_STATE
+   *                                | (6)
+   *                                v
+   *                           FINISHED_STATE
+   *    \_____________________________________/
+   *          | (7)
+   *          v
+   *        CLOSED_STATE
+   *
+   * (1) If we should produce a header we start in INIT_STATE, otherwise
+   *     we start in BUSY_STATE.
+   * (2) A dictionary may be set only when we are in INIT_STATE, then
+   *     we change the state as indicated.
+   * (3) Whether a dictionary is set or not, on the first call of deflate
+   *     we change to BUSY_STATE.
+   * (4) -- intentionally left blank -- :)
+   * (5) FINISHING_STATE is entered, when flush() is called to indicate that
+   *     there is no more INPUT.  There are also states indicating, that
+   *     the header wasn't written yet.
+   * (6) FINISHED_STATE is entered, when everything has been flushed to the
+   *     internal pending output buffer.
+   * (7) At any time (7)
+   * 
+   */
+
+  private static final int IS_SETDICT              = 0x01;
+  private static final int IS_FLUSHING             = 0x04;
+  private static final int IS_FINISHING            = 0x08;
+  
+  private static final int INIT_STATE              = 0x00;
+  private static final int SETDICT_STATE           = 0x01;
+  private static final int INIT_FINISHING_STATE    = 0x08;
+  private static final int SETDICT_FINISHING_STATE = 0x09;
+  private static final int BUSY_STATE              = 0x10;
+  private static final int FLUSHING_STATE          = 0x14;
+  private static final int FINISHING_STATE         = 0x1c;
+  private static final int FINISHED_STATE          = 0x1e;
+  private static final int CLOSED_STATE            = 0x7f;
 
-  public Deflater()
-  {
-    this(DEFAULT_COMPRESSION, false);
-  }
+  /** Compression level. */
+  private int level;
 
-  public synchronized void setInput(byte b[], int o, int l)
-  {
-    buf = b;
-    off = o;
-    len = l;
-  }
+  /** should we include a header. */
+  private boolean noHeader;
 
-  public void setInput(byte b[])
-  {
-    setInput(b, 0, b.length);
-  }
+  /** Compression strategy. */
+  private int strategy;
 
-  public void setDictionary(byte b[])
-  {
-    setDictionary(b, 0, b.length);
-  }
+  /** The current state. */
+  private int state;
 
-  public synchronized void setStrategy(int stgy)
+  /** The total bytes of output written. */
+  private int totalOut;
+ 
+  /** The pending output. */
+  private DeflaterPending pending;
+
+  /** The deflater engine. */
+  private DeflaterEngine engine;
+
+  /**
+   * Creates a new deflater with default compression level.
+   */
+  public Deflater()
   {
-    if (stgy != DEFLATED) {
-      throw new IllegalArgumentException("only support deflation");
-    }
-    strategy = stgy;
+    this(DEFAULT_COMPRESSION, false);
   }
 
-  public synchronized void setLevel(int lvl)
+  /**
+   * Creates a new deflater with given compression level.
+   * @param lvl the compression level, a value between NO_COMPRESSION
+   * and BEST_COMPRESSION, or DEFAULT_COMPRESSION.  
+   * @exception IllegalArgumentException if lvl is out of range.
+   */
+  public Deflater(int lvl)
+  {
+    this(lvl, false);
+  }
+
+  /**
+   * Creates a new deflater with given compression level.
+   * @param lvl the compression level, a value between NO_COMPRESSION
+   * and BEST_COMPRESSION.  
+   * @param nowrap true, iff we should suppress the deflate header at the
+   * beginning and the adler checksum at the end of the output.  This is
+   * useful for the GZIP format.
+   * @exception IllegalArgumentException if lvl is out of range.
+   */
+  public Deflater(int lvl, boolean nowrap)
   {
-    if ((level != DEFAULT_COMPRESSION) && (lvl < 0 || lvl > 9)) {
-      throw new IllegalArgumentException("levels 0-9 supported");
-    }
-    level = lvl;
-  }
-
+    if (lvl == DEFAULT_COMPRESSION)
+      lvl = 6;
+    else if (lvl < NO_COMPRESSION || lvl > BEST_COMPRESSION)
+      throw new IllegalArgumentException();
+
+    pending = new DeflaterPending();
+    engine = new DeflaterEngine(pending);
+    this.noHeader = nowrap;
+    setStrategy(DEFAULT_STRATEGY);
+    setLevel(lvl);
+    reset();
+  }
+
+  /** 
+   * Resets the deflater.  The deflater acts afterwards as if it was
+   * just created with the same compression level and strategy as it
+   * had before.  
+   */
+  public void reset() 
+  {
+    state = (noHeader ? BUSY_STATE : INIT_STATE);
+    totalOut = 0;
+    pending.reset();
+    engine.reset();
+  }
+  
+  /**
+   * Frees all objects allocated by the compressor.  There's no
+   * reason to call this, since you can just rely on garbage
+   * collection.  Exists only for compatibility against Sun's JDK,
+   * where the compressor allocates native memory.
+   * If you call any method (even reset) afterwards the behaviour is
+   * <i>undefined</i>.  
+   * @deprecated Just clear all references to deflater instead.
+   */
+  public void end()
+  {
+    engine = null;
+    pending = null;
+    state = CLOSED_STATE;
+  }
+
+  /** 
+   * Gets the current adler checksum of the data that was processed so
+   * far.
+   */
+  public int getAdler()
+  {
+    return engine.getAdler();
+  }
+
+  /** 
+   * Gets the number of input bytes processed so far.
+   */
+  public int getTotalIn()
+  {
+    return engine.getTotalIn();
+  }
+
+  /** 
+   * Gets the number of output bytes so far.
+   */
+  public int getTotalOut()
+  {
+    return totalOut;
+  }
+
+  /** 
+   * Finalizes this object.
+   */
+  protected void finalize()
+  {
+    /* Exists solely for compatibility.  We don't have any native state. */
+  }
+
+  /** 
+   * Flushes the current input block.  Further calls to deflate() will
+   * produce enough output to inflate everything in the current input
+   * block.  This is not part of Sun's JDK so I have made it package
+   * private.  It is used by DeflaterOutputStream to implement
+   * flush().
+   */
+  void flush() {
+    state |= IS_FLUSHING;
+  }
+
+  /** 
+   * Finishes the deflater with the current input block.  It is an error
+   * to give more input after this method was called.  This method must
+   * be called to force all bytes to be flushed.
+   */
+  public void finish() {
+    state |= IS_FLUSHING | IS_FINISHING;
+  }
+
+  /** 
+   * Returns true iff the stream was finished and no more output bytes
+   * are available.
+   */
+  public boolean finished()
+  {
+    return state == FINISHED_STATE && pending.isFlushed();
+  }
+
+  /**
+   * Returns true, if the input buffer is empty.
+   * You should then call setInput(). <br>
+   *
+   * <em>NOTE</em>: This method can also return true when the stream
+   * was finished.  
+   */
   public boolean needsInput()
   {
-    return (len == 0 ? true : false);
+    return engine.needsInput();
   }
 
-  public synchronized void finish()
+  /**
+   * Sets the data which should be compressed next.  This should be only
+   * called when needsInput indicates that more input is needed.
+   * If you call setInput when needsInput() returns false, the
+   * previous input that is still pending will be thrown away.
+   * The given byte array should not be changed, before needsInput() returns
+   * true again.
+   * This call is equivalent to <code>setInput(input, 0, input.length)</code>.
+   * @param input the buffer containing the input data.
+   * @exception IllegalStateException if the buffer was finished() or ended().
+   */
+  public void setInput(byte[] input)
+  {
+    setInput(input, 0, input.length);
+  }
+
+  /**
+   * Sets the data which should be compressed next.  This should be
+   * only called when needsInput indicates that more input is needed.
+   * The given byte array should not be changed, before needsInput() returns
+   * true again.
+   * @param input the buffer containing the input data.
+   * @param off the start of the data.
+   * @param len the length of the data.  
+   * @exception IllegalStateException if the buffer was finished() or ended()
+   * or if previous input is still pending.
+   */
+  public void setInput(byte[] input, int off, int len)
+  {
+    if ((state & IS_FINISHING) != 0)
+      throw new IllegalStateException("finish()/end() already called");
+    engine.setInput(input, off, len);
+  }
+
+  /** 
+   * Sets the compression level.  There is no guarantee of the exact
+   * position of the change, but if you call this when needsInput is
+   * true the change of compression level will occur somewhere near
+   * before the end of the so far given input.  
+   * @param lvl the new compression level.
+   */
+  public void setLevel(int lvl)
+  {
+    if (lvl == DEFAULT_COMPRESSION)
+      lvl = 6;
+    else if (lvl < NO_COMPRESSION || lvl > BEST_COMPRESSION)
+      throw new IllegalArgumentException();
+
+
+    if (level != lvl)
+      {
+	level = lvl;
+	engine.setLevel(lvl);
+      }
+  }
+
+  /** 
+   * Sets the compression strategy. Strategy is one of
+   * DEFAULT_STRATEGY, HUFFMAN_ONLY and FILTERED.  For the exact
+   * position where the strategy is changed, the same as for
+   * setLevel() applies.
+   * @param stgy the new compression strategy.
+   */
+  public void setStrategy(int stgy)
+  {
+    if (stgy != DEFAULT_STRATEGY && stgy != FILTERED
+	&& stgy != HUFFMAN_ONLY)
+      throw new IllegalArgumentException();
+    engine.setStrategy(stgy);
+  }
+
+  /**
+   * Deflates the current input block to the given array.  It returns 
+   * the number of bytes compressed, or 0 if either 
+   * needsInput() or finished() returns true or length is zero.
+   * @param output the buffer where to write the compressed data.
+   */
+  public int deflate(byte[] output)
+  {
+    return deflate(output, 0, output.length);
+  }
+
+  /**
+   * Deflates the current input block to the given array.  It returns 
+   * the number of bytes compressed, or 0 if either 
+   * needsInput() or finished() returns true or length is zero.
+   * @param output the buffer where to write the compressed data.
+   * @param offset the offset into the output array.
+   * @param length the maximum number of bytes that may be written.
+   * @exception IllegalStateException if end() was called.
+   * @exception IndexOutOfBoundsException if offset and/or length
+   * don't match the array length.  
+   */
+  public int deflate(byte[] output, int offset, int length)
+  {
+    int origLength = length;
+
+    if (state == CLOSED_STATE)
+      throw new IllegalStateException("Deflater closed");
+
+    if (state < BUSY_STATE)
+      {
+	/* output header */
+	int header = (DEFLATED + 
+		      ((DeflaterConstants.MAX_WBITS - 8) << 4)) << 8;
+	int level_flags = (level - 1) >> 1;
+	if (level_flags < 0 || level_flags > 3) 
+	  level_flags = 3;
+	header |= level_flags << 6;
+	if ((state & IS_SETDICT) != 0)
+	  /* Dictionary was set */
+	  header |= DeflaterConstants.PRESET_DICT;
+	header += 31 - (header % 31);
+
+	pending.writeShortMSB(header);
+	if ((state & IS_SETDICT) != 0)
+	  {
+	    int chksum = engine.getAdler();
+	    engine.resetAdler();
+	    pending.writeShortMSB(chksum >> 16);
+	    pending.writeShortMSB(chksum & 0xffff);
+	  }
+
+	state = BUSY_STATE | (state & (IS_FLUSHING | IS_FINISHING));
+      }
+
+    for (;;)
+      {
+	int count = pending.flush(output, offset, length);
+	offset += count;
+	totalOut += count;
+	length -= count;
+	if (length == 0 || state == FINISHED_STATE)
+	  break;
+
+	if (!engine.deflate((state & IS_FLUSHING) != 0, 
+			    (state & IS_FINISHING) != 0))
+	  {
+	    if (state == BUSY_STATE)
+	      /* We need more input now */
+	      return origLength - length;
+	    else if (state == FLUSHING_STATE)
+	      {
+		if (level != NO_COMPRESSION)
+		  {
+		    /* We have to supply some lookahead.  8 bit lookahead
+		     * are needed by the zlib inflater, and we must fill 
+		     * the next byte, so that all bits are flushed.
+		     */
+		    int neededbits = 8 + ((-pending.getBitCount()) & 7);
+		    while (neededbits > 0)
+		      {
+			/* write a static tree block consisting solely of
+			 * an EOF:
+			 */
+			pending.writeBits(2, 10);
+			neededbits -= 10;
+		      }
+		  }
+		state = BUSY_STATE;
+	      }
+	    else if (state == FINISHING_STATE)
+	      {
+		pending.alignToByte();
+		/* We have completed the stream */
+		if (!noHeader)
+		  {
+		    int adler = engine.getAdler();
+		    pending.writeShortMSB(adler >> 16);
+		    pending.writeShortMSB(adler & 0xffff);
+		  }
+		state = FINISHED_STATE;
+	      }
+	  }
+      }
+
+    return origLength - length;
+  }
+
+  /**
+   * Sets the dictionary which should be used in the deflate process.
+   * This call is equivalent to <code>setDictionary(dict, 0,
+   * dict.length)</code>.  
+   * @param dict the dictionary.  
+   * @exception IllegalStateException if setInput () or deflate ()
+   * were already called or another dictionary was already set.  
+   */
+  public void setDictionary(byte[] dict)
+  {
+    setDictionary(dict, 0, dict.length);
+  }
+
+  /**
+   * Sets the dictionary which should be used in the deflate process.
+   * The dictionary should be a byte array containing strings that are
+   * likely to occur in the data which should be compressed.  The
+   * dictionary is not stored in the compressed output, only a
+   * checksum.  To decompress the output you need to supply the same
+   * dictionary again.
+   * @param dict the dictionary.
+   * @param offset an offset into the dictionary.
+   * @param length the length of the dictionary.
+   * @exception IllegalStateException if setInput () or deflate () were
+   * already called or another dictionary was already set.
+   */
+  public void setDictionary(byte[] dict, int offset, int length)
   {
-    finish = true;
-  }
+    if (state != INIT_STATE)
+      throw new IllegalStateException();
 
-  public synchronized boolean finished()
-  {
-    return (finished);
-  }
-
-  public int deflate(byte b[])
-  {
-    return (deflate(b, 0, b.length));
+    state = SETDICT_STATE;
+    engine.setDictionary(dict, offset, length);
   }
-
-  protected void finalize() throws Throwable
-  {
-    /* We don't need to call super.finalize(),
-     * since super class is java.lang.Object, and
-     * java.lang.Object.finalize() just returns
-     * to caller.
-     */
-
-    end();
-  }
-
-  public native synchronized void setDictionary(byte b[], int off, int len);
-  public native synchronized int deflate(byte b[], int off, int len);
-  public native synchronized int getAdler();
-  public native synchronized int getTotalIn();
-  public native synchronized int getTotalOut();
-  public native synchronized void reset();
-  public native synchronized void end();
-  private native synchronized void init(boolean nowrap);
-
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/DeflaterConstants.java kaffe/libraries/javalib/java/util/zip/DeflaterConstants.java
--- kaffe_orig/libraries/javalib/java/util/zip/DeflaterConstants.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/DeflaterConstants.java	2003-09-27 23:01:41.000000000 +1200
@@ -0,0 +1,77 @@
+/* java.util.zip.DeflaterConstants
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
+interface DeflaterConstants {
+  final static boolean DEBUGGING = false;
+
+  final static int STORED_BLOCK = 0;
+  final static int STATIC_TREES = 1;
+  final static int DYN_TREES    = 2;
+  final static int PRESET_DICT  = 0x20;
+
+  final static int DEFAULT_MEM_LEVEL = 8;
+
+  final static int MAX_MATCH = 258;
+  final static int MIN_MATCH = 3;
+
+  final static int MAX_WBITS = 15;
+  final static int WSIZE = 1 << MAX_WBITS;
+  final static int WMASK = WSIZE - 1;
+
+  final static int HASH_BITS = DEFAULT_MEM_LEVEL + 7;
+  final static int HASH_SIZE = 1 << HASH_BITS;
+  final static int HASH_MASK = HASH_SIZE - 1;
+  final static int HASH_SHIFT = (HASH_BITS + MIN_MATCH - 1) / MIN_MATCH;
+
+  final static int MIN_LOOKAHEAD = MAX_MATCH + MIN_MATCH + 1;
+  final static int MAX_DIST = WSIZE - MIN_LOOKAHEAD;
+
+  final static int PENDING_BUF_SIZE = 1 << (DEFAULT_MEM_LEVEL + 8);
+  final static int MAX_BLOCK_SIZE = Math.min(65535, PENDING_BUF_SIZE-5);
+
+  final static int DEFLATE_STORED = 0;
+  final static int DEFLATE_FAST   = 1;
+  final static int DEFLATE_SLOW   = 2;
+
+  final static int GOOD_LENGTH[] = { 0,4, 4, 4, 4, 8,  8,  8,  32,  32 };
+  final static int MAX_LAZY[]    = { 0,4, 5, 6, 4,16, 16, 32, 128, 258 };
+  final static int NICE_LENGTH[] = { 0,8,16,32,16,32,128,128, 258, 258 };
+  final static int MAX_CHAIN[]   = { 0,4, 8,32,16,32,128,256,1024,4096 };
+  final static int COMPR_FUNC[]  = { 0,1, 1, 1, 1, 2,  2,  2,   2,   2 };
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/DeflaterEngine.java kaffe/libraries/javalib/java/util/zip/DeflaterEngine.java
--- kaffe_orig/libraries/javalib/java/util/zip/DeflaterEngine.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/DeflaterEngine.java	2003-09-27 23:01:41.000000000 +1200
@@ -0,0 +1,696 @@
+/* java.util.zip.DeflaterEngine
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
+class DeflaterEngine implements DeflaterConstants {
+  private final static int TOO_FAR = 4096;
+
+  private int ins_h;
+  private byte[] buffer;
+
+  /**
+   * Hashtable, hashing three characters to an index for window, so
+   * that window[index]..window[index+2] have this hash code.  
+   * Note that the array should really be unsigned short, so you need
+   * to and the values with 0xffff.
+   */
+  private short[] head;
+
+  /**
+   * prev[index & WMASK] points to the previous index that has the
+   * same hash code as the string starting at index.  This way 
+   * entries with the same hash code are in a linked list.
+   * Note that the array should really be unsigned short, so you need
+   * to and the values with 0xffff.
+   */
+  private short[] prev;
+
+  private int matchStart, matchLen;
+  private boolean prevAvailable;
+  private int blockStart;
+
+  /**
+   * strstart points to the current character in window.
+   */
+  private int strstart;
+
+  /**
+   * lookahead is the number of characters starting at strstart in
+   * window that are valid.
+   * So window[strstart] until window[strstart+lookahead-1] are valid
+   * characters.
+   */
+  private int lookahead;
+
+  /**
+   * This array contains the part of the uncompressed stream that 
+   * is of relevance.  The current character is indexed by strstart.
+   */
+  private byte[] window;
+
+  private int strategy, max_chain, max_lazy, niceLength, goodLength;
+
+  /** The current compression function. */
+  private int comprFunc;
+
+  /** The input data for compression. */
+  private byte[] inputBuf;
+
+  /** The total bytes of input read. */
+  private int totalIn;
+
+  /** The offset into inputBuf, where input data starts. */
+  private int inputOff;
+
+  /** The end offset of the input data. */
+  private int inputEnd;
+
+  private DeflaterPending pending;
+  private DeflaterHuffman huffman;
+
+  /** The adler checksum */
+  private Adler32 adler;
+
+  /* DEFLATE ALGORITHM:
+   *
+   * The uncompressed stream is inserted into the window array.  When
+   * the window array is full the first half is thrown away and the
+   * second half is copied to the beginning.
+   *
+   * The head array is a hash table.  Three characters build a hash value
+   * and they the value points to the corresponding index in window of 
+   * the last string with this hash.  The prev array implements a
+   * linked list of matches with the same hash: prev[index & WMASK] points
+   * to the previous index with the same hash.
+   * 
+   * 
+   */
+
+
+  DeflaterEngine(DeflaterPending pending) {
+    this.pending = pending;
+    huffman = new DeflaterHuffman(pending);
+    adler = new Adler32();
+
+    window = new byte[2*WSIZE];
+    head   = new short[HASH_SIZE];
+    prev   = new short[WSIZE];
+
+    /* We start at index 1, to avoid a implementation deficiency, that
+     * we cannot build a repeat pattern at index 0.
+     */
+    blockStart = strstart = 1;
+  }
+
+  public void reset()
+  {
+    huffman.reset();
+    adler.reset();
+    blockStart = strstart = 1;
+    lookahead = 0;
+    totalIn = 0;
+    prevAvailable = false;
+    matchLen = MIN_MATCH - 1;
+    for (int i = 0; i < HASH_SIZE; i++)
+      head[i] = 0;
+    for (int i = 0; i < WSIZE; i++)
+      prev[i] = 0;
+  }
+
+  public final void resetAdler()
+  {
+    adler.reset();
+  }
+
+  public final int getAdler()
+  {
+    int chksum = (int) adler.getValue();
+    return chksum;
+  }
+
+  public final int getTotalIn()
+  {
+    return totalIn;
+  }
+
+  public final void setStrategy(int strat)
+  {
+    strategy = strat;
+  }
+
+  public void setLevel(int lvl)
+  {
+    goodLength = DeflaterConstants.GOOD_LENGTH[lvl];
+    max_lazy    = DeflaterConstants.MAX_LAZY[lvl];
+    niceLength = DeflaterConstants.NICE_LENGTH[lvl];
+    max_chain   = DeflaterConstants.MAX_CHAIN[lvl];
+
+    if (DeflaterConstants.COMPR_FUNC[lvl] != comprFunc) 
+      {
+	if (DeflaterConstants.DEBUGGING)
+	  System.err.println("Change from "+comprFunc +" to "
+			     + DeflaterConstants.COMPR_FUNC[lvl]);
+	switch (comprFunc)
+	  {
+	  case DEFLATE_STORED:
+	    if (strstart > blockStart)
+	      {
+		huffman.flushStoredBlock(window, blockStart, 
+					 strstart - blockStart, false);
+		blockStart = strstart;
+	      }
+	    updateHash();
+	    break;
+	  case DEFLATE_FAST:
+	    if (strstart > blockStart)
+	      {
+		huffman.flushBlock(window, blockStart, strstart - blockStart,
+				   false);
+		blockStart = strstart;
+	      }
+	    break;
+	  case DEFLATE_SLOW:
+	    if (prevAvailable)
+	      huffman.tallyLit(window[strstart-1] & 0xff);
+	    if (strstart > blockStart)
+	      {
+		huffman.flushBlock(window, blockStart, strstart - blockStart,
+				   false);
+		blockStart = strstart;
+	      }
+	    prevAvailable = false;
+	    matchLen = MIN_MATCH - 1;
+	    break;
+	  }
+	comprFunc = COMPR_FUNC[lvl];
+      }
+  }
+
+  private final void updateHash() {
+    if (DEBUGGING)
+      System.err.println("updateHash: "+strstart);
+    ins_h = (window[strstart] << HASH_SHIFT) ^ window[strstart + 1];
+  }    
+
+  /**
+   * Inserts the current string in the head hash and returns the previous
+   * value for this hash.
+   */
+  private final int insertString() {
+    short match;
+    int hash = ((ins_h << HASH_SHIFT) ^ window[strstart + (MIN_MATCH -1)])
+      & HASH_MASK;
+
+    if (DEBUGGING)
+      {
+	if (hash != (((window[strstart] << (2*HASH_SHIFT))
+		      ^ (window[strstart + 1] << HASH_SHIFT)
+		      ^ (window[strstart + 2])) & HASH_MASK))
+	  throw new InternalError("hash inconsistent: "+hash+"/"
+				  +window[strstart]+","
+				  +window[strstart+1]+","
+				  +window[strstart+2]+","+HASH_SHIFT);
+      }
+
+    prev[strstart & WMASK] = match = head[hash];
+    head[hash] = (short) strstart;
+    ins_h = hash;
+    return match & 0xffff;
+  }
+
+  private void slideWindow()
+  {
+    System.arraycopy(window, WSIZE, window, 0, WSIZE);
+    matchStart -= WSIZE;
+    strstart -= WSIZE;
+    blockStart -= WSIZE;
+    
+    /* Slide the hash table (could be avoided with 32 bit values
+     * at the expense of memory usage).
+     */
+    for (int i = 0; i < HASH_SIZE; i++) 
+      {
+	int m = head[i] & 0xffff;
+	head[i] = m >= WSIZE ? (short) (m - WSIZE) : 0;
+      }
+
+    /* Slide the prev table.
+     */
+    for (int i = 0; i < WSIZE; i++) 
+      {
+	int m = prev[i] & 0xffff;
+	prev[i] = m >= WSIZE ? (short) (m - WSIZE) : 0;
+      }
+  }
+
+  /**
+   * Fill the window when the lookahead becomes insufficient.
+   * Updates strstart and lookahead.
+   *
+   * OUT assertions: strstart + lookahead <= 2*WSIZE
+   *    lookahead >= MIN_LOOKAHEAD or inputOff == inputEnd
+   */
+  private void fillWindow()
+  {
+    /* If the window is almost full and there is insufficient lookahead,
+     * move the upper half to the lower one to make room in the upper half.
+     */
+    if (strstart >= WSIZE + MAX_DIST)
+      slideWindow();
+
+    /* If there is not enough lookahead, but still some input left,
+     * read in the input
+     */
+    while (lookahead < DeflaterConstants.MIN_LOOKAHEAD && inputOff < inputEnd)
+      {
+	int more = 2*WSIZE - lookahead - strstart;
+	
+	if (more > inputEnd - inputOff)
+	  more = inputEnd - inputOff;
+
+	System.arraycopy(inputBuf, inputOff, 
+			 window, strstart + lookahead, more);
+	adler.update(inputBuf, inputOff, more);
+	inputOff += more;
+	totalIn  += more;
+	lookahead += more;
+      }
+
+    if (lookahead >= MIN_MATCH) 
+      updateHash();
+  }
+
+  /**
+   * Find the best (longest) string in the window matching the 
+   * string starting at strstart.
+   *
+   * Preconditions:
+   *    strstart + MAX_MATCH <= window.length.
+   *    
+   *
+   * @param curMatch
+   */
+  private boolean findLongestMatch(int curMatch) {
+    int chainLength = this.max_chain;
+    int niceLength = this.niceLength;
+    short[] prev = this.prev;
+    int scan  = this.strstart;
+    int match;
+    int best_end = this.strstart + matchLen;
+    int best_len = Math.max(matchLen, MIN_MATCH - 1);
+    
+    int limit = Math.max(strstart - MAX_DIST, 0);
+
+    int strend = scan + MAX_MATCH - 1;
+    byte scan_end1 = window[best_end - 1];
+    byte scan_end  = window[best_end];
+
+    /* Do not waste too much time if we already have a good match: */
+    if (best_len >= this.goodLength)
+      chainLength >>= 2;
+
+    /* Do not look for matches beyond the end of the input. This is necessary
+     * to make deflate deterministic.
+     */
+    if (niceLength > lookahead)
+      niceLength = lookahead;
+
+    if (DeflaterConstants.DEBUGGING 
+	&& strstart > 2*WSIZE - MIN_LOOKAHEAD)
+      throw new InternalError("need lookahead");
+    
+    do {
+      if (DeflaterConstants.DEBUGGING && curMatch >= strstart)
+	throw new InternalError("future match");
+      if (window[curMatch + best_len] != scan_end
+	  || window[curMatch + best_len - 1] != scan_end1
+	  || window[curMatch] != window[scan]
+	  || window[curMatch+1] != window[scan + 1])
+	continue;
+
+      match = curMatch + 2;      
+      scan += 2;
+
+      /* We check for insufficient lookahead only every 8th comparison;
+       * the 256th check will be made at strstart+258.
+       */
+      while (window[++scan] == window[++match]
+	     && window[++scan] == window[++match]
+	     && window[++scan] == window[++match]
+	     && window[++scan] == window[++match]
+	     && window[++scan] == window[++match]
+	     && window[++scan] == window[++match]
+	     && window[++scan] == window[++match]
+	     && window[++scan] == window[++match]
+	     && scan < strend);
+
+      if (scan > best_end) {
+//  	if (DeflaterConstants.DEBUGGING && ins_h == 0)
+//  	  System.err.println("Found match: "+curMatch+"-"+(scan-strstart));
+	matchStart = curMatch;
+	best_end = scan;
+	best_len = scan - strstart;
+	if (best_len >= niceLength)
+	  break;
+
+	scan_end1  = window[best_end-1];
+	scan_end   = window[best_end];
+      }
+      scan = strstart;
+    } while ((curMatch = (prev[curMatch & WMASK] & 0xffff)) > limit
+	     && --chainLength != 0);
+
+    matchLen = Math.min(best_len, lookahead);
+    return matchLen >= MIN_MATCH;
+  }
+
+  void setDictionary(byte[] buffer, int offset, int length) {
+    if (DeflaterConstants.DEBUGGING && strstart != 1)
+      throw new IllegalStateException("strstart not 1");
+    adler.update(buffer, offset, length);
+    if (length < MIN_MATCH)
+      return;
+    if (length > MAX_DIST) {
+      offset += length - MAX_DIST;
+      length = MAX_DIST;
+    }
+
+    System.arraycopy(buffer, offset, window, strstart, length);
+
+    updateHash();
+    length--;
+    while (--length > 0)
+      {
+	insertString();
+	strstart++;
+      }
+    strstart += 2;
+    blockStart = strstart;
+  }    
+    
+  private boolean deflateStored(boolean flush, boolean finish)
+  {
+    if (!flush && lookahead == 0)
+      return false;
+
+    strstart += lookahead;
+    lookahead = 0;
+
+    int storedLen = strstart - blockStart;
+
+    if ((storedLen >= DeflaterConstants.MAX_BLOCK_SIZE) 
+	/* Block is full */
+	|| (blockStart < WSIZE && storedLen >= MAX_DIST)
+	/* Block may move out of window */
+	|| flush)
+      {
+	boolean lastBlock = finish;
+	if (storedLen > DeflaterConstants.MAX_BLOCK_SIZE)
+	  {
+	    storedLen = DeflaterConstants.MAX_BLOCK_SIZE;
+	    lastBlock = false;
+	  }
+
+	if (DeflaterConstants.DEBUGGING)
+	  System.err.println("storedBlock["+storedLen+","+lastBlock+"]");
+
+	huffman.flushStoredBlock(window, blockStart, storedLen, lastBlock);
+	blockStart += storedLen;
+	return !lastBlock;
+      }
+    return true;
+  }
+
+  private boolean deflateFast(boolean flush, boolean finish)
+  {
+    if (lookahead < MIN_LOOKAHEAD && !flush)
+      return false;
+
+    while (lookahead >= MIN_LOOKAHEAD || flush)
+      {
+	if (lookahead == 0)
+	  {
+	    /* We are flushing everything */
+	    huffman.flushBlock(window, blockStart, strstart - blockStart,
+			       finish);
+	    blockStart = strstart;
+	    return false;
+	  }
+
+	if (strstart > 2 * WSIZE - MIN_LOOKAHEAD)
+	  {
+	    /* slide window, as findLongestMatch need this.
+	     * This should only happen when flushing and the window
+	     * is almost full.
+	     */
+	    slideWindow();
+	  }
+
+	int hashHead;
+	if (lookahead >= MIN_MATCH 
+	    && (hashHead = insertString()) != 0
+	    && strategy != Deflater.HUFFMAN_ONLY
+	    && strstart - hashHead <= MAX_DIST
+	    && findLongestMatch(hashHead))
+	  {
+	    /* longestMatch sets matchStart and matchLen */
+	    if (DeflaterConstants.DEBUGGING)
+	      {
+		for (int i = 0 ; i < matchLen; i++)
+		  {
+		    if (window[strstart+i] != window[matchStart + i])
+		      throw new InternalError();
+		  }
+	      }
+	    huffman.tallyDist(strstart - matchStart, matchLen);
+	    
+	    lookahead -= matchLen;
+	    if (matchLen <= max_lazy && lookahead >= MIN_MATCH)
+	      {
+		while (--matchLen > 0)
+		  {
+		    strstart++;
+		    insertString();
+		  }
+		strstart++;
+	      }
+	    else
+	      {
+		strstart += matchLen;
+		if (lookahead >= MIN_MATCH - 1)
+		  updateHash();
+	      }
+	    matchLen = MIN_MATCH - 1;
+	    continue;
+	  }
+	else
+	  {
+	    /* No match found */
+	    huffman.tallyLit(window[strstart] & 0xff);
+	    strstart++;
+	    lookahead--;
+	  }
+
+	if (huffman.isFull())
+	  {
+	    boolean lastBlock = finish && lookahead == 0;
+	    huffman.flushBlock(window, blockStart, strstart - blockStart,
+			       lastBlock);
+	    blockStart = strstart;
+	    return !lastBlock;
+	  }
+      }
+    return true;
+  }
+
+  private boolean deflateSlow(boolean flush, boolean finish)
+  {
+    if (lookahead < MIN_LOOKAHEAD && !flush)
+      return false;
+
+    while (lookahead >= MIN_LOOKAHEAD || flush)
+      {
+	if (lookahead == 0)
+	  {
+	    if (prevAvailable)
+	      huffman.tallyLit(window[strstart-1] & 0xff);
+	    prevAvailable = false;
+
+	    /* We are flushing everything */
+	    if (DeflaterConstants.DEBUGGING && !flush)
+	      throw new InternalError("Not flushing, but no lookahead");
+	    huffman.flushBlock(window, blockStart, strstart - blockStart,
+			       finish);
+	    blockStart = strstart;
+	    return false;
+	  }
+
+	if (strstart >= 2 * WSIZE - MIN_LOOKAHEAD)
+	  {
+	    /* slide window, as findLongestMatch need this.
+	     * This should only happen when flushing and the window
+	     * is almost full.
+	     */
+	    slideWindow();
+	  }
+
+	int prevMatch = matchStart;
+	int prevLen = matchLen;
+	if (lookahead >= MIN_MATCH)
+	  {
+	    int hashHead = insertString();
+	    if (strategy != Deflater.HUFFMAN_ONLY
+		&& hashHead != 0 && strstart - hashHead <= MAX_DIST
+		&& findLongestMatch(hashHead))
+	      {
+		/* longestMatch sets matchStart and matchLen */
+		
+		/* Discard match if too small and too far away */
+		if (matchLen <= 5
+		    && (strategy == Deflater.FILTERED
+			|| (matchLen == MIN_MATCH
+			    && strstart - matchStart > TOO_FAR))) {
+		  matchLen = MIN_MATCH - 1;
+		}
+	      }
+	  }
+	
+	/* previous match was better */
+	if (prevLen >= MIN_MATCH && matchLen <= prevLen)
+	  {
+	    if (DeflaterConstants.DEBUGGING)
+	      {
+		for (int i = 0 ; i < matchLen; i++)
+		  {
+		    if (window[strstart-1+i] != window[prevMatch + i])
+		      throw new InternalError();
+		  }
+	      }
+	    huffman.tallyDist(strstart - 1 - prevMatch, prevLen);
+	    prevLen -= 2;
+	    do 
+	      {
+		strstart++;
+		lookahead--;
+		if (lookahead >= MIN_MATCH)
+		  insertString();
+	      }
+	    while (--prevLen > 0);
+	    strstart ++;
+	    lookahead--;
+	    prevAvailable = false;
+	    matchLen = MIN_MATCH - 1;
+	  }
+	else
+	  {
+	    if (prevAvailable)
+	      huffman.tallyLit(window[strstart-1] & 0xff);
+	    prevAvailable = true;
+	    strstart++;
+	    lookahead--;
+	  }
+
+	if (huffman.isFull())
+	  {
+	    int len = strstart - blockStart;
+	    if (prevAvailable)
+	      len--;
+	    boolean lastBlock = (finish && lookahead == 0 && !prevAvailable);
+	    huffman.flushBlock(window, blockStart, len, lastBlock);
+	    blockStart += len;
+	    return !lastBlock;
+	  }
+      }
+    return true;
+  } 
+
+  public boolean deflate(boolean flush, boolean finish) 
+  {
+    boolean progress;
+    do
+      {
+	fillWindow();
+	boolean canFlush = flush && inputOff == inputEnd;
+	if (DeflaterConstants.DEBUGGING)
+	  System.err.println("window: ["+blockStart+","+strstart+","
+			     +lookahead+"], "+comprFunc+","+canFlush);
+	switch (comprFunc)
+	  {
+	  case DEFLATE_STORED:
+	    progress = deflateStored(canFlush, finish);
+	    break;
+	  case DEFLATE_FAST:
+	    progress = deflateFast(canFlush, finish);
+	    break;
+	  case DEFLATE_SLOW:
+	    progress = deflateSlow(canFlush, finish);
+	    break;
+	  default:
+	    throw new InternalError();
+	  }
+      }
+    while (pending.isFlushed()  /* repeat while we have no pending output */
+	   && progress);        /* and progress was made */
+
+    return progress;
+  }
+
+  public void setInput(byte[] buf, int off, int len)
+  {
+    if (inputOff < inputEnd)
+      throw new IllegalStateException
+	("Old input was not completely processed");
+
+    int end = off + len;
+
+    /* We want to throw an ArrayIndexOutOfBoundsException early.  The
+     * check is very tricky: it also handles integer wrap around.  
+     */
+    if (0 > off || off > end || end > buf.length)
+      throw new ArrayIndexOutOfBoundsException();
+
+    inputBuf = buf;
+    inputOff = off;
+    inputEnd = end;
+  }
+
+  public final boolean needsInput()
+  {
+    return inputEnd == inputOff;
+  }
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/DeflaterHuffman.java kaffe/libraries/javalib/java/util/zip/DeflaterHuffman.java
--- kaffe_orig/libraries/javalib/java/util/zip/DeflaterHuffman.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/DeflaterHuffman.java	2003-09-27 23:01:41.000000000 +1200
@@ -0,0 +1,777 @@
+/* java.util.zip.DeflaterHuffman
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
+/**
+ * This is the DeflaterHuffman class.
+ *
+ * This class is <i>not</i> thread safe.  This is inherent in the API, due
+ * to the split of deflate and setInput.
+ *
+ * @author Jochen Hoenicke
+ * @date Jan 6, 2000 
+ */
+class DeflaterHuffman
+{
+  private static final int BUFSIZE = 1 << (DeflaterConstants.DEFAULT_MEM_LEVEL + 6);
+  private static final int LITERAL_NUM = 286;
+  private static final int DIST_NUM = 30;
+  private static final int BITLEN_NUM = 19;
+  private static final int REP_3_6    = 16;
+  private static final int REP_3_10   = 17;
+  private static final int REP_11_138 = 18;
+  private static final int EOF_SYMBOL = 256;
+  private static final int[] BL_ORDER =
+  { 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15 };
+
+  private final static String bit4Reverse =
+    "\000\010\004\014\002\012\006\016\001\011\005\015\003\013\007\017";
+
+  class Tree {
+    short[] freqs;
+    short[] codes;
+    byte[]  length;
+    int[]   bl_counts;
+    int     minNumCodes, numCodes;
+    int     maxLength;
+
+    Tree(int elems, int minCodes, int maxLength) {
+      this.minNumCodes = minCodes;
+      this.maxLength  = maxLength;
+      freqs  = new short[elems];
+      bl_counts = new int[maxLength];
+    }
+
+    void reset() {
+      for (int i = 0; i < freqs.length; i++)
+	freqs[i] = 0;
+      codes = null;
+      length = null;
+    }
+
+    final void writeSymbol(int code)
+    {
+      if (DeflaterConstants.DEBUGGING)
+ 	{
+ 	  freqs[code]--;
+//  	  System.err.print("writeSymbol("+freqs.length+","+code+"): ");
+ 	}
+      pending.writeBits(codes[code] & 0xffff, length[code]);
+    }
+
+    final void checkEmpty()
+    {
+      boolean empty = true;
+      for (int i = 0; i < freqs.length; i++)
+	if (freqs[i] != 0)
+	  {
+	    System.err.println("freqs["+i+"] == "+freqs[i]);
+	    empty = false;
+	  }
+      if (!empty)
+	throw new InternalError();
+      System.err.println("checkEmpty suceeded!");
+    }
+
+    void setStaticCodes(short[] stCodes, byte[] stLength)
+    {
+      codes = stCodes;
+      length = stLength;
+    }
+
+    public void buildCodes() {
+      int numSymbols = freqs.length;
+      int[] nextCode = new int[maxLength];
+      int code = 0;
+      codes = new short[freqs.length];
+
+      if (DeflaterConstants.DEBUGGING)
+	System.err.println("buildCodes: "+freqs.length);
+      for (int bits = 0; bits < maxLength; bits++) 
+	{
+	  nextCode[bits] = code;
+	  code += bl_counts[bits] << (15 - bits);
+	  if (DeflaterConstants.DEBUGGING)
+	    System.err.println("bits: "+(bits+1)+" count: "+bl_counts[bits]
+			       +" nextCode: "+Integer.toHexString(code));
+	}
+      if (DeflaterConstants.DEBUGGING && code != 65536)
+	throw new RuntimeException("Inconsistent bl_counts!");
+      
+      for (int i=0; i < numCodes; i++)
+	{
+	  int bits = length[i];
+	  if (bits > 0)
+	    {
+	      if (DeflaterConstants.DEBUGGING)
+		System.err.println("codes["+i+"] = rev("
+				   +Integer.toHexString(nextCode[bits-1])+"),"
+				   +bits);
+	      codes[i] = bitReverse(nextCode[bits-1]);
+	      nextCode[bits-1] += 1 << (16 - bits);
+	    }
+	}
+    }
+
+    private void buildLength(int childs[])
+    {
+      this.length = new byte [freqs.length];
+      int numNodes = childs.length / 2;
+      int numLeafs = (numNodes + 1) / 2;
+      int overflow = 0;
+      
+      for (int i = 0; i < maxLength; i++)
+	bl_counts[i] = 0;
+
+      /* First calculate optimal bit lengths */
+      int lengths[] = new int[numNodes];
+      lengths[numNodes-1] = 0;
+      for (int i = numNodes - 1; i >= 0; i--)
+	{
+	  if (childs[2*i+1] != -1)
+	    {
+	      int bitLength = lengths[i] + 1;
+	      if (bitLength > maxLength)
+		{
+		  bitLength = maxLength;
+		  overflow++;
+		}
+	      lengths[childs[2*i]] = lengths[childs[2*i+1]] = bitLength;
+	    }
+	  else
+	    {
+	      /* A leaf node */
+	      int bitLength = lengths[i];
+	      bl_counts[bitLength - 1]++;
+	      this.length[childs[2*i]] = (byte) lengths[i];
+	    }
+	}
+      
+      if (DeflaterConstants.DEBUGGING)
+	{
+	  System.err.println("Tree "+freqs.length+" lengths:");
+	  for (int i=0; i < numLeafs; i++)
+	    System.err.println("Node "+childs[2*i]+" freq: "+freqs[childs[2*i]]
+			       + " len: "+length[childs[2*i]]);
+	}
+      
+      if (overflow == 0)
+	return;
+      
+      int incrBitLen = maxLength - 1;
+      do
+	{
+	  /* Find the first bit length which could increase: */
+	  while (bl_counts[--incrBitLen] == 0)
+	    ;
+	  
+	  /* Move this node one down and remove a corresponding
+	   * amount of overflow nodes.
+	   */
+	  do
+	    {
+	      bl_counts[incrBitLen]--;
+	      bl_counts[++incrBitLen]++;
+	      overflow -= 1 << (maxLength - 1 - incrBitLen);
+	    }
+	  while (overflow > 0 && incrBitLen < maxLength - 1);
+	}
+      while (overflow > 0);
+
+      /* We may have overshot above.  Move some nodes from maxLength to
+       * maxLength-1 in that case.
+       */
+      bl_counts[maxLength-1] += overflow;
+      bl_counts[maxLength-2] -= overflow;
+      
+      /* Now recompute all bit lengths, scanning in increasing
+       * frequency.  It is simpler to reconstruct all lengths instead of
+       * fixing only the wrong ones. This idea is taken from 'ar'
+       * written by Haruhiko Okumura.
+       *
+       * The nodes were inserted with decreasing frequency into the childs
+       * array.
+       */
+      int nodePtr = 2 * numLeafs;
+      for (int bits = maxLength; bits != 0; bits--) 
+	{
+	  int n = bl_counts[bits-1];
+	  while (n > 0) 
+	    {
+	      int childPtr = 2*childs[nodePtr++];
+	      if (childs[childPtr + 1] == -1)
+		{
+		  /* We found another leaf */
+		  length[childs[childPtr]] = (byte) bits;
+		  n--;
+		}
+	    }
+	}
+      if (DeflaterConstants.DEBUGGING)
+	{
+	  System.err.println("*** After overflow elimination. ***");
+	  for (int i=0; i < numLeafs; i++)
+	    System.err.println("Node "+childs[2*i]+" freq: "+freqs[childs[2*i]]
+			       + " len: "+length[childs[2*i]]);
+	}
+    }
+    
+    void buildTree() 
+    {
+      int numSymbols = freqs.length;
+
+      /* heap is a priority queue, sorted by frequency, least frequent
+       * nodes first.  The heap is a binary tree, with the property, that
+       * the parent node is smaller than both child nodes.  This assures
+       * that the smallest node is the first parent.
+       *
+       * The binary tree is encoded in an array:  0 is root node and
+       * the nodes 2*n+1, 2*n+2 are the child nodes of node n.
+       */
+      int[] heap = new int[numSymbols];
+      int heapLen = 0;
+      int maxCode = 0;
+      for (int n = 0; n < numSymbols; n++)
+	{
+	  int freq = freqs[n];
+	  if (freq != 0)
+	    {
+	      /* Insert n into heap */
+	      int pos = heapLen++;
+	      int ppos;
+	      while (pos > 0 &&
+		     freqs[heap[ppos = (pos - 1) / 2]] > freq) {
+		heap[pos] = heap[ppos];
+		pos = ppos;
+	      }
+	      heap[pos] = n;
+	      maxCode = n;
+	    }
+	}
+      
+      /* We could encode a single literal with 0 bits but then we
+       * don't see the literals.  Therefore we force at least two
+       * literals to avoid this case.  We don't care about order in
+       * this case, both literals get a 1 bit code.  
+       */
+      while (heapLen < 2)
+	{
+	  int node = maxCode < 2 ? ++maxCode : 0;
+	  heap[heapLen++] = node;
+	}
+
+      numCodes = Math.max(maxCode + 1, minNumCodes);
+      
+      int numLeafs = heapLen;
+      int[] childs = new int[4*heapLen - 2];
+      int[] values = new int[2*heapLen - 1];
+      int numNodes = numLeafs;
+      for (int i = 0; i < heapLen; i++)
+	{
+	  int node = heap[i];
+	  childs[2*i]   = node;
+	  childs[2*i+1] = -1;
+	  values[i] = freqs[node] << 8;
+	  heap[i] = i;
+	}
+      
+      /* Construct the Huffman tree by repeatedly combining the least two
+       * frequent nodes.
+       */
+      do
+	{
+	  int first = heap[0];
+	  int last  = heap[--heapLen];
+	  
+	  /* Propagate the hole to the leafs of the heap */
+	  int ppos = 0;
+	  int path = 1;
+	  while (path < heapLen)
+	    {
+	      if (path + 1 < heapLen 
+		  && values[heap[path]] > values[heap[path+1]])
+		path++;
+	      
+	      heap[ppos] = heap[path];
+	      ppos = path;
+	      path = path * 2 + 1;
+	    }
+	  
+	  /* Now propagate the last element down along path.  Normally
+	   * it shouldn't go too deep.
+	   */
+	  int lastVal = values[last];
+	  while ((path = ppos) > 0
+		 && values[heap[ppos = (path - 1)/2]] > lastVal)
+	    heap[path] = heap[ppos];
+	  heap[path] = last;
+	  
+	  
+	  int second = heap[0];
+	  
+	  /* Create a new node father of first and second */
+	  last = numNodes++;
+	  childs[2*last] = first;
+	  childs[2*last+1] = second;
+	  int mindepth = Math.min(values[first] & 0xff, values[second] & 0xff);
+	  values[last] = lastVal = values[first] + values[second] - mindepth + 1;
+	  
+	  /* Again, propagate the hole to the leafs */
+	  ppos = 0;
+	  path = 1;
+	  while (path < heapLen)
+	    {
+	      if (path + 1 < heapLen 
+		  && values[heap[path]] > values[heap[path+1]])
+		path++;
+	      
+	      heap[ppos] = heap[path];
+	      ppos = path;
+	      path = ppos * 2 + 1;
+	    }
+	  
+	  /* Now propagate the new element down along path */
+	  while ((path = ppos) > 0
+		 && values[heap[ppos = (path - 1)/2]] > lastVal)
+	    heap[path] = heap[ppos];
+	  heap[path] = last;
+	}
+      while (heapLen > 1);
+      
+      if (heap[0] != childs.length / 2 - 1)
+	throw new RuntimeException("Weird!");
+      
+      buildLength(childs);
+    }
+
+    int getEncodedLength() 
+    {
+      int len = 0;
+      for (int i = 0; i < freqs.length; i++)
+	len += freqs[i] * length[i];
+      return len;
+    }
+
+    void calcBLFreq(Tree blTree) {
+      int max_count;               /* max repeat count */
+      int min_count;               /* min repeat count */
+      int count;                   /* repeat count of the current code */
+      int curlen = -1;             /* length of current code */
+      
+      int i = 0;
+      while (i < numCodes)
+	{
+	  count = 1;
+	  int nextlen = length[i];
+	  if (nextlen == 0) 
+	    {
+	      max_count = 138;
+	      min_count = 3;
+	    }
+	  else
+	    {
+	      max_count = 6;
+	      min_count = 3;
+	      if (curlen != nextlen)
+		{
+		  blTree.freqs[nextlen]++;
+		  count = 0;
+		}
+	    }
+	  curlen = nextlen;
+	  i++;
+
+	  while (i < numCodes && curlen == length[i])
+	    {
+	      i++;
+	      if (++count >= max_count)
+		break;
+	    }
+
+	  if (count < min_count)
+	    blTree.freqs[curlen] += count;
+	  else if (curlen != 0)
+	    blTree.freqs[REP_3_6]++;
+	  else if (count <= 10)
+	    blTree.freqs[REP_3_10]++;
+	  else
+	    blTree.freqs[REP_11_138]++;
+	}
+    }
+
+    void writeTree(Tree blTree)
+    {
+      int max_count;               /* max repeat count */
+      int min_count;               /* min repeat count */
+      int count;                   /* repeat count of the current code */
+      int curlen = -1;             /* length of current code */
+      
+      int i = 0;
+      while (i < numCodes)
+	{
+	  count = 1;
+	  int nextlen = length[i];
+	  if (nextlen == 0) 
+	    {
+	      max_count = 138;
+	      min_count = 3;
+	    }
+	  else
+	    {
+	      max_count = 6;
+	      min_count = 3;
+	      if (curlen != nextlen)
+		{
+		  blTree.writeSymbol(nextlen);
+		  count = 0;
+		}
+	    }
+	  curlen = nextlen;
+	  i++;
+
+	  while (i < numCodes && curlen == length[i])
+	    {
+	      i++;
+	      if (++count >= max_count)
+		break;
+	    }
+
+	  if (count < min_count)
+	    {
+	      while (count-- > 0)
+		blTree.writeSymbol(curlen);
+	    }
+	  else if (curlen != 0)
+	    {
+	      blTree.writeSymbol(REP_3_6);
+	      pending.writeBits(count - 3, 2);
+	    }
+	  else if (count <= 10)
+	    {
+	      blTree.writeSymbol(REP_3_10);
+	      pending.writeBits(count - 3, 3);
+	    }
+	  else
+	    {
+	      blTree.writeSymbol(REP_11_138);
+	      pending.writeBits(count - 11, 7);
+	    }
+	}
+    }
+  }
+
+
+
+  DeflaterPending pending;
+  private Tree literalTree, distTree, blTree;
+
+  private short d_buf[];
+  private byte l_buf[];
+  private int last_lit;
+  private int extra_bits;
+
+  private static short staticLCodes[];
+  private static byte  staticLLength[];
+  private static short staticDCodes[];
+  private static byte  staticDLength[];
+
+  /**
+   * Reverse the bits of a 16 bit value.
+   */
+  static short bitReverse(int value) {
+    return (short) (bit4Reverse.charAt(value & 0xf) << 12
+		    | bit4Reverse.charAt((value >> 4) & 0xf) << 8
+		    | bit4Reverse.charAt((value >> 8) & 0xf) << 4
+		    | bit4Reverse.charAt(value >> 12));
+  }
+
+  static {
+    /* See RFC 1951 3.2.6 */
+    /* Literal codes */
+    staticLCodes = new short[LITERAL_NUM];
+    staticLLength = new byte[LITERAL_NUM];
+    int i = 0;
+    while (i < 144) {
+      staticLCodes[i] = bitReverse((0x030 + i) << 8);
+      staticLLength[i++] = 8;
+    }
+    while (i < 256) {
+      staticLCodes[i] = bitReverse((0x190 - 144 + i) << 7);
+      staticLLength[i++] = 9;
+    }
+    while (i < 280) {
+      staticLCodes[i] = bitReverse((0x000 - 256 + i) << 9);
+      staticLLength[i++] = 7;
+    }
+    while (i < LITERAL_NUM) {
+      staticLCodes[i] = bitReverse((0x0c0 - 280 + i)  << 8);
+      staticLLength[i++] = 8;
+    }
+
+    /* Distant codes */
+    staticDCodes = new short[DIST_NUM];
+    staticDLength = new byte[DIST_NUM];
+    for (i = 0; i < DIST_NUM; i++) {
+      staticDCodes[i] = bitReverse(i << 11);
+      staticDLength[i] = 5;
+    }
+  }
+    
+  public DeflaterHuffman(DeflaterPending pending) 
+  {
+    this.pending = pending;
+
+    literalTree = new Tree(LITERAL_NUM, 257, 15);
+    distTree    = new Tree(DIST_NUM, 1, 15);
+    blTree      = new Tree(BITLEN_NUM, 4, 7);
+
+    d_buf = new short[BUFSIZE];
+    l_buf = new byte [BUFSIZE];
+  }
+
+  public final void reset() {
+    last_lit = 0;
+    extra_bits = 0;
+    literalTree.reset();
+    distTree.reset();
+    blTree.reset();
+  }
+
+  private final int l_code(int len) {
+    if (len == 255)
+      return 285;
+
+    int code = 257;
+    while (len >= 8)
+      {
+	code += 4;
+	len >>= 1;
+      }
+    return code + len;
+  }
+
+  private final int d_code(int distance) {
+    int code = 0;
+    while (distance >= 4)
+      {
+	code += 2;
+	distance >>= 1;
+      }
+    return code + distance;
+  }
+
+  public void sendAllTrees(int blTreeCodes) {
+    blTree.buildCodes();
+    literalTree.buildCodes();
+    distTree.buildCodes();
+    pending.writeBits(literalTree.numCodes - 257, 5);
+    pending.writeBits(distTree.numCodes - 1, 5);
+    pending.writeBits(blTreeCodes - 4, 4);
+    for (int rank = 0; rank < blTreeCodes; rank++)
+      pending.writeBits(blTree.length[BL_ORDER[rank]], 3);
+    literalTree.writeTree(blTree);
+    distTree.writeTree(blTree);
+    if (DeflaterConstants.DEBUGGING)
+      blTree.checkEmpty();
+  }
+
+  public void compressBlock() {
+    for (int i = 0; i < last_lit; i++) 
+      {
+	int litlen = l_buf[i] & 0xff;
+	int dist = d_buf[i];
+	if (dist-- != 0)
+	  {
+	    if (DeflaterConstants.DEBUGGING)
+	      System.err.print("["+(dist+1)+","+(litlen+3)+"]: ");
+
+	    int lc = l_code(litlen);
+	    literalTree.writeSymbol(lc);
+
+	    int bits = (lc - 261) / 4;
+	    if (bits > 0 && bits <= 5)
+	      pending.writeBits(litlen & ((1 << bits) - 1), bits);
+
+	    int dc = d_code(dist);
+	    distTree.writeSymbol(dc);
+
+	    bits = dc / 2 - 1;
+	    if (bits > 0)
+	      pending.writeBits(dist & ((1 << bits) - 1), bits);
+	  }
+	else
+	  {
+	    if (DeflaterConstants.DEBUGGING)
+	      {
+		if (litlen > 32 && litlen < 127)
+		  System.err.print("("+(char)litlen+"): ");
+		else
+		  System.err.print("{"+litlen+"}: ");
+	      }
+	    literalTree.writeSymbol(litlen);
+	  }
+      }
+    if (DeflaterConstants.DEBUGGING)
+      System.err.print("EOF: ");
+    literalTree.writeSymbol(EOF_SYMBOL);
+    if (DeflaterConstants.DEBUGGING)
+      {
+	literalTree.checkEmpty();
+	distTree.checkEmpty();
+      }
+  }
+
+  public void flushStoredBlock(byte[] stored, 
+			       int stored_offset, int stored_len,
+			       boolean lastBlock) {
+    if (DeflaterConstants.DEBUGGING)
+      System.err.println("Flushing stored block "+ stored_len);
+    pending.writeBits((DeflaterConstants.STORED_BLOCK << 1)
+		      + (lastBlock ? 1 : 0), 3);
+    pending.alignToByte();
+    pending.writeShort(stored_len);
+    pending.writeShort(~stored_len);
+    pending.writeBlock(stored, stored_offset, stored_len);
+    reset();
+  }
+
+  public void flushBlock(byte[] stored, int stored_offset, int stored_len,
+			 boolean lastBlock) {
+    literalTree.freqs[EOF_SYMBOL]++;
+
+    /* Build trees */
+    literalTree.buildTree();
+    distTree.buildTree();
+
+    /* Calculate bitlen frequency */
+    literalTree.calcBLFreq(blTree);
+    distTree.calcBLFreq(blTree);
+
+    /* Build bitlen tree */
+    blTree.buildTree();
+
+    int blTreeCodes = 4;
+    for (int i = 18; i > blTreeCodes; i--)
+      {
+	if (blTree.length[BL_ORDER[i]] > 0)
+	  blTreeCodes = i+1;
+      }
+    int opt_len = 14 + blTreeCodes * 3 + blTree.getEncodedLength()
+      + literalTree.getEncodedLength() + distTree.getEncodedLength()
+      + extra_bits;
+
+    int static_len = extra_bits;
+    for (int i = 0; i < LITERAL_NUM; i++)
+      static_len += literalTree.freqs[i] * staticLLength[i];
+    for (int i = 0; i < DIST_NUM; i++)
+      static_len += distTree.freqs[i] * staticDLength[i];
+    if (opt_len >= static_len)
+      {
+	/* Force static trees */
+	opt_len = static_len;
+      }
+
+    if (stored_offset >= 0 && stored_len+4 < opt_len >> 3)
+      {
+	/* Store Block */
+	if (DeflaterConstants.DEBUGGING)
+	  System.err.println("Storing, since " + stored_len + " < " + opt_len
+			     + " <= " + static_len);
+	flushStoredBlock(stored, stored_offset, stored_len, lastBlock);
+      }
+    else if (opt_len == static_len)
+      {
+	/* Encode with static tree */
+	pending.writeBits((DeflaterConstants.STATIC_TREES << 1)
+			  + (lastBlock ? 1 : 0), 3);
+	literalTree.setStaticCodes(staticLCodes, staticLLength);
+	distTree.setStaticCodes(staticDCodes, staticDLength);
+	compressBlock();
+	reset();
+      }
+    else
+      {
+	/* Encode with dynamic tree */
+	pending.writeBits((DeflaterConstants.DYN_TREES << 1)
+			  + (lastBlock ? 1 : 0), 3);
+	sendAllTrees(blTreeCodes);
+	compressBlock();
+	reset();
+      }
+  }
+
+  public final boolean isFull()
+  {
+    return last_lit == BUFSIZE;
+  }
+
+  public final boolean tallyLit(int lit) 
+  {
+    if (DeflaterConstants.DEBUGGING)
+      {
+	if (lit > 32 && lit < 127)
+	  System.err.println("("+(char)lit+")");
+	else
+	  System.err.println("{"+lit+"}");
+      }
+    d_buf[last_lit] = 0;
+    l_buf[last_lit++] = (byte) lit;
+    literalTree.freqs[lit]++;
+    return last_lit == BUFSIZE;
+  }
+
+  public final boolean tallyDist(int dist, int len) 
+  {
+    if (DeflaterConstants.DEBUGGING)
+      System.err.println("["+dist+","+len+"]");
+
+    d_buf[last_lit] = (short) dist;
+    l_buf[last_lit++] = (byte) (len - 3);
+
+    int lc = l_code(len-3);
+    literalTree.freqs[lc]++;
+    if (lc >= 265 && lc < 285)
+      extra_bits += (lc - 261) / 4;
+
+    int dc = d_code(dist-1);
+    distTree.freqs[dc]++;
+    if (dc >= 4)
+      extra_bits += dc / 2 - 1;
+    return last_lit == BUFSIZE;
+  }
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/DeflaterOutputStream.java kaffe/libraries/javalib/java/util/zip/DeflaterOutputStream.java
--- kaffe_orig/libraries/javalib/java/util/zip/DeflaterOutputStream.java	2002-01-04 18:12:27.000000000 +1300
+++ kaffe/libraries/javalib/java/util/zip/DeflaterOutputStream.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,78 +1,198 @@
+/* java.util.zip.DeflaterOutputStream
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
 package java.util.zip;
 
 import java.io.FilterOutputStream;
-import java.io.IOException;
 import java.io.OutputStream;
+import java.io.IOException;
+
+/* Written using on-line Java Platform 1.2 API Specification
+ * and JCL book.
+ * Believed complete and correct.
+ */
 
-/*
- * Java core library component.
+/**
+ * This is a special FilterOutputStream deflating the bytes that are
+ * written through it.  It uses the Deflater for deflating.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * A special thing to be noted is that flush() doesn't flush
+ * everything in Sun's JDK, but it does so in jazzlib. This is because
+ * Sun's Deflater doesn't have a way to flush() everything, without
+ * finishing the stream.
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
+ * @author Tom Tromey, Jochen Hoenicke
+ * @date Jan 11, 2001 
  */
-public class DeflaterOutputStream
-  extends FilterOutputStream
+public class DeflaterOutputStream extends FilterOutputStream
 {
-	final private static int DEFAULT = 512;
-	protected Deflater def;
-	protected byte[] buf;
-
-public DeflaterOutputStream(OutputStream out) {
-	this(out, new Deflater(), DEFAULT);
-}
-
-public DeflaterOutputStream(OutputStream out, Deflater defx) {
-	this(out, defx, DEFAULT);
-}
-
-public DeflaterOutputStream(OutputStream out, Deflater defx, int size) {
-	super(out);
-	if (out == null)
-	  throw new NullPointerException("out");
-	if (defx == null)
-	  throw new NullPointerException("def");
-	def = defx;
-	if (size < 1)
-	  throw new IllegalArgumentException("size < 1");
-	buf = new byte[size];
-}
-
-public void close() throws IOException {
-	finish();
-	super.close();
-}
-
-protected void deflate() throws IOException {
-	do {
-		int r = def.deflate(buf, 0, buf.length);
-		super.write(buf, 0, r);
-	} while (!def.needsInput());
-}
-
-public void finish() throws IOException {
-	def.finish();
-	while (!def.finished()) {
-		deflate();
-	}
-}
-
-public void write(byte b[], int off, int len) throws IOException {
-	if (off < 0 || len < 0 || off + len > b.length)
-		throw new IndexOutOfBoundsException();
-	
-	if(len != 0) {
-		def.setInput(b, off, len);
-		deflate();
-	}
-}
-
-public void write(int b) throws IOException {
-	byte a[] = new byte[1];
-	a[0] = (byte)b;
-	write(a, 0, 1);
-}
-
+  /** 
+   * This buffer is used temporarily to retrieve the bytes from the
+   * deflater and write them to the underlying output stream.  
+   */
+  protected byte[] buf;
+
+  /** 
+   * The deflater which is used to deflate the stream.
+   */
+  protected Deflater def;
+
+  /**
+   * Deflates everything in the def's input buffers.  This will call
+   * <code>def.deflate()</code> until all bytes from the input buffers
+   * are processed.
+   */
+  protected void deflate () throws IOException
+  {
+    while (! def.needsInput())
+      {
+	int len = def.deflate(buf, 0, buf.length);
+
+	//	System.err.println("DOS deflated " + len + " out of " + buf.length);
+	if (len <= 0)
+	  break;
+	out.write(buf, 0, len);
+      }
+
+    if (! def.needsInput())
+      throw new InternalError("Can't deflate all input?");
+  }
+
+  /** 
+   * Creates a new DeflaterOutputStream with a default Deflater and
+   * default buffer size.
+   * @param out the output stream where deflated output should be written.
+   */
+  public DeflaterOutputStream (OutputStream out)
+  {
+    this (out, new Deflater (), 512);
+  }
+
+  /** 
+   * Creates a new DeflaterOutputStream with the given Deflater and
+   * default buffer size.
+   * @param out the output stream where deflated output should be written.
+   * @param defl the underlying deflater.
+   */
+  public DeflaterOutputStream (OutputStream out, Deflater defl)
+  {
+    this (out, defl, 512);
+  }
+
+  /** 
+   * Creates a new DeflaterOutputStream with the given Deflater and
+   * buffer size.
+   * @param out the output stream where deflated output should be written.
+   * @param defl the underlying deflater.
+   * @param bufsize the buffer size.
+   * @exception IllegalArgumentException if bufsize isn't positive.
+   */
+  public DeflaterOutputStream(OutputStream out, Deflater defl, int bufsize)
+  {
+    super (out);
+    if (bufsize <= 0)
+      throw new IllegalArgumentException("bufsize <= 0");
+    buf = new byte[bufsize];
+    def = defl;
+  }
+
+  /**  
+   * Flushes the stream by calling flush() on the deflater and then
+   * on the underlying stream.  This ensures that all bytes are
+   * flushed.  This function doesn't work in Sun's JDK, but only in
+   * jazzlib.
+   */
+  public void flush() throws IOException
+  {
+    def.flush();
+    deflate();
+    out.flush();
+  }
+
+  /**
+   * Finishes the stream by calling finish() on the deflater.  This
+   * was the only way to ensure that all bytes are flushed in Sun's
+   * JDK.  
+   */
+  public void finish () throws IOException
+  {
+    def.finish();
+    while (! def.finished ())
+      {
+	int len = def.deflate(buf, 0, buf.length);
+	if (len <= 0)
+	  break;
+	out.write(buf, 0, len);
+      }
+    if (! def.finished())
+      throw new InternalError("Can't deflate all input?");
+    out.flush();
+  }
+
+  /**
+   * Calls finish () and closes the stream. 
+   */
+  public void close() throws IOException
+  {
+    finish();
+    out.close();
+  }
+
+  /**
+   * Writes a single byte to the compressed output stream.
+   * @param bval the byte value.
+   */
+  public void write(int bval) throws IOException
+  {
+    byte[] b = new byte[1];
+    b[0] = (byte) bval;
+    write(b, 0, 1);
+  }
+
+  /**
+   * Writes a len bytes from an array to the compressed stream.
+   * @param buf the byte array.
+   * @param off the offset into the byte array where to start.
+   * @param len the number of bytes to write.
+   */
+  public void write(byte[] buf, int off, int len) throws IOException
+  {
+    //    System.err.println("DOS with off " + off + " and len " + len);
+    def.setInput(buf, off, len);
+    deflate();
+  }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/DeflaterPending.java kaffe/libraries/javalib/java/util/zip/DeflaterPending.java
--- kaffe_orig/libraries/javalib/java/util/zip/DeflaterPending.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/DeflaterPending.java	2003-09-27 23:01:41.000000000 +1200
@@ -0,0 +1,54 @@
+/* java.util.zip.DeflaterPending
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
+/**
+ * This class stores the pending output of the Deflater.
+ *
+ * @author Jochen Hoenicke
+ * @date Jan 5, 2000 
+ */
+
+class DeflaterPending extends PendingBuffer
+{
+  public DeflaterPending()
+  {
+    super(DeflaterConstants.PENDING_BUF_SIZE);
+  }
+}
+
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/GZIPInputStream.java kaffe/libraries/javalib/java/util/zip/GZIPInputStream.java
--- kaffe_orig/libraries/javalib/java/util/zip/GZIPInputStream.java	2002-08-17 06:04:31.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/GZIPInputStream.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,118 +1,372 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* java.util.zip.GZIPInputStream
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.zip;
 
 import java.io.InputStream;
 import java.io.IOException;
+import java.io.EOFException;
 
-public class GZIPInputStream extends InflaterInputStream {
-
-protected CRC32 crc;
-protected boolean eos;
-private InputStream strm;
-
-public static final int GZIP_MAGIC		= 0x1f8b;
-static final int OLD_GZIP_MAGIC		= 0x1f9e;
-
-static final int GZIP_FLAG_ASCII_FLAG	= 0x01;	// probably ascii text
-static final int GZIP_FLAG_CONTINUATION	= 0x02;	// continuation of
-							//  multi-part gzip file
-static final int GZIP_FLAG_EXTRA_FIELD	= 0x04;	// extra field present
-static final int GZIP_FLAG_ORIG_NAME	= 0x08;	// file name present
-static final int GZIP_FLAG_COMMENT	= 0x10;	// file comment present
-static final int GZIP_FLAG_ENCRYPTED	= 0x20;	// file is encrypted
-static final int GZIP_FLAG_RESERVED	= 0xc0;	// must be zero
-
-public GZIPInputStream(InputStream in) throws IOException {
-	this(in, 512);
-}
-
-public GZIPInputStream(InputStream in, int readsize) throws IOException {
-	super(in, new Inflater(true), readsize);
-	strm = in;
-	crc = new CRC32();
-	eos = false;
-
-        /* Check GZIP header */
-        checkBytes(new int[] { GZIP_MAGIC >> 8, OLD_GZIP_MAGIC >> 8 });
-        checkBytes(new int[] { GZIP_MAGIC & 0xff, OLD_GZIP_MAGIC & 0xff });
-        checkBytes(new int[] { Deflater.DEFLATED });
-
-	/* Get flags byte */
-	int flags = checkBytes(null);
-
-	/* Skip time stamp, extra flags, and O/S fields */
-        ignoreBytes(6);
-
-	/* Check flags */
-	if ((flags & GZIP_FLAG_CONTINUATION) != 0) {	// skip multi-part #
-		ignoreBytes(2);
-	}
-	if ((flags & GZIP_FLAG_EXTRA_FIELD) != 0) {	// skip extra fields
-		int len = strm.read();
-		len |= strm.read() << 8;
-		ignoreBytes(len);
-	}
-	if ((flags & GZIP_FLAG_ORIG_NAME) != 0) {	// skip name
-		ignoreString();
-	}
-	if ((flags & GZIP_FLAG_COMMENT) != 0) {		// skip comment
-		ignoreString();
-	}
-}
-
-private int checkBytes(int[] v) throws IOException {
-	int i, x = strm.read();
-	if (v != null) {
-		for (i = 0; i < v.length && x != v[i]; i++)
-			;
-		if (i == v.length) {
-			throw new IOException("invalid GZIP stream");
-		}
-	}
-	return x;
-}
-
-private void ignoreBytes(int nr) throws IOException {
-	for (; nr > 0; nr--) {
-		strm.read();
-	}
-}
-
-private void ignoreString() throws IOException {
-	int x;
-	while ((x = strm.read()) != 0) {
-		if (x == -1) {
-			throw new IOException("premature GZIP end-of-file");
-		}
-	}
-}
-
-public void close() throws IOException {
-	super.close();
-}
-
-public int read(byte[] buf, int off, int len) throws IOException {
-	int total = super.read(buf, off, len);
-	if (total > 0) {
-		crc.update(buf, off, total);
-	}
-	else if (total == -1) {
-		if (!eos) {
-			eos = true;
-			// Skip the tail on the GZIP
-			ignoreBytes(8);
-		}
-	}
-	return (total);
-}
 
+/**
+ * This filter stream is used to decompress a "GZIP" format stream. 
+ * The "GZIP" format is described in RFC 1952.
+ *
+ * @author John Leuner
+ * @since JDK 1.1
+ */
+public class GZIPInputStream
+  extends InflaterInputStream
+{
+  /**
+   * The magic number found at the start of a GZIP stream.
+   */
+  public static final int GZIP_MAGIC = 0x1f8b;
+
+
+  /**
+   * The mask for bit 0 of the flag byte.
+   */
+  static final int FTEXT = 0x1;
+
+
+  /**
+   * The mask for bit 1 of the flag byte.
+   */
+  static final int FHCRC = 0x2;
+
+
+  /**
+   * The mask for bit 2 of the flag byte.
+   */
+  static final int FEXTRA = 0x4;
+
+
+  /**
+   * The mask for bit 3 of the flag byte.
+   */
+  static final int FNAME = 0x8;
+
+
+  /**
+   * The mask for bit 4 of the flag byte.
+   */
+  static final int FCOMMENT = 0x10;
+
+
+  /**
+   * The CRC-32 checksum value for uncompressed data.
+   */
+  protected CRC32 crc; 
+
+
+  /**
+   * Indicates whether or not the end of the stream has been reached.
+   */  
+  protected boolean eos;
+
+
+  /**
+   * Indicates whether or not the GZIP header has been read in.
+   */
+  private boolean readGZIPHeader;
+
+
+  /**
+   * Creates a GZIPInputStream with the default buffer size.
+   *
+   * @param in The stream to read compressed data from 
+   *           (in GZIP format).
+   *
+   * @throws IOException if an error occurs during an I/O operation.
+   */
+  public GZIPInputStream(InputStream in)
+    throws IOException
+  {
+    this(in, 4096);
+  }
+
+
+  /**
+   * Creates a GZIPInputStream with the specified buffer size.
+   *
+   * @param in The stream to read compressed data from 
+   *           (in GZIP format).
+   *
+   * @param size The size of the buffer to use.
+   *
+   * @throws IOException if an error occurs during an I/O operation.
+   *
+   * @throws java.lang.IllegalArgumentException if <code>size</code>
+   *         is less than or equal to 0.
+   */
+  public GZIPInputStream(InputStream in, int size)
+    throws IOException
+  {
+    super(in, new Inflater(true), size);
+    crc = new CRC32();
+  }
+
+
+  /**
+   * Closes the input stream.
+   *
+   * @throws IOException if an error occurs during an I/O operation.
+   */
+  public void close()
+    throws IOException
+  {
+    super.close();
+  }
+
+
+  /**
+   * Reads in GZIP-compressed data and stores it in uncompressed form
+   * into an array of bytes.  The method will block until either
+   * enough input data becomes available or the compressed stream
+   * reaches its end.
+   *
+   * @param buf the buffer into which the uncompressed data will
+   *            be stored.
+   *
+   * @param offset the offset indicating where in <code>buf</code>
+   *               the uncompressed data should be placed.
+   *
+   * @param len the number of uncompressed bytes to be read.
+   */
+  public int read(byte[] buf, int offset, int len) throws IOException
+  {
+    // We first have to slurp in the GZIP header, then we feed all the
+    // rest of the data to the superclass.
+    //
+    // As we do that we continually update the CRC32. Once the data is
+    // finished, we check the CRC32.
+    //
+    // This means we don't need our own buffer, as everything is done
+    // in the superclass.
+    if (!readGZIPHeader)
+      readHeader();
+
+    if (eos)
+      return -1;
+
+    //  System.err.println("GZIPIS.read(byte[], off, len ... " + offset + " and len " + len);
+
+    /* We don't have to read the header,
+     * so we just grab data from the superclass.
+     */
+    int numRead = super.read(buf, offset, len);
+    if (numRead > 0)
+      crc.update(buf, offset, numRead);
+
+    if (inf.finished())
+      readFooter();
+    return numRead;
+  }
+
+
+  /**
+   * Reads in the GZIP header.
+   */
+  private void readHeader() throws IOException
+  {
+    /* 1. Check the two magic bytes */
+    CRC32 headCRC = new CRC32();
+    int magic = in.read();
+    if (magic < 0)
+    {
+      eos = true;
+      return;
+    }
+    headCRC.update(magic);
+    if (magic != (GZIP_MAGIC >> 8))
+      throw new IOException("Error in GZIP header, first byte doesn't match");
+    
+    magic = in.read();
+    if (magic != (GZIP_MAGIC & 0xff))
+      throw new IOException("Error in GZIP header, second byte doesn't match");
+    headCRC.update(magic);
+    
+    /* 2. Check the compression type (must be 8) */
+    int CM = in.read();
+    if (CM != 8)
+      throw new IOException("Error in GZIP header, data not in deflate format");
+    headCRC.update(CM);
+
+    /* 3. Check the flags */
+    int flags = in.read();
+    if (flags < 0)
+      throw new EOFException("Early EOF in GZIP header");
+    headCRC.update(flags);
+    
+    /*    This flag byte is divided into individual bits as follows:
+	  
+	  bit 0   FTEXT
+	  bit 1   FHCRC
+	  bit 2   FEXTRA
+	  bit 3   FNAME
+	  bit 4   FCOMMENT
+	  bit 5   reserved
+	  bit 6   reserved
+	  bit 7   reserved
+    */
+    
+    /* 3.1 Check the reserved bits are zero */    
+    if ((flags & 0xd0) != 0)
+      throw new IOException("Reserved flag bits in GZIP header != 0");
+    
+    /* 4.-6. Skip the modification time, extra flags, and OS type */
+    for (int i=0; i< 6; i++)
+    {
+      int readByte = in.read();
+      if (readByte < 0)
+	throw new EOFException("Early EOF in GZIP header");
+      headCRC.update(readByte);
+    }
+    
+    /* 7. Read extra field */
+    if ((flags & FEXTRA) != 0)
+    {
+      /* Skip subfield id */
+      for (int i=0; i< 2; i++)
+      {
+        int readByte = in.read();
+	if (readByte < 0)
+	  throw new EOFException("Early EOF in GZIP header");
+	headCRC.update(readByte);
+      }
+      if (in.read() < 0 || in.read() < 0)
+	throw new EOFException("Early EOF in GZIP header");
+	
+      int len1, len2, extraLen;
+      len1 = in.read();
+      len2 = in.read();
+      if ((len1 < 0) || (len2 < 0))
+	throw new EOFException("Early EOF in GZIP header");
+      headCRC.update(len1);
+      headCRC.update(len2);
+
+      extraLen = (len1 << 8) | len2;
+      for (int i = 0; i < extraLen;i++)
+      {
+	int readByte = in.read();
+	if (readByte < 0)
+	  throw new EOFException("Early EOF in GZIP header");
+	headCRC.update(readByte);
+      }
+    }
+    
+    /* 8. Read file name */
+    if ((flags & FNAME) != 0)
+    {
+      int readByte;
+      while ( (readByte = in.read()) > 0)
+	headCRC.update(readByte);
+      if (readByte < 0)
+	throw new EOFException("Early EOF in GZIP file name");
+      headCRC.update(readByte);
+    }
+
+    /* 9. Read comment */
+    if ((flags & FCOMMENT) != 0)
+    {
+      int readByte;
+      while ( (readByte = in.read()) > 0)
+        headCRC.update(readByte);
+
+      if (readByte < 0)
+        throw new EOFException("Early EOF in GZIP comment");
+      headCRC.update(readByte);
+    }
+    
+    /* 10. Read header CRC */
+    if ((flags & FHCRC) != 0)
+    {
+      int tempByte;
+      int crcval = in.read();
+      if (crcval < 0)
+        throw new EOFException("Early EOF in GZIP header");
+	
+      tempByte = in.read();
+      if (tempByte < 0)
+        throw new EOFException("Early EOF in GZIP header");
+	
+      crcval = (crcval << 8) | tempByte;
+      if (crcval != ((int) headCRC.getValue() & 0xffff))
+        throw new IOException("Header CRC value mismatch");
+    }
+    
+    readGZIPHeader = true;
+    //System.err.println("Read GZIP header");
+  }
+
+
+  private void readFooter() throws IOException
+  {
+    byte[] footer = new byte[8];
+    int avail = inf.getRemaining();
+    if (avail > 8)
+      avail = 8;
+    System.arraycopy(buf, len - inf.getRemaining(), footer, 0, avail);
+    int needed = 8 - avail;
+    while (needed > 0)
+    {
+      int count = in.read(footer, 8-needed, needed);
+      if (count <= 0)
+	throw new EOFException("Early EOF in GZIP footer");
+      needed -= count; //Jewel Jan 16
+    }
+
+    int crcval = (footer[0] & 0xff) | ((footer[1] & 0xff) << 8)
+      | ((footer[2] & 0xff) << 16) | (footer[3] << 24);
+    if (crcval != (int) crc.getValue())
+      throw new IOException("GZIP crc sum mismatch, theirs \""
+			    + Integer.toHexString(crcval)
+			    + "\" and ours \""
+			    + Integer.toHexString( (int) crc.getValue()));
+
+    int total = (footer[4] & 0xff) | ((footer[5] & 0xff) << 8)
+      | ((footer[6] & 0xff) << 16) | (footer[7] << 24);
+    if (total != inf.getTotalOut())
+      throw new IOException("Number of bytes mismatch");
+
+    /* FIXME" XXX Should we support multiple members.
+     * Difficult, since there may be some bytes still in buf
+     */
+    eos = true;
+  }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/GZIPOutputStream.java kaffe/libraries/javalib/java/util/zip/GZIPOutputStream.java
--- kaffe_orig/libraries/javalib/java/util/zip/GZIPOutputStream.java	1998-10-01 11:48:34.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/GZIPOutputStream.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,78 +1,152 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
-
-package java.util.zip;
-
-import java.io.OutputStream;
-import java.io.IOException;
-
-public class GZIPOutputStream extends DeflaterOutputStream {
+/* java.util.zip.GZIPOutputStream
+   Copyright (C) 2001 Free Software Foundation, Inc.
 
-protected CRC32 crc;
-private int count;
-private OutputStream strm;
+This file is part of GNU Classpath.
 
-public GZIPOutputStream(OutputStream out) throws IOException {
-        this(out, 512);
-}
-
-public GZIPOutputStream(OutputStream out, int readsize) throws IOException {
-        super(out, new Deflater(Deflater.DEFAULT_COMPRESSION, true), readsize);
-	strm = out;
-	crc = new CRC32();
-	count = 0;
-
-	/* Write GZIP header */
-	writeByte(31);	// GZIP identifier
-	writeByte(139);	//  "
-	writeByte(8);	// Deflating
-	writeByte(0);	// No extra bits
-	writeInt(0);	// No time stamp
-	writeByte(2);	// Maximum compression, slowest algorithm
-	writeByte(255);	// Unknown OS
-}
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-public void close() throws IOException {
-	finish();
-	super.close();
-}
-
-public void finish() throws IOException {
-	super.finish();
-	// Make sure we only do this once.
-	if (count > -1) {
-		writeInt((int)crc.getValue());
-		writeInt(count);
-		count = -1;
-	}
-}
+package java.util.zip;
 
-private void writeInt(int v) throws IOException {
-	byte[] buf = new byte[4];
-	buf[0] = (byte)v;
-	buf[1] = (byte)(v >> 8);
-	buf[2] = (byte)(v >> 16);
-	buf[3] = (byte)(v >> 24);
-	strm.write(buf);
-}
+import java.io.IOException;
+import java.io.OutputStream;
 
-private void writeByte(int v) throws IOException {
-	byte[] buf = new byte[1];
-	buf[0] = (byte)v;
-	strm.write(buf);
-}
+/**
+ * This filter stream is used to compress a stream into a "GZIP" stream. 
+ * The "GZIP" format is described in RFC 1952.
+ *
+ * @author John Leuner
+ * @since JDK 1.1
+ */
 
-public void write(byte[] buf, int off, int len) throws IOException {
-	super.write(buf, off, len);
-	crc.update(buf, off, len);
-	count += len;
-}
 
+public class GZIPOutputStream extends DeflaterOutputStream
+{
+  //Variables
+
+  /* CRC-32 value for uncompressed data
+   */
+  
+  protected CRC32 crc = new CRC32(); 
+
+  // Constructors
+
+  /* Creates a GZIPOutputStream with the default buffer size
+   *
+   *
+   * @param out The stream to read data (to be compressed) from 
+   * 
+   */
+
+  public GZIPOutputStream(OutputStream out)  throws IOException
+  {
+    this(out, 4096);
+  }
+
+  /* Creates a GZIPOutputStream with the specified buffer size
+   *
+   *
+   * @param out The stream to read compressed data from 
+   * 
+   * @param size Size of the buffer to use 
+   */
+
+  public GZIPOutputStream(OutputStream out, int size)  throws IOException
+  {
+    super(out, new Deflater(Deflater.DEFAULT_COMPRESSION, true), size);
+    
+    int mod_time = (int) (System.currentTimeMillis() / 1000L);
+    byte[] gzipHeader =
+      {
+	/* The two magic bytes */
+	(byte) (GZIPInputStream.GZIP_MAGIC >> 8),
+	(byte) GZIPInputStream.GZIP_MAGIC,
+	  
+	/* The compression type */
+	(byte) Deflater.DEFLATED,
+	
+        /* The flags (not set) */
+	0,
+	
+	/* The modification time */
+	(byte) mod_time, (byte) (mod_time >> 8), 
+	(byte) (mod_time >> 16), (byte) (mod_time >> 24), 
+
+	/* The extra flags */
+	0,
+    
+	/* The OS type (unknown) */
+	(byte) 255
+      };
+
+    out.write(gzipHeader);
+    //    System.err.println("wrote GZIP header (" + gzipHeader.length + " bytes )");
+  }
+  
+  public void write(byte[] buf, int off, int len) throws IOException
+  {
+    crc.update(buf, off, len);
+    super.write(buf, off, len);
+  }
+  
+  /** Writes remaining compressed output data to the output stream
+   * and closes it.
+   */
+  public void close() throws IOException
+  {
+    finish();
+    out.close();
+  }
+
+  public void finish() throws IOException
+  {
+
+    super.finish();
+
+    int totalin = def.getTotalIn();
+    int crcval = (int) (crc.getValue() & 0xffffffff);
+
+    //    System.err.println("CRC val is " + Integer.toHexString( crcval ) 		       + " and length " + Integer.toHexString(totalin));
+    
+    byte[] gzipFooter = 
+      {
+	(byte) crcval, (byte) (crcval >> 8),
+	(byte) (crcval >> 16), (byte) (crcval >> 24),
+
+	(byte) totalin, (byte) (totalin >> 8),
+	(byte) (totalin >> 16), (byte) (totalin >> 24)
+      };
+
+    out.write(gzipFooter);
+  //    System.err.println("wrote GZIP trailer (" + gzipFooter.length + " bytes )");    
+  }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/Inflater.java kaffe/libraries/javalib/java/util/zip/Inflater.java
--- kaffe_orig/libraries/javalib/java/util/zip/Inflater.java	2002-08-17 06:04:31.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/Inflater.java	2003-09-27 23:05:40.000000000 +1200
@@ -1,111 +1,726 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
-
-package java.util.zip;
-
-public class Inflater {
-
-  static {
-    System.loadLibrary("zip");
-  }
-
-  private int strm;
-  protected byte[] buf;
-  protected int off;
-  protected int len;
-  private boolean finished;
-  private boolean needsDictionary;
-
-  public Inflater(boolean nowrap)
-  {
-    init(nowrap);
-  }
-
-  public Inflater()
-  {
-    this(false);
-  }
-
-  public synchronized void setInput(byte b[], int o, int l)
-  {
-    buf = b;
-    off = o;
-    len = l;
-  }
-
-  public void setInput(byte b[])
-  {
-    setInput(b, 0, b.length);
-  }
-
-  public void setDictionary(byte b[])
-  {
-    setDictionary(b, 0, b.length);
-  }
+/* Inflater.java - Decompress a data stream
+   Copyright (C) 1999, 2000, 2001, 2003  Free Software Foundation, Inc.
 
-  public synchronized int getRemaining()
-  {
-    return (len);
-  }
+This file is part of GNU Classpath.
 
-  public synchronized boolean needsInput()
-  {
-    return (len == 0 && !finished());
-  }
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-  public synchronized boolean needsDictionary()
-  {
-    return (needsDictionary);
-  }
+package java.util.zip;
 
-  public synchronized boolean finished()
-  {
-    return (finished);
-  }
+/* Written using on-line Java Platform 1.2 API Specification
+ * and JCL book.
+ * Believed complete and correct.
+ */
 
-  public int inflate(byte b[]) throws DataFormatException
+/**
+ * Inflater is used to decompress data that has been compressed according 
+ * to the "deflate" standard described in rfc1950.
+ *
+ * The usage is as following.  First you have to set some input with
+ * <code>setInput()</code>, then inflate() it.  If inflate doesn't
+ * inflate any bytes there may be three reasons:
+ * <ul>
+ * <li>needsInput() returns true because the input buffer is empty.
+ * You have to provide more input with <code>setInput()</code>.  
+ * NOTE: needsInput() also returns true when, the stream is finished.
+ * </li>
+ * <li>needsDictionary() returns true, you have to provide a preset 
+ *     dictionary with <code>setDictionary()</code>.</li>
+ * <li>finished() returns true, the inflater has finished.</li>
+ * </ul>
+ * Once the first output byte is produced, a dictionary will not be
+ * needed at a later stage.
+ *
+ * @author John Leuner, Jochen Hoenicke
+ * @author Tom Tromey
+ * @date May 17, 1999
+ * @since JDK 1.1
+ */
+public class Inflater
+{
+  /* Copy lengths for literal codes 257..285 */
+  private static final int CPLENS[] = 
+  { 
+    3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
+    35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258
+  };
+  
+  /* Extra bits for literal codes 257..285 */  
+  private static final int CPLEXT[] = 
+  { 
+    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2,
+    3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0
+  };
+
+  /* Copy offsets for distance codes 0..29 */
+  private static final int CPDIST[] = {
+    1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
+    257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
+    8193, 12289, 16385, 24577
+  };
+  
+  /* Extra bits for distance codes */
+  private static final int CPDEXT[] = {
+    0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6,
+    7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 
+    12, 12, 13, 13
+  };
+
+  /* This are the state in which the inflater can be.  */
+  private static final int DECODE_HEADER           = 0;
+  private static final int DECODE_DICT             = 1;
+  private static final int DECODE_BLOCKS           = 2;
+  private static final int DECODE_STORED_LEN1      = 3;
+  private static final int DECODE_STORED_LEN2      = 4;
+  private static final int DECODE_STORED           = 5;
+  private static final int DECODE_DYN_HEADER       = 6;
+  private static final int DECODE_HUFFMAN          = 7;
+  private static final int DECODE_HUFFMAN_LENBITS  = 8;
+  private static final int DECODE_HUFFMAN_DIST     = 9;
+  private static final int DECODE_HUFFMAN_DISTBITS = 10;
+  private static final int DECODE_CHKSUM           = 11;
+  private static final int FINISHED                = 12;
+
+  /** This variable contains the current state. */
+  private int mode;
+
+  /**
+   * The adler checksum of the dictionary or of the decompressed
+   * stream, as it is written in the header resp. footer of the
+   * compressed stream.  <br>
+   *
+   * Only valid if mode is DECODE_DICT or DECODE_CHKSUM.
+   */
+  private int readAdler;
+  /** 
+   * The number of bits needed to complete the current state.  This
+   * is valid, if mode is DECODE_DICT, DECODE_CHKSUM,
+   * DECODE_HUFFMAN_LENBITS or DECODE_HUFFMAN_DISTBITS.  
+   */
+  private int neededBits;
+  private int repLength, repDist;
+  private int uncomprLen;
+  /**
+   * True, if the last block flag was set in the last block of the
+   * inflated stream.  This means that the stream ends after the
+   * current block.  
+   */
+  private boolean isLastBlock;
+
+  /**
+   * The total number of inflated bytes.
+   */
+  private int totalOut;
+  /**
+   * The total number of bytes set with setInput().  This is not the
+   * value returned by getTotalIn(), since this also includes the 
+   * unprocessed input.
+   */
+  private int totalIn;
+  /**
+   * This variable stores the nowrap flag that was given to the constructor.
+   * True means, that the inflated stream doesn't contain a header nor the
+   * checksum in the footer.
+   */
+  private boolean nowrap;
+
+  private StreamManipulator input;
+  private OutputWindow outputWindow;
+  private InflaterDynHeader dynHeader;
+  private InflaterHuffmanTree litlenTree, distTree;
+  private Adler32 adler;
+
+	/*
+	 *
+	 * Len, Buf, Off we need for compatibility with kaffe's SwitchInflater.java
+	 *
+	 */
+	protected int Len, Off;
+	protected byte[] Buf;
+
+  /**
+   * Creates a new inflater.
+   */
+  public Inflater ()
+  {
+    this (false);
+  }
+
+  /**
+   * Creates a new inflater.
+   * @param nowrap true if no header and checksum field appears in the
+   * stream.  This is used for GZIPed input.  For compatibility with
+   * Sun JDK you should provide one byte of input more than needed in
+   * this case.
+   */
+  public Inflater (boolean nowrap)
+  {
+    this.nowrap = nowrap;
+    this.adler = new Adler32();
+    input = new StreamManipulator();
+    outputWindow = new OutputWindow();
+    mode = nowrap ? DECODE_BLOCKS : DECODE_HEADER;
+  }
+
+  /**
+   * Finalizes this object.
+   */
+  protected void finalize ()
+  {
+    /* Exists only for compatibility */
+  }
+
+  /**
+   * Frees all objects allocated by the inflater.  There's no reason
+   * to call this, since you can just rely on garbage collection (even
+   * for the Sun implementation).  Exists only for compatibility
+   * with Sun's JDK, where the compressor allocates native memory.
+   * If you call any method (even reset) afterwards the behaviour is
+   * <i>undefined</i>.  
+   * @deprecated Just clear all references to inflater instead.
+   */
+  public void end ()
+  {
+    outputWindow = null;
+    input = null;
+    dynHeader = null;
+    litlenTree = null;
+    distTree = null;
+    adler = null;
+  }
+
+  /**
+   * Returns true, if the inflater has finished.  This means, that no
+   * input is needed and no output can be produced.
+   */
+  public boolean finished() 
+  {
+    return mode == FINISHED && outputWindow.getAvailable() == 0;
+  }
+
+  /**
+   * Gets the adler checksum.  This is either the checksum of all
+   * uncompressed bytes returned by inflate(), or if needsDictionary()
+   * returns true (and thus no output was yet produced) this is the
+   * adler checksum of the expected dictionary.
+   * @returns the adler checksum.
+   */
+  public int getAdler()
+  {
+    return needsDictionary() ? readAdler : (int) adler.getValue();
+  }
+  
+  /**
+   * Gets the number of unprocessed input.  Useful, if the end of the
+   * stream is reached and you want to further process the bytes after
+   * the deflate stream.  
+   * @return the number of bytes of the input which were not processed.
+   */
+  public int getRemaining()
+  {
+    return input.getAvailableBytes();
+  }
+  
+  /**
+   * Gets the total number of processed compressed input bytes.
+   * @return the total number of bytes of processed input bytes.
+   */
+  public int getTotalIn()
+  {
+    return totalIn - getRemaining();
+  }
+
+  /**
+   * Gets the total number of output bytes returned by inflate().
+   * @return the total number of output bytes.
+   */
+  public int getTotalOut()
+  {
+    return totalOut;
+  }
+
+  /**
+   * Inflates the compressed stream to the output buffer.  If this
+   * returns 0, you should check, whether needsDictionary(),
+   * needsInput() or finished() returns true, to determine why no 
+   * further output is produced.
+   * @param buffer the output buffer.
+   * @return the number of bytes written to the buffer, 0 if no further
+   * output can be produced.  
+   * @exception DataFormatException if deflated stream is invalid.
+   * @exception IllegalArgumentException if buf has length 0.
+   */
+  public int inflate (byte[] buf) throws DataFormatException
+  {
+    return inflate (buf, 0, buf.length);
+  }
+
+  /**
+   * Inflates the compressed stream to the output buffer.  If this
+   * returns 0, you should check, whether needsDictionary(),
+   * needsInput() or finished() returns true, to determine why no 
+   * further output is produced.
+   * @param buffer the output buffer.
+   * @param off the offset into buffer where the output should start.
+   * @param len the maximum length of the output.
+   * @return the number of bytes written to the buffer, 0 if no further
+   * output can be produced.  
+   * @exception DataFormatException if deflated stream is invalid.
+   * @exception IndexOutOfBoundsException if the off and/or len are wrong.
+   */
+  public int inflate (byte[] buf, int off, int len) throws DataFormatException
   {
-    try {
-      return (inflate(b, 0, b.length));
-    }
-    catch (NullPointerException _) {
-      throw new DataFormatException("null buffer");
-    }
-  }
-
-  public synchronized int inflate(byte b[], int off, int length) throws DataFormatException {
-    if (getRemaining() == 0) {
+    /* Special case: len may be zero */
+    if (len == 0)
       return 0;
-    }
-
-    return inflate0(b, off, length);
-  }
-
-  protected void finalize() throws Throwable
-  {
-    /* We don't need to call super.finalize(),
-     * since super class is java.lang.Object, and
-     * java.lang.Object.finalize() just returns
-     * to caller.
+    /* Check for correct buff, off, len triple */
+    if (0 > off || off > off + len || off + len > buf.length)
+      throw new ArrayIndexOutOfBoundsException();
+    int count = 0;
+    int more;
+    do
+      {
+	if (mode != DECODE_CHKSUM)
+	  {
+	    /* Don't give away any output, if we are waiting for the
+	     * checksum in the input stream.
+	     *
+	     * With this trick we have always:
+	     *   needsInput() and not finished() 
+	     *   implies more output can be produced.  
+	     */
+	    more = outputWindow.copyOutput(buf, off, len);
+	    adler.update(buf, off, more);
+	    off += more;
+	    count += more;
+	    totalOut += more;
+	    len -= more;
+	    if (len == 0)
+	      return count;
+	  }
+      }
+    while (decode() || (outputWindow.getAvailable() > 0
+			&& mode != DECODE_CHKSUM));
+    return count;
+  }
+
+  /**
+   * Returns true, if a preset dictionary is needed to inflate the input.
+   */
+  public boolean needsDictionary ()
+  {
+    return mode == DECODE_DICT && neededBits == 0;
+  }
+
+  /**
+   * Returns true, if the input buffer is empty.
+   * You should then call setInput(). <br>
+   *
+   * <em>NOTE</em>: This method also returns true when the stream is finished.
+   */
+  public boolean needsInput () 
+  {
+    return input.needsInput ();
+  }
+
+  /**
+   * Resets the inflater so that a new stream can be decompressed.  All
+   * pending input and output will be discarded.
+   */
+  public void reset ()
+  {
+    mode = nowrap ? DECODE_BLOCKS : DECODE_HEADER;
+    totalIn = totalOut = 0;
+    input.reset();
+    outputWindow.reset();
+    dynHeader = null;
+    litlenTree = null;
+    distTree = null;
+    isLastBlock = false;
+    adler.reset();
+  }
+
+  /**
+   * Sets the preset dictionary.  This should only be called, if
+   * needsDictionary() returns true and it should set the same
+   * dictionary, that was used for deflating.  The getAdler()
+   * function returns the checksum of the dictionary needed.
+   * @param buffer the dictionary.
+   * @exception IllegalStateException if no dictionary is needed.
+   * @exception IllegalArgumentException if the dictionary checksum is
+   * wrong.  
+   */
+  public void setDictionary (byte[] buffer)
+  {
+    setDictionary(buffer, 0, buffer.length);
+  }
+
+  /**
+   * Sets the preset dictionary.  This should only be called, if
+   * needsDictionary() returns true and it should set the same
+   * dictionary, that was used for deflating.  The getAdler()
+   * function returns the checksum of the dictionary needed.
+   * @param buffer the dictionary.
+   * @param off the offset into buffer where the dictionary starts.
+   * @param len the length of the dictionary.
+   * @exception IllegalStateException if no dictionary is needed.
+   * @exception IllegalArgumentException if the dictionary checksum is
+   * wrong.  
+   * @exception IndexOutOfBoundsException if the off and/or len are wrong.
+   */
+  public void setDictionary (byte[] buffer, int off, int len)
+  {
+    if (!needsDictionary())
+      throw new IllegalStateException();
+
+    adler.update(buffer, off, len);
+    if ((int) adler.getValue() != readAdler)
+      throw new IllegalArgumentException("Wrong adler checksum");
+    adler.reset();
+    outputWindow.copyDict(buffer, off, len);
+    mode = DECODE_BLOCKS;
+  }
+
+  /**
+   * Sets the input.  This should only be called, if needsInput()
+   * returns true.
+   * @param buffer the input.
+   * @exception IllegalStateException if no input is needed.
+   */
+  public void setInput (byte[] buf) 
+  {
+    setInput (buf, 0, buf.length);
+  }
+
+  /**
+   * Sets the input.  This should only be called, if needsInput()
+   * returns true.
+   * @param buffer the input.
+   * @param off the offset into buffer where the input starts.
+   * @param len the length of the input.  
+   * @exception IllegalStateException if no input is needed.
+   * @exception IndexOutOfBoundsException if the off and/or len are wrong.
+   */
+  public void setInput (byte[] buf, int off, int len) 
+  {
+    input.setInput (buf, off, len);
+    totalIn += len;
+		Buf = buf;
+		Off = off;
+		Len = len;
+  }
+
+  /**
+   * Decodes the deflate header.
+   * @return false if more input is needed. 
+   * @exception DataFormatException if header is invalid.
+   */
+  private boolean decodeHeader () throws DataFormatException
+  {
+    int header = input.peekBits(16);
+    if (header < 0)
+      return false;
+    input.dropBits(16);
+    
+    /* The header is written in "wrong" byte order */
+    header = ((header << 8) | (header >> 8)) & 0xffff;
+    if (header % 31 != 0)
+      throw new DataFormatException("Header checksum illegal");
+    
+    if ((header & 0x0f00) != (Deflater.DEFLATED << 8))
+      throw new DataFormatException("Compression Method unknown");
+
+    /* Maximum size of the backwards window in bits. 
+     * We currently ignore this, but we could use it to make the
+     * inflater window more space efficient. On the other hand the
+     * full window (15 bits) is needed most times, anyway.
+     int max_wbits = ((header & 0x7000) >> 12) + 8;
      */
-
-    end();
+    
+    if ((header & 0x0020) == 0) // Dictionary flag?
+      {
+	mode = DECODE_BLOCKS;
+      }
+    else
+      {
+	mode = DECODE_DICT;
+	neededBits = 32;      
+      }
+    return true;
+  }
+   
+  /**
+   * Decodes the dictionary checksum after the deflate header.
+   * @return false if more input is needed. 
+   */
+  private boolean decodeDict ()
+  {
+    while (neededBits > 0)
+      {
+	int dictByte = input.peekBits(8);
+	if (dictByte < 0)
+	  return false;
+	input.dropBits(8);
+	readAdler = (readAdler << 8) | dictByte;
+	neededBits -= 8;
+      }
+    return false;
+  }
+
+  /**
+   * Decodes the huffman encoded symbols in the input stream.
+   * @return false if more input is needed, true if output window is
+   * full or the current block ends.
+   * @exception DataFormatException if deflated stream is invalid.  
+   */
+  private boolean decodeHuffman () throws DataFormatException
+  {
+    int free = outputWindow.getFreeSpace();
+    while (free >= 258)
+      {
+	int symbol;
+	switch (mode)
+	  {
+	  case DECODE_HUFFMAN:
+	    /* This is the inner loop so it is optimized a bit */
+	    while (((symbol = litlenTree.getSymbol(input)) & ~0xff) == 0)
+	      {
+		outputWindow.write(symbol);
+		if (--free < 258)
+		  return true;
+	      } 
+	    if (symbol < 257)
+	      {
+		if (symbol < 0)
+		  return false;
+		else
+		  {
+		    /* symbol == 256: end of block */
+		    distTree = null;
+		    litlenTree = null;
+		    mode = DECODE_BLOCKS;
+		    return true;
+		  }
+	      }
+		
+	    try
+	      {
+		repLength = CPLENS[symbol - 257];
+		neededBits = CPLEXT[symbol - 257];
+	      }
+	    catch (ArrayIndexOutOfBoundsException ex)
+	      {
+		throw new DataFormatException("Illegal rep length code");
+	      }
+	    /* fall through */
+	  case DECODE_HUFFMAN_LENBITS:
+	    if (neededBits > 0)
+	      {
+		mode = DECODE_HUFFMAN_LENBITS;
+		int i = input.peekBits(neededBits);
+		if (i < 0)
+		  return false;
+		input.dropBits(neededBits);
+		repLength += i;
+	      }
+	    mode = DECODE_HUFFMAN_DIST;
+	    /* fall through */
+	  case DECODE_HUFFMAN_DIST:
+	    symbol = distTree.getSymbol(input);
+	    if (symbol < 0)
+	      return false;
+	    try 
+	      {
+		repDist = CPDIST[symbol];
+		neededBits = CPDEXT[symbol];
+	      }
+	    catch (ArrayIndexOutOfBoundsException ex)
+	      {
+		throw new DataFormatException("Illegal rep dist code");
+	      }
+	    /* fall through */
+	  case DECODE_HUFFMAN_DISTBITS:
+	    if (neededBits > 0)
+	      {
+		mode = DECODE_HUFFMAN_DISTBITS;
+		int i = input.peekBits(neededBits);
+		if (i < 0)
+		  return false;
+		input.dropBits(neededBits);
+		repDist += i;
+	      }
+	    outputWindow.repeat(repLength, repDist);
+	    free -= repLength;
+	    mode = DECODE_HUFFMAN;
+	    break;
+	  default:
+	    throw new IllegalStateException();
+	  }
+      }
+    return true;
+  }
+
+  /**
+   * Decodes the adler checksum after the deflate stream.
+   * @return false if more input is needed. 
+   * @exception DataFormatException if checksum doesn't match.
+   */
+  private boolean decodeChksum () throws DataFormatException
+  {
+    while (neededBits > 0)
+      {
+	int chkByte = input.peekBits(8);
+	if (chkByte < 0)
+	  return false;
+	input.dropBits(8);
+	readAdler = (readAdler << 8) | chkByte;
+	neededBits -= 8;
+      }
+    if ((int) adler.getValue() != readAdler)
+      throw new DataFormatException("Adler chksum doesn't match: "
+				    +Integer.toHexString((int)adler.getValue())
+				    +" vs. "+Integer.toHexString(readAdler));
+    mode = FINISHED;
+    return false;
+  }
+
+  /**
+   * Decodes the deflated stream.
+   * @return false if more input is needed, or if finished. 
+   * @exception DataFormatException if deflated stream is invalid.
+   */
+  private boolean decode () throws DataFormatException
+  {
+    switch (mode) 
+      {
+      case DECODE_HEADER:
+	return decodeHeader();
+      case DECODE_DICT:
+	return decodeDict();
+      case DECODE_CHKSUM:
+	return decodeChksum();
+
+      case DECODE_BLOCKS:
+	if (isLastBlock)
+	  {
+	    if (nowrap)
+	      {
+		mode = FINISHED;
+		return false;
+	      }
+	    else
+	      {
+		input.skipToByteBoundary();
+		neededBits = 32;
+		mode = DECODE_CHKSUM;
+		return true;
+	      }
+	  }
+
+	int type = input.peekBits(3);
+	if (type < 0)
+	  return false;
+	input.dropBits(3);
+
+	if ((type & 1) != 0)
+	  isLastBlock = true;
+	switch (type >> 1)
+	  {
+	  case DeflaterConstants.STORED_BLOCK:
+	    input.skipToByteBoundary();
+	    mode = DECODE_STORED_LEN1;
+	    break;
+	  case DeflaterConstants.STATIC_TREES:
+	    litlenTree = InflaterHuffmanTree.defLitLenTree;
+	    distTree = InflaterHuffmanTree.defDistTree;
+	    mode = DECODE_HUFFMAN;
+	    break;
+	  case DeflaterConstants.DYN_TREES:
+	    dynHeader = new InflaterDynHeader();
+	    mode = DECODE_DYN_HEADER;
+	    break;
+	  default:
+	    throw new DataFormatException("Unknown block type "+type);
+	  }
+	return true;
+
+      case DECODE_STORED_LEN1:
+	{
+	  if ((uncomprLen = input.peekBits(16)) < 0)
+	    return false;
+	  input.dropBits(16);
+	  mode = DECODE_STORED_LEN2;
+	}
+	/* fall through */
+      case DECODE_STORED_LEN2:
+	{
+	  int nlen = input.peekBits(16);
+	  if (nlen < 0)
+	    return false;
+	  input.dropBits(16);
+	  if (nlen != (uncomprLen ^ 0xffff))
+	    throw new DataFormatException("broken uncompressed block");
+	  mode = DECODE_STORED;
+	}
+	/* fall through */
+      case DECODE_STORED:
+	{
+	  int more = outputWindow.copyStored(input, uncomprLen);
+	  uncomprLen -= more;
+	  if (uncomprLen == 0)
+	    {
+	      mode = DECODE_BLOCKS;
+	      return true;
+	    }
+	  return !input.needsInput();
+	}
+
+      case DECODE_DYN_HEADER:
+	if (!dynHeader.decode(input))
+	  return false;
+	litlenTree = dynHeader.buildLitLenTree();
+	distTree = dynHeader.buildDistTree();
+	mode = DECODE_HUFFMAN;
+	/* fall through */
+      case DECODE_HUFFMAN:
+      case DECODE_HUFFMAN_LENBITS:
+      case DECODE_HUFFMAN_DIST:
+      case DECODE_HUFFMAN_DISTBITS:
+	return decodeHuffman();
+      case FINISHED:
+	return false;
+      default:
+	throw new IllegalStateException();
+      }	
   }
-
-  public native synchronized void setDictionary(byte b[], int off, int len);
-  public native synchronized int inflate0(byte b[], int off, int len) throws DataFormatException;
-  public native synchronized int getAdler();
-  public native synchronized int getTotalIn();
-  public native synchronized int getTotalOut();
-  public native synchronized void reset();
-  private native synchronized void init(boolean nowrap);
-  public native synchronized void end();
-
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/InflaterDynHeader.java kaffe/libraries/javalib/java/util/zip/InflaterDynHeader.java
--- kaffe_orig/libraries/javalib/java/util/zip/InflaterDynHeader.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/InflaterDynHeader.java	2003-09-27 23:01:41.000000000 +1200
@@ -0,0 +1,203 @@
+/* java.util.zip.InflaterDynHeader
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
+class InflaterDynHeader
+{
+  private static final int LNUM   = 0;
+  private static final int DNUM   = 1;
+  private static final int BLNUM  = 2;
+  private static final int BLLENS = 3;
+  private static final int LENS   = 4;
+  private static final int REPS   = 5;
+
+  private static final int repMin[]  = { 3, 3, 11 };
+  private static final int repBits[] = { 2, 3,  7 };
+
+  
+  private byte[] blLens;
+  private byte[] litdistLens;
+
+  private InflaterHuffmanTree blTree;
+  
+  private int mode;
+  private int lnum, dnum, blnum, num;
+  private int repSymbol;
+  private byte lastLen;
+  private int ptr;
+
+  private static final int[] BL_ORDER =
+  { 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15 };
+  
+  public InflaterDynHeader()
+  {
+  }
+  
+  public boolean decode(StreamManipulator input) throws DataFormatException
+  {
+  decode_loop:
+    for (;;)
+      {
+	switch (mode)
+	  {
+	  case LNUM:
+	    lnum = input.peekBits(5);
+	    if (lnum < 0)
+	      return false;
+	    lnum += 257;
+	    input.dropBits(5);
+//  	    System.err.println("LNUM: "+lnum);
+	    mode = DNUM;
+	    /* fall through */
+	  case DNUM:
+	    dnum = input.peekBits(5);
+	    if (dnum < 0)
+	      return false;
+	    dnum++;
+	    input.dropBits(5);
+//  	    System.err.println("DNUM: "+dnum);
+	    num = lnum+dnum;
+	    litdistLens = new byte[num];
+	    mode = BLNUM;
+	    /* fall through */
+	  case BLNUM:
+	    blnum = input.peekBits(4);
+	    if (blnum < 0)
+	      return false;
+	    blnum += 4;
+	    input.dropBits(4);
+	    blLens = new byte[19];
+	    ptr = 0;
+//  	    System.err.println("BLNUM: "+blnum);
+	    mode = BLLENS;
+	    /* fall through */
+	  case BLLENS:
+	    while (ptr < blnum)
+	      {
+		int len = input.peekBits(3);
+		if (len < 0)
+		  return false;
+		input.dropBits(3);
+//  		System.err.println("blLens["+BL_ORDER[ptr]+"]: "+len);
+		blLens[BL_ORDER[ptr]] = (byte) len;
+		ptr++;
+	      }
+	    blTree = new InflaterHuffmanTree(blLens);
+	    blLens = null;
+	    ptr = 0;
+	    mode = LENS;
+	    /* fall through */
+	  case LENS:
+	    {
+	      int symbol;
+	      while (((symbol = blTree.getSymbol(input)) & ~15) == 0)
+		{
+		  /* Normal case: symbol in [0..15] */
+
+//  		  System.err.println("litdistLens["+ptr+"]: "+symbol);
+		  litdistLens[ptr++] = lastLen = (byte) symbol;
+
+		  if (ptr == num)
+		    {
+		      /* Finished */
+		      return true;
+		    }
+		}
+	      
+	      /* need more input ? */
+	      if (symbol < 0)
+		return false;
+
+	      /* otherwise repeat code */
+	      if (symbol >= 17)
+		{
+		  /* repeat zero */
+//  		  System.err.println("repeating zero");
+		  lastLen = 0;
+		}
+	      else
+		{
+		  if (ptr == 0)
+		    throw new DataFormatException();
+		}
+	      repSymbol = symbol-16;
+	      mode = REPS;
+	    }
+	    /* fall through */
+
+	  case REPS:
+	    {
+	      int bits = repBits[repSymbol];
+	      int count = input.peekBits(bits);
+	      if (count < 0)
+		return false;
+	      input.dropBits(bits);
+	      count += repMin[repSymbol];
+//  	      System.err.println("litdistLens repeated: "+count);
+
+	      if (ptr + count > num)
+		throw new DataFormatException();
+	      while (count-- > 0)
+		litdistLens[ptr++] = lastLen;
+
+	      if (ptr == num)
+		{
+		  /* Finished */
+		  return true;
+		}
+	    }
+	    mode = LENS;
+	    continue decode_loop;
+	  }
+      }
+  }
+
+  public InflaterHuffmanTree buildLitLenTree() throws DataFormatException
+  {
+    byte[] litlenLens = new byte[lnum];
+    System.arraycopy(litdistLens, 0, litlenLens, 0, lnum);
+    return new InflaterHuffmanTree(litlenLens);
+  }
+
+  public InflaterHuffmanTree buildDistTree() throws DataFormatException
+  {
+    byte[] distLens = new byte[dnum];
+    System.arraycopy(litdistLens, lnum, distLens, 0, dnum);
+    return new InflaterHuffmanTree(distLens);
+  }
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/InflaterHuffmanTree.java kaffe/libraries/javalib/java/util/zip/InflaterHuffmanTree.java
--- kaffe_orig/libraries/javalib/java/util/zip/InflaterHuffmanTree.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/InflaterHuffmanTree.java	2003-09-27 23:01:41.000000000 +1200
@@ -0,0 +1,215 @@
+/* java.util.zip.InflaterHuffmanTree
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
+public class InflaterHuffmanTree {
+  private final static int MAX_BITLEN = 15;
+  private short[] tree;
+
+  public static InflaterHuffmanTree defLitLenTree, defDistTree;
+
+  static
+  {
+    try 
+      {
+	byte[] codeLengths = new byte[288];
+	int i = 0;
+	while (i < 144)
+	  codeLengths[i++] = 8;
+	while (i < 256)
+	  codeLengths[i++] = 9;
+	while (i < 280)
+	  codeLengths[i++] = 7;
+	while (i < 288)
+	  codeLengths[i++] = 8;
+	defLitLenTree = new InflaterHuffmanTree(codeLengths);
+	
+	codeLengths = new byte[32];
+	i = 0;
+	while (i < 32)
+	  codeLengths[i++] = 5;
+	defDistTree = new InflaterHuffmanTree(codeLengths);
+      } 
+    catch (DataFormatException ex)
+      {
+	throw new InternalError
+	  ("InflaterHuffmanTree: static tree length illegal");
+      }
+  }
+
+  /**
+   * Constructs a Huffman tree from the array of code lengths.
+   *
+   * @param codeLengths the array of code lengths
+   */
+  public InflaterHuffmanTree(byte[] codeLengths) throws DataFormatException
+  {
+    buildTree(codeLengths);
+  }
+  
+  private void buildTree(byte[] codeLengths) throws DataFormatException
+  {
+    int[] blCount = new int[MAX_BITLEN+1];
+    int[] nextCode = new int[MAX_BITLEN+1];
+    for (int i = 0; i < codeLengths.length; i++)
+      {
+	int bits = codeLengths[i];
+	if (bits > 0)
+	  blCount[bits]++;
+      }
+
+    int code = 0;
+    int treeSize = 512;
+    for (int bits = 1; bits <= MAX_BITLEN; bits++)
+      {
+	nextCode[bits] = code;
+	code += blCount[bits] << (16 - bits);
+	if (bits >= 10)
+	  {
+	    /* We need an extra table for bit lengths >= 10. */
+	    int start = nextCode[bits] & 0x1ff80;
+	    int end   = code & 0x1ff80;
+	    treeSize += (end - start) >> (16 - bits);
+	  }
+      }
+    if (code != 65536)
+      throw new DataFormatException("Code lengths don't add up properly.");
+
+    /* Now create and fill the extra tables from longest to shortest
+     * bit len.  This way the sub trees will be aligned.
+     */
+    tree = new short[treeSize];
+    int treePtr = 512;
+    for (int bits = MAX_BITLEN; bits >= 10; bits--)
+      {
+	int end   = code & 0x1ff80;
+	code -= blCount[bits] << (16 - bits);
+	int start = code & 0x1ff80;
+	for (int i = start; i < end; i += 1 << 7)
+	  {
+	    tree[DeflaterHuffman.bitReverse(i)]
+	      = (short) ((-treePtr << 4) | bits);
+	    treePtr += 1 << (bits-9);
+	  }
+      }
+    
+    for (int i = 0; i < codeLengths.length; i++)
+      {
+	int bits = codeLengths[i];
+	if (bits == 0)
+	  continue;
+	code = nextCode[bits];
+	int revcode = DeflaterHuffman.bitReverse(code);
+	if (bits <= 9)
+	  {
+	    do
+	      {
+		tree[revcode] = (short) ((i << 4) | bits);
+		revcode += 1 << bits;
+	      }
+	    while (revcode < 512);
+	  }
+	else
+	  {
+	    int subTree = tree[revcode & 511];
+	    int treeLen = 1 << (subTree & 15);
+	    subTree = -(subTree >> 4);
+	    do
+	      { 
+		tree[subTree | (revcode >> 9)] = (short) ((i << 4) | bits);
+		revcode += 1 << bits;
+	      }
+	    while (revcode < treeLen);
+	  }
+	nextCode[bits] = code + (1 << (16 - bits));
+      }
+  }
+
+  /**
+   * Reads the next symbol from input.  The symbol is encoded using the
+   * huffman tree.
+   * @param input the input source.
+   * @return the next symbol, or -1 if not enough input is available.
+   */
+  public int getSymbol(StreamManipulator input) throws DataFormatException
+  {
+    int lookahead, symbol;
+    if ((lookahead = input.peekBits(9)) >= 0)
+      {
+	if ((symbol = tree[lookahead]) >= 0)
+	  {
+	    input.dropBits(symbol & 15);
+	    return symbol >> 4;
+	  }
+	int subtree = -(symbol >> 4);
+	int bitlen = symbol & 15;
+	if ((lookahead = input.peekBits(bitlen)) >= 0)
+	  {
+	    symbol = tree[subtree | (lookahead >> 9)];
+	    input.dropBits(symbol & 15);
+	    return symbol >> 4;
+	  }
+	else
+	  {
+	    int bits = input.getAvailableBits();
+	    lookahead = input.peekBits(bits);
+	    symbol = tree[subtree | (lookahead >> 9)];
+	    if ((symbol & 15) <= bits)
+	      {
+		input.dropBits(symbol & 15);
+		return symbol >> 4;
+	      }
+	    else
+	      return -1;
+	  }
+      }
+    else
+      {
+	int bits = input.getAvailableBits();
+	lookahead = input.peekBits(bits);
+	symbol = tree[lookahead];
+	if (symbol >= 0 && (symbol & 15) <= bits)
+	  {
+	    input.dropBits(symbol & 15);
+	    return symbol >> 4;
+	  }
+	else
+	  return -1;
+      }
+  }
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/InflaterInputStream.java kaffe/libraries/javalib/java/util/zip/InflaterInputStream.java
--- kaffe_orig/libraries/javalib/java/util/zip/InflaterInputStream.java	2002-08-17 06:04:31.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/InflaterInputStream.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,108 +1,237 @@
+/* java.util.zip.InflaterInputStream
+   Copyright (C) 2001, 2003 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
 package java.util.zip;
 
 import java.io.FilterInputStream;
-import java.io.IOException;
 import java.io.InputStream;
+import java.io.IOException;
 
-/*
- * Java core library component.
+/**
+ * This filter stream is used to decompress data compressed in the "deflate"
+ * format. The "deflate" format is described in RFC 1951.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * This stream may form the basis for other decompression filters, such
+ * as the <code>GZIPInputStream</code>.
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
+ * @author John Leuner
+ * @since 1.1
  */
-public class InflaterInputStream
-  extends FilterInputStream
+public class InflaterInputStream extends FilterInputStream
 {
-	final private static int DEFAULT = 512;
-	protected Inflater inf;
-	protected byte[] buf;
-	protected int len;
-
-public InflaterInputStream(InputStream in) {
-	this(in, new Inflater(), DEFAULT);
-}
-
-public InflaterInputStream(InputStream in, Inflater inf) {
-	this(in, inf, DEFAULT);
-}
-
-public InflaterInputStream(InputStream in, Inflater inf, int size) {
-	super(in);
-	if (in == null)
-	  throw new NullPointerException("in");
-	if (inf == null)
-	  throw new NullPointerException("inf");
-	this.inf = inf;
-	if (size < 1)
-	  throw new IllegalArgumentException("size < 1");
-	buf = new byte[size];
-}
-
-protected void fill() throws IOException {
-	len = super.read(buf, 0, buf.length);
-}
-
-public int read() throws IOException {
-	byte[] b = new byte[1];
-	int r = read(b, 0, 1);
-	if (r == -1) {
-		return (-1);
-	}
-	else {
-		return ((int)b[0]);
-	}
-}
-
-public int read(byte b[], int off, int lenx) throws IOException {
-	if (inf.finished()) {
-		return (-1);
-	}
-	if (inf.needsInput()) {
-		fill();
-		if (len == -1) {
-			return (-1);
-		}
-		inf.setInput(buf, 0, len);
-	}
-	try {
-		/* we have to call inflate until
-		 * it is finished or needs more input
-		 */
-		int inflated = 0;
-		do {
-			inflated += inf.inflate(b,
-						off + inflated,
-						lenx - inflated);
-		}
-		while (inflated < lenx && !inf.needsInput() && !inf.finished());
- 
-		/* recurse if only 0 bytes were inflated */
-		if (inflated == 0 && lenx != 0) {
-		    return read(b, off, lenx);
-		}
-
-		return inflated;
-	}
-	catch (DataFormatException _) {
-		throw new IOException("bad data format");
-	}
-}
-
-public long skip(long n) throws IOException {
-	// This is a terribly inefficient way to skip ...
-	long cnt;
-	byte[] b = new byte[1];
-
-	for (cnt = 0; cnt < n; cnt++) {
-		int r = read(b, 0, 1);
-		if (r == -1) {
-			break;
-		}
-	}
-	return (cnt);
-}
-
+  /**
+   * Decompressor for this filter 
+   */
+  protected Inflater inf;
+
+  /**
+   * Byte array used as a buffer 
+   */
+  protected byte[] buf;
+
+  /**
+   * Size of buffer   
+   */
+  protected int len;
+
+
+  /*
+   * We just use this if we are decoding one byte at a time with the read() call
+   */
+  private byte[] onebytebuffer = new byte[1];
+
+  /**
+   * Create an InflaterInputStream with the default decompresseor
+   * and a default buffer size.
+   *
+   * @param in the InputStream to read bytes from
+   */
+  public InflaterInputStream(InputStream in) 
+  {
+    this(in, new Inflater(), 4096);
+  }
+
+  /**
+   * Create an InflaterInputStream with the specified decompresseor
+   * and a default buffer size.
+   *
+   * @param in the InputStream to read bytes from
+   * @param inf the decompressor used to decompress data read from in
+   */
+  public InflaterInputStream(InputStream in, Inflater inf) 
+  {
+    this(in, inf, 4096);
+  }
+
+  /**
+   * Create an InflaterInputStream with the specified decompresseor
+   * and a specified buffer size.
+   *
+   * @param in the InputStream to read bytes from
+   * @param inf the decompressor used to decompress data read from in
+   * @param size size of the buffer to use
+   */
+  public InflaterInputStream(InputStream in, Inflater inf, int size) 
+  {
+    super(in);
+    this.inf = inf;
+    this.len = 0;
+    
+    if (size <= 0)
+      throw new IllegalArgumentException("size <= 0");
+    buf = new byte[size]; //Create the buffer
+
+    if (in == null)
+      throw new NullPointerException("InputStream null");
+    if (inf == null)
+      throw new NullPointerException("Inflater null");
+  }
+
+  /**
+   * Returns 0 once the end of the stream (EOF) has been reached.
+   * Otherwise returns 1.
+   */
+  public int available() throws IOException
+  {
+    return inf.finished() ? 0 : 1;
+  }
+
+  /**
+   * Closes the input stream
+   */
+  public synchronized void close() throws IOException
+  {
+    if (in != null)
+      in.close();
+    in = null;
+  }
+
+  /**
+   * Fills the buffer with more data to decompress.
+   */
+  protected void fill() throws IOException
+  {
+    if (in == null)
+      throw new ZipException ("InflaterInputStream is closed");
+    
+    len = in.read(buf, 0, buf.length);
+
+    if (len < 0)
+      throw new ZipException("Deflated stream ends early.");
+    
+    inf.setInput(buf, 0, len);
+  }
+
+  /**
+   * Reads one byte of decompressed data.
+   *
+   * The byte is in the lower 8 bits of the int.
+   */
+  public int read() throws IOException
+  { 
+    int nread = read(onebytebuffer, 0, 1); //read one byte
+    
+    if (nread > 0)
+      return onebytebuffer[0] & 0xff;
+    
+    return -1;
+  }
+
+  /**
+   * Decompresses data into the byte array
+   *
+   * @param b the array to read and decompress data into
+   * @param off the offset indicating where the data should be placed
+   * @param len the number of bytes to decompress
+   */
+  public int read(byte[] b, int off, int len) throws IOException
+  {
+    if (len == 0) return 0;
+
+    for (;;)
+      {
+	int count;
+	try
+	  {
+	    count = inf.inflate(b, off, len);
+	  } 
+	catch (DataFormatException dfe) 
+	  {
+	    throw new ZipException(dfe.getMessage());
+	  }
+
+	if (count > 0)
+	  return count;
+	
+	if (inf.needsDictionary()
+	    | inf.finished())
+	  return -1;
+	else if (inf.needsInput())
+	  fill();
+	else
+	  throw new InternalError("Don't know what to do");
+      }
+  }
+
+  /**
+   * Skip specified number of bytes of uncompressed data
+   *
+   * @param n number of bytes to skip
+   */
+  public long skip(long n) throws IOException
+  {
+    if (n < 0)
+      throw new IllegalArgumentException();
+    int len = 2048;
+    if (n < len)
+      len = (int) n;
+    byte[] tmp = new byte[len];
+    return (long) read(tmp);
+  }
+
+  /**
+   * Since this stream tends to buffer large (unpredictable?) amounts
+   * of stuff, it causes problems to the mark/reset mechanism.  Hence,
+   * it claims not to support mark.
+   *
+   * @return false
+   */
+  public boolean markSupported()
+  {
+    return false;
+  }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/OutputWindow.java kaffe/libraries/javalib/java/util/zip/OutputWindow.java
--- kaffe_orig/libraries/javalib/java/util/zip/OutputWindow.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/OutputWindow.java	2003-09-27 23:01:41.000000000 +1200
@@ -0,0 +1,180 @@
+/* java.util.zip.OutputWindow
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
+/*
+ * Contains the output from the Inflation process.
+ *
+ * We need to have a window so that we can refer backwards into the output stream
+ * to repeat stuff.
+ *
+ * @author John Leuner
+ * @since JDK 1.1
+ */
+
+class OutputWindow
+{
+  private final int WINDOW_SIZE = 1 << 15;
+  private final int WINDOW_MASK = WINDOW_SIZE - 1;
+
+  private byte[] window = new byte[WINDOW_SIZE]; //The window is 2^15 bytes
+  private int window_end  = 0;
+  private int window_filled = 0;
+
+  public void write(int abyte)
+  {
+    if (window_filled++ == WINDOW_SIZE)
+      throw new IllegalStateException("Window full");
+    window[window_end++] = (byte) abyte;
+    window_end &= WINDOW_MASK;
+  }
+
+
+  private final void slowRepeat(int rep_start, int len, int dist)
+  {
+    while (len-- > 0)
+      {
+	window[window_end++] = window[rep_start++];
+	window_end &= WINDOW_MASK;
+	rep_start &= WINDOW_MASK;
+      }
+  }
+
+  public void repeat(int len, int dist)
+  {
+    if ((window_filled += len) > WINDOW_SIZE)
+      throw new IllegalStateException("Window full");
+
+    int rep_start = (window_end - dist) & WINDOW_MASK;
+    int border = WINDOW_SIZE - len;
+    if (rep_start <= border && window_end < border)
+      {
+	if (len <= dist)
+	  {
+	    System.arraycopy(window, rep_start, window, window_end, len);
+	    window_end += len;
+	  }
+	else
+	  {
+	    /* We have to copy manually, since the repeat pattern overlaps.
+	     */
+	    while (len-- > 0)
+	      window[window_end++] = window[rep_start++];
+	  }
+      }
+    else
+      slowRepeat(rep_start, len, dist);
+  }
+
+  public int copyStored(StreamManipulator input, int len)
+  {
+    len = Math.min(Math.min(len, WINDOW_SIZE - window_filled), 
+		   input.getAvailableBytes());
+    int copied;
+
+    int tailLen = WINDOW_SIZE - window_end;
+    if (len > tailLen)
+      {
+	copied = input.copyBytes(window, window_end, tailLen);
+	if (copied == tailLen)
+	  copied += input.copyBytes(window, 0, len - tailLen);
+      }
+    else
+      copied = input.copyBytes(window, window_end, len);
+
+    window_end = (window_end + copied) & WINDOW_MASK;
+    window_filled += copied;
+    return copied;
+  }
+
+  public void copyDict(byte[] dict, int offset, int len)
+  {
+    if (window_filled > 0)
+      throw new IllegalStateException();
+
+    if (len > WINDOW_SIZE)
+      {
+	offset += len - WINDOW_SIZE;
+	len = WINDOW_SIZE;
+      }
+    System.arraycopy(dict, offset, window, 0, len);
+    window_end = len & WINDOW_MASK;
+  }
+
+  public int getFreeSpace()
+  {
+    return WINDOW_SIZE - window_filled;
+  }
+
+  public int getAvailable()
+  {
+    return window_filled;
+  }
+
+  public int copyOutput(byte[] output, int offset, int len)
+  {
+    int copy_end = window_end;
+    if (len > window_filled)
+      len = window_filled;
+    else
+      copy_end = (window_end - window_filled + len) & WINDOW_MASK;
+
+    int copied = len;
+    int tailLen = len - copy_end;
+
+    if (tailLen > 0)
+      {
+	System.arraycopy(window, WINDOW_SIZE - tailLen,
+			 output, offset, tailLen);
+	offset += tailLen;
+	len = copy_end;
+      }
+    System.arraycopy(window, copy_end - len, output, offset, len);
+    window_filled -= copied;
+    if (window_filled < 0)
+      throw new IllegalStateException();
+    return copied;
+  }
+
+  public void reset() {
+    window_filled = window_end = 0;
+  }
+}
+
+
+
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/PendingBuffer.java kaffe/libraries/javalib/java/util/zip/PendingBuffer.java
--- kaffe_orig/libraries/javalib/java/util/zip/PendingBuffer.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/PendingBuffer.java	2003-09-27 23:01:41.000000000 +1200
@@ -0,0 +1,200 @@
+/* java.util.zip.PendingBuffer
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
+/**
+ * This class is general purpose class for writing data to a buffer.
+ *
+ * It allows you to write bits as well as bytes 
+ *
+ * Based on DeflaterPending.java
+ *
+ * @author Jochen Hoenicke
+ * @date Jan 5, 2000 
+ */
+
+class PendingBuffer
+{
+  protected byte[] buf;
+  int    start;
+  int    end;
+
+  int    bits;
+  int    bitCount;
+
+  public PendingBuffer()
+  {
+    this( 4096 );
+  }
+
+  public PendingBuffer(int bufsize)
+  {
+    buf = new byte[bufsize];
+  }
+
+  public final void reset() {
+    start = end = bitCount = 0;
+  }
+
+  public final void writeByte(int b) 
+  {
+    if (DeflaterConstants.DEBUGGING && start != 0)
+      throw new IllegalStateException();
+    buf[end++] = (byte) b;
+  }
+
+  public final void writeShort(int s) 
+  {
+    if (DeflaterConstants.DEBUGGING && start != 0)
+      throw new IllegalStateException();
+    buf[end++] = (byte) s;
+    buf[end++] = (byte) (s >> 8);
+  }
+
+  public final void writeInt(int s) 
+  {
+    if (DeflaterConstants.DEBUGGING && start != 0)
+      throw new IllegalStateException();
+    buf[end++] = (byte) s;
+    buf[end++] = (byte) (s >> 8);
+    buf[end++] = (byte) (s >> 16);
+    buf[end++] = (byte) (s >> 24);
+  }
+
+  public final void writeBlock(byte[] block, int offset, int len) 
+  {
+    if (DeflaterConstants.DEBUGGING && start != 0)
+      throw new IllegalStateException();
+    System.arraycopy(block, offset, buf, end, len);
+    end += len;
+  }
+
+  public final int getBitCount() {
+    return bitCount;
+  }
+
+  public final void alignToByte() {
+    if (DeflaterConstants.DEBUGGING && start != 0)
+      throw new IllegalStateException();
+    if (bitCount > 0)
+      {
+	buf[end++] = (byte) bits;
+	if (bitCount > 8)
+	  buf[end++] = (byte) (bits >>> 8);
+      }
+    bits = 0;
+    bitCount = 0;
+  }
+
+  public final void writeBits(int b, int count)
+  {
+     if (DeflaterConstants.DEBUGGING && start != 0)
+       throw new IllegalStateException();
+     if (DeflaterConstants.DEBUGGING)
+       System.err.println("writeBits("+Integer.toHexString(b)+","+count+")");
+    bits |= b << bitCount;
+    bitCount += count;
+    if (bitCount >= 16) {
+      buf[end++] = (byte) bits;
+      buf[end++] = (byte) (bits >>> 8);
+      bits >>>= 16;
+      bitCount -= 16;
+    }
+  }
+
+  public final void writeShortMSB(int s) {
+    if (DeflaterConstants.DEBUGGING && start != 0)
+      throw new IllegalStateException();
+    buf[end++] = (byte) (s >> 8);
+    buf[end++] = (byte) s;
+  }
+
+  public final boolean isFlushed() {
+    return end == 0;
+  }
+
+  /**
+   * Flushes the pending buffer into the given output array.  If the
+   * output array is to small, only a partial flush is done.
+   *
+   * @param output the output array;
+   * @param offset the offset into output array;
+   * @param length the maximum number of bytes to store;
+   * @exception IndexOutOfBoundsException if offset or length are
+   * invalid.
+   */
+  public final int flush(byte[] output, int offset, int length) {
+    if (bitCount >= 8)
+      {
+	buf[end++] = (byte) bits;
+	bits >>>= 8;
+	bitCount -= 8;
+      }
+    if (length > end - start)
+      {
+	length = end - start;
+	System.arraycopy(buf, start, output, offset, length);
+	start = 0;
+	end = 0;
+      }
+    else
+      {
+	System.arraycopy(buf, start, output, offset, length);
+	start += length;
+      }
+    return length;
+  }
+
+  /**
+   * Flushes the pending buffer and returns that data in a new array
+   * 
+   * @param output the output stream
+   */
+
+  public final byte[] toByteArray()
+  {
+    byte[] ret = new byte[ end - start ];
+    System.arraycopy(buf, start, ret, 0, ret.length);
+    start = 0;
+    end = 0;
+    return ret;
+  }
+
+
+}
+
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/StreamManipulator.java kaffe/libraries/javalib/java/util/zip/StreamManipulator.java
--- kaffe_orig/libraries/javalib/java/util/zip/StreamManipulator.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/StreamManipulator.java	2003-09-27 23:01:41.000000000 +1200
@@ -0,0 +1,216 @@
+/* java.util.zip.StreamManipulator
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.util.zip;
+
+/**
+ * This class allows us to retrieve a specified amount of bits from
+ * the input buffer, as well as copy big byte blocks.
+ *
+ * It uses an int buffer to store up to 31 bits for direct
+ * manipulation.  This guarantees that we can get at least 16 bits,
+ * but we only need at most 15, so this is all safe.
+ *
+ * There are some optimizations in this class, for example, you must
+ * never peek more then 8 bits more than needed, and you must first 
+ * peek bits before you may drop them.  This is not a general purpose
+ * class but optimized for the behaviour of the Inflater.
+ *
+ * @author John Leuner, Jochen Hoenicke
+ */
+
+class StreamManipulator
+{
+  private byte[] window;
+  private int window_start = 0;
+  private int window_end = 0;
+
+  private int buffer = 0;
+  private int bits_in_buffer = 0;
+
+  /**
+   * Get the next n bits but don't increase input pointer.  n must be
+   * less or equal 16 and if you if this call succeeds, you must drop
+   * at least n-8 bits in the next call.
+   * 
+   * @return the value of the bits, or -1 if not enough bits available.  */
+  public final int peekBits(int n)
+  {
+    if (bits_in_buffer < n)
+      {
+	if (window_start == window_end)
+	  return -1;
+	buffer |= (window[window_start++] & 0xff
+		   | (window[window_start++] & 0xff) << 8) << bits_in_buffer;
+	bits_in_buffer += 16;
+      }
+    return buffer & ((1 << n) - 1);
+  }
+
+  /* Drops the next n bits from the input.  You should have called peekBits
+   * with a bigger or equal n before, to make sure that enough bits are in
+   * the bit buffer.
+   */
+  public final void dropBits(int n)
+  {
+    buffer >>>= n;
+    bits_in_buffer -= n;
+  }
+
+  /**
+   * Gets the next n bits and increases input pointer.  This is equivalent
+   * to peekBits followed by dropBits, except for correct error handling.
+   * @return the value of the bits, or -1 if not enough bits available. 
+   */
+  public final int getBits(int n)
+  {
+    int bits = peekBits(n);
+    if (bits >= 0)
+      dropBits(n);
+    return bits;
+  }
+  /**
+   * Gets the number of bits available in the bit buffer.  This must be
+   * only called when a previous peekBits() returned -1.
+   * @return the number of bits available.
+   */
+  public final int getAvailableBits()
+  {
+    return bits_in_buffer;
+  }
+
+  /**
+   * Gets the number of bytes available.  
+   * @return the number of bytes available.
+   */
+  public final int getAvailableBytes()
+  {
+    return window_end - window_start + (bits_in_buffer >> 3);
+  }
+
+  /**
+   * Skips to the next byte boundary.
+   */
+  public void skipToByteBoundary()
+  {
+    buffer >>= (bits_in_buffer & 7);
+    bits_in_buffer &= ~7;
+  }
+
+  public final boolean needsInput() {
+    return window_start == window_end;
+  }
+
+
+  /* Copies length bytes from input buffer to output buffer starting
+   * at output[offset].  You have to make sure, that the buffer is
+   * byte aligned.  If not enough bytes are available, copies fewer
+   * bytes.
+   * @param length the length to copy, 0 is allowed.
+   * @return the number of bytes copied, 0 if no byte is available.  
+   */
+  public int copyBytes(byte[] output, int offset, int length)
+  {
+    if (length < 0)
+      throw new IllegalArgumentException("length negative");
+    if ((bits_in_buffer & 7) != 0)  
+      /* bits_in_buffer may only be 0 or 8 */
+      throw new IllegalStateException("Bit buffer is not aligned!");
+
+    int count = 0;
+    while (bits_in_buffer > 0 && length > 0)
+      {
+	output[offset++] = (byte) buffer;
+	buffer >>>= 8;
+	bits_in_buffer -= 8;
+	length--;
+	count++;
+      }
+    if (length == 0)
+      return count;
+
+    int avail = window_end - window_start;
+    if (length > avail)
+      length = avail;
+    System.arraycopy(window, window_start, output, offset, length);
+    window_start += length;
+
+    if (((window_start - window_end) & 1) != 0)
+      {
+	/* We always want an even number of bytes in input, see peekBits */
+	buffer = (window[window_start++] & 0xff);
+	bits_in_buffer = 8;
+      }
+    return count + length;
+  }
+
+  public StreamManipulator()
+  {
+  }
+
+  public void reset()
+  {
+    window_start = window_end = buffer = bits_in_buffer = 0;
+  }
+
+  public void setInput(byte[] buf, int off, int len)
+  {
+    if (window_start < window_end)
+      throw new IllegalStateException
+	("Old input was not completely processed");
+
+    int end = off + len;
+
+    /* We want to throw an ArrayIndexOutOfBoundsException early.  The
+     * check is very tricky: it also handles integer wrap around.  
+     */
+    if (0 > off || off > end || end > buf.length)
+      throw new ArrayIndexOutOfBoundsException();
+    
+    if ((len & 1) != 0)
+      {
+	/* We always want an even number of bytes in input, see peekBits */
+	buffer |= (buf[off++] & 0xff) << bits_in_buffer;
+	bits_in_buffer += 8;
+      }
+    
+    window = buf;
+    window_start = off;
+    window_end = end;
+  }
+}
+
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/ZipConstants.java kaffe/libraries/javalib/java/util/zip/ZipConstants.java
--- kaffe_orig/libraries/javalib/java/util/zip/ZipConstants.java	2001-11-24 14:52:55.000000000 +1300
+++ kaffe/libraries/javalib/java/util/zip/ZipConstants.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,78 +1,97 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* java.util.zip.ZipConstants
+   Copyright (C) 2001 Free Software Foundation, Inc.
 
-package java.util.zip;
-
-// This isn't documented so I don't know what it contains .... !!!
-
-interface ZipConstants {
+This file is part of GNU Classpath.
 
-  int CEN_SIGNATURE = 0;
-  int CEN_VERSIONMADE = 4;
-  int CEN_VERSIONEXTRACT = 6;
-  int CEN_FLAGS = 8;
-  int CEN_METHOD = 10;
-  int CEN_TIME = 12;
-  int CEN_DATE = 14;
-  int CEN_CRC = 16;
-  int CEN_COMPRESSEDSIZE = 20;
-  int CEN_UNCOMPRESSEDSIZE = 24;
-  int CEN_FILENAMELEN = 28;
-  int CEN_EXTRAFIELDLEN = 30;
-  int CEN_FILECOMMENTLEN = 32;
-  int CEN_DISKNUMBER = 34;
-  int CEN_INTERNALATTR = 36;
-  int CEN_EXTERNALATTR = 38;
-  int CEN_LCLOFFSET = 42;
-
-  int CEN_RECSZ = 46;
-
-  long CEN_HEADSIG = 0x02014b50;
-
-  int END_SIGNATURE = 0;
-  int END_DISKNUMBER = 4;
-  int END_CENDISKNUMBER = 6;
-  int END_TOTALCENONDISK = 8;
-  int END_TOTALCEN = 10;
-  int END_CENSIZE = 12;
-  int END_CENOFFSET = 16;
-  int END_COMMENTLEN = 20;
-
-  int END_RECSZ = 22;
-
-  long END_ENDSIG = 0x06054b50;
-
-  int LOC_SIGNATURE = 0;
-  int LOC_VERSIONEXTRACT = 4;
-  int LOC_FLAGS = 6;
-  int LOC_METHOD = 8;
-  int LOC_TIME = 10;
-  int LOC_DATE = 12;
-  int LOC_CRC = 14;
-  int LOC_COMPRESSEDSIZE = 18;
-  int LOC_UNCOMPRESSEDSIZE = 22;
-  int LOC_FILENAMELEN = 26;
-  int LOC_EXTRAFIELDLEN = 28;
-
-  int LOC_RECSZ = 30;
-
-  long LOC_HEADSIG = 0x04034b50;
-
-  long DATA_HEADSIG = 0x08074b50;
-  int DATA_SIGNATURE = 0;
-  int DATA_CRC = 4;
-  int DATA_COMPRESSEDSIZE = 8;
-  int DATA_UNCOMPRESSEDSIZE = 12;
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-  int DATA_RECSZ = 16;
+package java.util.zip;
 
-  int DEFLATED = 8;
-  int STORED = 0;
+interface ZipConstants
+{
+    /* The local file header */
+    public final static int LOCHDR = 30;
+    public final static int LOCSIG = 'P'|('K'<<8)|(3<<16)|(4<<24);
+
+    public final static int LOCVER =  4;
+    public final static int LOCFLG =  6;
+    public final static int LOCHOW =  8;
+    public final static int LOCTIM = 10;
+    public final static int LOCCRC = 14;
+    public final static int LOCSIZ = 18;
+    public final static int LOCLEN = 22;
+    public final static int LOCNAM = 26;
+    public final static int LOCEXT = 28;
+
+    /* The Data descriptor */
+    public final static int EXTSIG = 'P'|('K'<<8)|(7<<16)|(8<<24);
+    public final static int EXTHDR = 16;
+
+    public final static int EXTCRC =  4;
+    public final static int EXTSIZ =  8;
+    public final static int EXTLEN = 12;
+
+    /* The central directory file header */
+    public final static int CENSIG = 'P'|('K'<<8)|(1<<16)|(2<<24);
+    public final static int CENHDR = 46;
+
+    public final static int CENVEM =  4;
+    public final static int CENVER =  6;
+    public final static int CENFLG =  8;
+    public final static int CENHOW = 10;
+    public final static int CENTIM = 12;
+    public final static int CENCRC = 16;
+    public final static int CENSIZ = 20;
+    public final static int CENLEN = 24;
+    public final static int CENNAM = 28;
+    public final static int CENEXT = 30;
+    public final static int CENCOM = 32;
+    public final static int CENDSK = 34;
+    public final static int CENATT = 36;
+    public final static int CENATX = 38;
+    public final static int CENOFF = 42;
+
+    /* The entries in the end of central directory */
+    public final static int ENDSIG = 'P'|('K'<<8)|(5<<16)|(6<<24);
+    public final static int ENDHDR = 22;
+
+    /* The following two fields are missing in SUN JDK */
+    final static int ENDNRD =  4;
+    final static int ENDDCD =  6;
+    public final static int ENDSUB =  8;
+    public final static int ENDTOT = 10;
+    public final static int ENDSIZ = 12;
+    public final static int ENDOFF = 16;
+    public final static int ENDCOM = 20;
 }
+
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/ZipEntry.java kaffe/libraries/javalib/java/util/zip/ZipEntry.java
--- kaffe_orig/libraries/javalib/java/util/zip/ZipEntry.java	2000-08-27 10:21:58.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/ZipEntry.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,221 +1,414 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* java.util.zip.ZipEntry
+   Copyright (C) 2001, 2002 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
 
 package java.util.zip;
 
-import java.util.Date;
 import java.util.Calendar;
-import java.util.GregorianCalendar;
+import java.util.Date;
+
+/**
+ * This class represents a member of a zip archive.  ZipFile and
+ * ZipInputStream will give you instances of this class as information
+ * about the members in an archive.  On the other hand ZipOutputStream
+ * needs an instance of this class to create a new member.
+ *
+ * @author Jochen Hoenicke 
+ */
+public class ZipEntry implements ZipConstants, Cloneable
+{
+  private static int KNOWN_SIZE   = 1;
+  private static int KNOWN_CSIZE  = 2;
+  private static int KNOWN_CRC    = 4;
+  private static int KNOWN_TIME   = 8;
+
+  private static Calendar cal;
+
+  private String name;
+  private int size;
+  private int compressedSize;
+  private int crc;
+  private int dostime;
+  private short known = 0;
+  private short method = -1;
+  private byte[] extra = null;
+  private String comment = null;
+
+  int flags;              /* used by ZipOutputStream */
+  int offset;             /* used by ZipFile and ZipOutputStream */
+
+
+  /**
+   * Compression method.  This method doesn't compress at all.
+   */
+  public final static int STORED      =  0;
+  /**
+   * Compression method.  This method uses the Deflater.
+   */
+  public final static int DEFLATED    =  8;
+
+  /**
+   * Creates a zip entry with the given name.
+   * @param name the name. May include directory components separated
+   * by '/'.
+   *
+   * @exception NullPointerException when name is null.
+   * @exception IllegalArgumentException when name is bigger then 65535 chars.
+   */
+  public ZipEntry(String name)
+  {
+    int length = name.length();
+    if (length > 65535)
+      throw new IllegalArgumentException("name length is " + length);
+    this.name = name;
+  }
+
+  /**
+   * Creates a copy of the given zip entry.
+   * @param e the entry to copy.
+   */
+  public ZipEntry(ZipEntry e)
+  {
+    name = e.name;
+    known = e.known;
+    size = e.size;
+    compressedSize = e.compressedSize;
+    crc = e.crc;
+    dostime = e.dostime;
+    method = e.method;
+    extra = e.extra;
+    comment = e.comment;
+  }
 
-public class ZipEntry implements Cloneable, ZipConstants {
+  final void setDOSTime(int dostime)
+  {
+    this.dostime = dostime;
+    known |= KNOWN_TIME;
+  }
 
-  public static final int STORED = Deflater.NO_COMPRESSION;
-  public static final int DEFLATED = Deflater.DEFLATED;
+  final int getDOSTime()
+  {
+    if ((known & KNOWN_TIME) == 0)
+      return 0;
+    else
+      return dostime;
+  }
 
-  String name;
-  long time = -1;
-  int dosTime;
-  long crc;
-  long size;
-  int method;
-  byte[] extra;
-  String comment;
-  int flag;
-  int version;
-  long csize;
-  long offset;
-
-  /**
-   * this constructor is for internal library use only (makeZipEntry) 
-   */
-  ZipEntry()
-  {
-  }
-
-  public ZipEntry(String nm)
-  {
-    if (nm == null) {
-      throw new NullPointerException();
-    }
-    if (nm.length() > 0xFFFF) {
-      throw new IllegalArgumentException("name length > 0xFFFF");
-    }
-    name = nm;
-    time = new Date().getTime();
-    dosTime = computeDosTime(time);
-    crc = -1;
-    size = -1;
-    method = -1;
-    extra = null;
-    comment = null;
-    flag = 0;
-    version = 0;
-    csize = -1;
-    offset = 0;
-  }
-
-  /**
-   * Create a new ZipEntry with fields taken from the specified zip entry.
-   */
-  public ZipEntry(ZipEntry entry)
-  {
-    name = entry.name;
-    time = entry.time;
-    dosTime = entry.dosTime;
-    crc  = entry.crc;
-    size = entry.size;
-    method = entry.method;
-    extra = entry.extra;
-    comment = entry.comment;
-    flag = entry.flag;
-    version = entry.version;
-    csize = entry.csize;
-    offset = entry.offset;
+  /**
+   * Creates a copy of this zip entry.
+   */
+  /**
+   * Clones the entry.
+   */
+  public Object clone()
+  {
+    try
+      {
+	// The JCL says that the `extra' field is also copied.
+	ZipEntry clone = (ZipEntry) super.clone();
+	if (extra != null)
+	  clone.extra = (byte[]) extra.clone();
+	return clone;
+      }
+    catch (CloneNotSupportedException ex)
+      {
+	throw new InternalError();
+      }
   }
 
+  /**
+   * Returns the entry name.  The path components in the entry are
+   * always separated by slashes ('/').  
+   */
   public String getName()
   {
-    return (name);
+    return name;
   }
 
-  public void setTime(long tm)
+  /**
+   * Sets the time of last modification of the entry.
+   * @time the time of last modification of the entry.
+   */
+  public void setTime(long time)
   {
-    time = tm;
-    dosTime = computeDosTime(tm);
+    Calendar cal = getCalendar();
+    synchronized (cal)
+      {
+	cal.setTime(new Date(time*1000L));
+	dostime = (cal.get(cal.YEAR) - 1980 & 0x7f) << 25
+	  | (cal.get(cal.MONTH) + 1) << 21
+	  | (cal.get(cal.DAY_OF_MONTH)) << 16
+	  | (cal.get(cal.HOUR_OF_DAY)) << 11
+	  | (cal.get(cal.MINUTE)) << 5
+	  | (cal.get(cal.SECOND)) >> 1;
+      }
+    dostime = (int) (dostime / 1000L);
+    this.known |= KNOWN_TIME;
   }
 
+  /**
+   * Gets the time of last modification of the entry.
+   * @return the time of last modification of the entry, or -1 if unknown.
+   */
   public long getTime()
   {
-    if (time == -1 && dosTime != 0)
-      setDosTime(dosTime);
-    return (time);
+    if ((known & KNOWN_TIME) == 0)
+      return -1;
+    
+    int sec = 2 * (dostime & 0x1f);
+    int min = (dostime >> 5) & 0x3f;
+    int hrs = (dostime >> 11) & 0x1f;
+    int day = (dostime >> 16) & 0x1f;
+    int mon = ((dostime >> 21) & 0xf) - 1;
+    int year = ((dostime >> 25) & 0x7f) + 1980; /* since 1900 */
+   
+    try
+      {
+	cal = getCalendar();
+	synchronized (cal)
+	  {
+	    cal.set(year, mon, day, hrs, min, sec);
+	    return cal.getTime().getTime();
+	  }
+      }
+    catch (RuntimeException ex)
+      {
+	/* Ignore illegal time stamp */
+	known &= ~KNOWN_TIME;
+	return -1;
+      }
+  }
+
+  private static synchronized Calendar getCalendar()
+  {
+    if (cal == null)
+      cal = Calendar.getInstance();
+
+    return cal;
   }
 
+  /**
+   * Sets the size of the uncompressed data.
+   * @exception IllegalArgumentException if size is not in 0..0xffffffffL
+   */
   public void setSize(long size)
   {
-    if (size < 0 || size > 0xFFFFFFFFL) {
-      throw new IllegalArgumentException("size < 0 or size > 0xFFFFFFFF");
-    }
-    this.size = size;
+    if ((size & 0xffffffff00000000L) != 0)
+	throw new IllegalArgumentException();
+    this.size = (int) size;
+    this.known |= KNOWN_SIZE;
   }
 
+  /**
+   * Gets the size of the uncompressed data.
+   * @return the size or -1 if unknown.
+   */
   public long getSize()
   {
-    return (size);
+    return (known & KNOWN_SIZE) != 0 ? size & 0xffffffffL : -1L;
+  }
+
+  /**
+   * Sets the size of the compressed data.
+   * @exception IllegalArgumentException if size is not in 0..0xffffffffL
+   */
+  public void setCompressedSize(long csize)
+  {
+    if ((csize & 0xffffffff00000000L) != 0)
+	throw new IllegalArgumentException();
+    this.compressedSize = (int) csize;
+    this.known |= KNOWN_CSIZE;
+  }
+
+  /**
+   * Gets the size of the compressed data.
+   * @return the size or -1 if unknown.
+   */
+  public long getCompressedSize()
+  {
+    return (known & KNOWN_CSIZE) != 0 ? compressedSize & 0xffffffffL : -1L;
   }
 
-  public void setCrc(long crcx)
+  /**
+   * Sets the crc of the uncompressed data.
+   * @exception IllegalArgumentException if crc is not in 0..0xffffffffL
+   */
+  public void setCrc(long crc)
   {
-    if (crcx < 0 || crcx > 0xFFFFFFFFL) {
-      throw new IllegalArgumentException("crc < 0 or > 0xFFFFFFFF: " + crcx);
-    }
-    crc = crcx;
+    if ((crc & 0xffffffff00000000L) != 0)
+	throw new IllegalArgumentException();
+    this.crc = (int) crc;
+    this.known |= KNOWN_CRC;
   }
 
+  /**
+   * Gets the crc of the uncompressed data.
+   * @return the crc or -1 if unknown.
+   */
   public long getCrc()
   {
-    return (crc);
+    return (known & KNOWN_CRC) != 0 ? crc & 0xffffffffL : -1L;
   }
 
-  public void setMethod(int meth)
+  /**
+   * Sets the compression method.  Only DEFLATED and STORED are
+   * supported.
+   * @exception IllegalArgumentException if method is not supported.
+   * @see ZipOutputStream#DEFLATED
+   * @see ZipOutputStream#STORED 
+   */
+  public void setMethod(int method)
   {
-    if (meth != STORED && meth != DEFLATED) {
-      throw new IllegalArgumentException("unsupported compression method");
-    }
-    method = meth;
+    if (method != ZipOutputStream.STORED
+	&& method != ZipOutputStream.DEFLATED)
+	throw new IllegalArgumentException();
+    this.method = (short) method;
   }
 
+  /**
+   * Gets the compression method.  
+   * @return the compression method or -1 if unknown.
+   */
   public int getMethod()
   {
-    return (method);
+    return method;
   }
 
-  public void setExtra(byte extra[])
+  /**
+   * Sets the extra data.
+   * @exception IllegalArgumentException if extra is longer than 0xffff bytes.
+   */
+  public void setExtra(byte[] extra)
   {
-    if ((extra != null) && (extra.length > 0xFFFFF)) {
-      throw new IllegalArgumentException("extra length > 0xFFFFF");
-    }
+    if (extra == null) 
+      {
+	this.extra = null;
+	return;
+      }
+
+    if (extra.length > 0xffff)
+      throw new IllegalArgumentException();
     this.extra = extra;
+    try
+      {
+	int pos = 0;
+	while (pos < extra.length) 
+	  {
+	    int sig = (extra[pos++] & 0xff)
+	      | (extra[pos++] & 0xff) << 8;
+	    int len = (extra[pos++] & 0xff)
+	      | (extra[pos++] & 0xff) << 8;
+	    if (sig == 0x5455) 
+	      {
+		/* extended time stamp */
+		int flags = extra[pos];
+		if ((flags & 1) != 0)
+		  {
+		    long time = ((extra[pos+1] & 0xff)
+			    | (extra[pos+2] & 0xff) << 8
+			    | (extra[pos+3] & 0xff) << 16
+			    | (extra[pos+4] & 0xff) << 24);
+		    setTime(time);
+		  }
+	      }
+	    pos += len;
+	  }
+      }
+    catch (ArrayIndexOutOfBoundsException ex)
+      {
+	/* be lenient */
+	return;
+      }
   }
 
+  /**
+   * Gets the extra data.
+   * @return the extra data or null if not set.
+   */
   public byte[] getExtra()
   {
-    return (extra);
+    return extra;
   }
 
+  /**
+   * Sets the entry comment.
+   * @exception IllegalArgumentException if comment is longer than 0xffff.
+   */
   public void setComment(String comment)
   {
-    if ((comment != null) && (comment.length() > 0xFFFF)) {
-      throw new IllegalArgumentException("comment length > 0xFFFF");
-    }
+    if (comment != null && comment.length() > 0xffff)
+      throw new IllegalArgumentException();
     this.comment = comment;
   }
 
+  /**
+   * Gets the comment.
+   * @return the comment or null if not set.
+   */
   public String getComment()
   {
-    return (comment);
-  }
-
-  public void setCompressedSize(long csize)
-  {
-    if (csize < 0 || csize > 0xFFFFFFFFL) {
-	throw new IllegalArgumentException("csize < 0 or csize > 0xFFFFFFFF");
-    }
-
-    this.csize = csize;
-  }
-  
-  public long getCompressedSize()
-  {
-    return (csize);
+    return comment;
   }
 
+  /**
+   * Gets true, if the entry is a directory.  This is solely
+   * determined by the name, a trailing slash '/' marks a directory.  
+   */
   public boolean isDirectory()
   {
-    return (name.endsWith("/"));
+    int nlen = name.length();
+    return nlen > 0 && name.charAt(nlen - 1) == '/';
   }
 
+  /**
+   * Gets the string representation of this ZipEntry.  This is just
+   * the name as returned by getName().
+   */
   public String toString()
   {
-    return (getName());
+    return name;
   }
 
-  // Encode timestamp in DOS format
-  int computeDosTime(long time) {
-    time = (time + 1) & ~1L; // Round up to even seconds.
-    Calendar cal = new GregorianCalendar();
-    cal.setTime(new Date(time));
-    return encodeDosTime(
-	cal.get(Calendar.YEAR), cal.get(Calendar.MONTH) + 1,
-	cal.get(Calendar.DAY_OF_MONTH), cal.get(Calendar.HOUR_OF_DAY),
-	cal.get(Calendar.MINUTE), cal.get(Calendar.SECOND));
-  }
-
-  int encodeDosTime(int year, int month, int day, int hour,
-      int minute, int second) {
-    return (year < 1980) ? encodeDosTime(1980, 1, 1, 0, 0, 0) :
-      ((year - 1980) << 25) | (month << 21) | (day << 16) |
-      (hour << 11) | (minute << 5) | (second >>> 1);
-  }
-
-  void setDosTime(int date) {
-      Calendar cal = new GregorianCalendar();
-      cal.clear();
-      cal.set (((date >> 25) & 0x7F) + 1980,
-	       ((date >> 21) & 0xF) - 1,
-	       (date >> 16) & 0x1F,
-	       (date >> 11) & 0x1F,
-	       (date >> 5) & 0x3F,
-	       (date << 1) & 0x3E); 
-      time = cal.getTime().getTime();
-      dosTime = date;
+  /**
+   * Gets the hashCode of this ZipEntry.  This is just the hashCode
+   * of the name.  Note that the equals method isn't changed, though.
+   */
+  public int hashCode()
+  {
+    return name.hashCode();
   }
-
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/ZipFile.java kaffe/libraries/javalib/java/util/zip/ZipFile.java
--- kaffe_orig/libraries/javalib/java/util/zip/ZipFile.java	2003-09-25 21:27:46.000000000 +1200
+++ kaffe/libraries/javalib/java/util/zip/ZipFile.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,118 +1,545 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* java.util.zip.ZipFile
+   Copyright (C) 2001, 2002, 2003 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.util.zip;
 
+import java.io.BufferedInputStream;
+import java.io.DataInput;
 import java.io.File;
 import java.io.InputStream;
-import java.io.ByteArrayInputStream;
 import java.io.IOException;
+import java.io.EOFException;
+import java.io.RandomAccessFile;
 import java.util.Enumeration;
-import java.util.Vector;
-import kaffe.util.Ptr;
-
-public class ZipFile implements ZipConstants {
-
+import java.util.HashMap;
+import java.util.Iterator;
+import java.util.NoSuchElementException;
+
+/**
+ * This class represents a Zip archive.  You can ask for the contained
+ * entries, or get an input stream for a file entry.  The entry is
+ * automatically decompressed.
+ *
+ * This class is thread safe:  You can open input streams for arbitrary
+ * entries in different threads.
+ *
+ * @author Jochen Hoenicke
+ * @author Artur Biesiadowski
+ */
+public class ZipFile implements ZipConstants
+{
 
   /**
    * Mode flag to open a zip file for reading.
-   * From GNU Classpath.
    */
   public static final int OPEN_READ = 0x1;
 
   /**
    * Mode flag to delete a zip file after reading.
-   * From GNU Classpath.
    */
   public static final int OPEN_DELETE = 0x4;
 
+  // Name of this zip file.
+  private final String name;
 
-private String name;
-private Ptr zip;
+  // File from which zip entries are read.
+  private final RandomAccessFile raf;
 
-public ZipFile(String fname) throws IOException
-{
-	name = fname;
-	zip = openZipFile0(fname);
-	if (zip == null) {
-		throw new IOException("No such zip file " + fname);
-	}
-}
+  // The entries of this zip file when initialized and not yet closed.
+  private HashMap entries;
 
-public ZipFile(File f) throws ZipException, IOException
-{
-	this(f.getPath());
-}
+  private boolean closed = false;
 
-public void close() throws IOException
-{
-	if (zip != null) {
-		closeZipFile0(zip);
-		zip = null;
-	}
-}
+  /**
+   * Opens a Zip file with the given name for reading.
+   * @exception IOException if a i/o error occured.
+   * @exception ZipException if the file doesn't contain a valid zip
+   * archive.  
+   */
+  public ZipFile(String name) throws ZipException, IOException
+  {
+    this.raf = new RandomAccessFile(name, "r");
+    this.name = name;
+  }
 
-public Enumeration entries()
-{
-	Vector all = getZipEntries0(zip);
-	return (all.elements());
-}
+  /**
+   * Opens a Zip file reading the given File.
+   * @exception IOException if a i/o error occured.
+   * @exception ZipException if the file doesn't contain a valid zip
+   * archive.  
+   */
+  public ZipFile(File file) throws ZipException, IOException
+  {
+    this.raf = new RandomAccessFile(file, "r");
+    this.name = file.getName();
+  }
 
-public ZipEntry getEntry(String zname)
-{
-	return (getZipEntry0(zip, zname));
-}
+  /**
+   * Opens a Zip file reading the given File in the given mode.
+   *
+   * If the OPEN_DELETE mode is specified, the zip file will be deleted at
+   * some time moment after it is opened. It will be deleted before the zip
+   * file is closed or the Virtual Machine exits.
+   * 
+   * The contents of the zip file will be accessible until it is closed.
+   *
+   * The OPEN_DELETE mode is currently unimplemented in this library
+   * 
+   * @since JDK1.3
+   * @param mode Must be one of OPEN_READ or OPEN_READ | OPEN_DELETE
+   *
+   * @exception IOException if a i/o error occured.
+   * @exception ZipException if the file doesn't contain a valid zip
+   * archive.  
+   */
+  public ZipFile(File file, int mode) throws ZipException, IOException
+  {
+    if ((mode & OPEN_DELETE) != 0)
+      {
+	throw new IllegalArgumentException
+	  ("OPEN_DELETE mode not supported yet in java.util.zip.ZipFile");
+      }
+    this.raf = new RandomAccessFile(file, "r");
+    this.name = file.getName();
+  }
 
-public InputStream getInputStream(ZipEntry ze) throws IOException
-{
-	if (ze == null) {
-		throw new NullPointerException();
-	}
+  /**
+   * Read an unsigned short in little endian byte order from the given
+   * DataInput stream using the given byte buffer.
+   *
+   * @param di DataInput stream to read from.
+   * @param b the byte buffer to read in (must be at least 2 bytes long).
+   * @return The value read.
+   *
+   * @exception IOException if a i/o error occured.
+   * @exception EOFException if the file ends prematurely
+   */
+  private final int readLeShort(DataInput di, byte[] b) throws IOException
+  {
+    di.readFully(b, 0, 2);
+    return (b[0] & 0xff) | (b[1] & 0xff) << 8;
+  }
 
-	if (ze.size == -1) {
-		ze = getEntry(ze.name);
-	}
+  /**
+   * Read an int in little endian byte order from the given
+   * DataInput stream using the given byte buffer.
+   *
+   * @param di DataInput stream to read from.
+   * @param b the byte buffer to read in (must be at least 4 bytes long).
+   * @return The value read.
+   *
+   * @exception IOException if a i/o error occured.
+   * @exception EOFException if the file ends prematurely
+   */
+  private final int readLeInt(DataInput di, byte[] b) throws IOException
+  {
+    di.readFully(b, 0, 4);
+    return ((b[0] & 0xff) | (b[1] & 0xff) << 8)
+	    | ((b[2] & 0xff) | (b[3] & 0xff) << 8) << 16;
+  }
 
-	byte[] buf = getZipData0(zip, ze);
-	if (buf == null) {
-		throw new ZipException("no data");
-	}
-	ByteArrayInputStream strm = new ByteArrayInputStream(buf);
-	return (strm);
-}
+  
+  /**
+   * Read an unsigned short in little endian byte order from the given
+   * byte buffer at the given offset.
+   *
+   * @param b the byte array to read from.
+   * @param off the offset to read from.
+   * @return The value read.
+   */
+  private final int readLeShort(byte[] b, int off)
+  {
+    return (b[off] & 0xff) | (b[off+1] & 0xff) << 8;
+  }
 
-public String getName()
-{
-	return (name);
-}
+  /**
+   * Read an int in little endian byte order from the given
+   * byte buffer at the given offset.
+   *
+   * @param b the byte array to read from.
+   * @param off the offset to read from.
+   * @return The value read.
+   */
+  private final int readLeInt(byte[] b, int off)
+  {
+    return ((b[off] & 0xff) | (b[off+1] & 0xff) << 8)
+	    | ((b[off+2] & 0xff) | (b[off+3] & 0xff) << 8) << 16;
+  }
+  
 
-public int size()
-{
-	return getZipFileSize0(zip);
-}
+  /**
+   * Read the central directory of a zip file and fill the entries
+   * array.  This is called exactly once when first needed. It is called
+   * while holding the lock on <code>raf</code>.
+   *
+   * @exception IOException if a i/o error occured.
+   * @exception ZipException if the central directory is malformed 
+   */
+  private void readEntries() throws ZipException, IOException
+  {
+    /* Search for the End Of Central Directory.  When a zip comment is 
+     * present the directory may start earlier.
+     * FIXME: This searches the whole file in a very slow manner if the
+     * file isn't a zip file.
+     */
+    long pos = raf.length() - ENDHDR;
+    byte[] ebs  = new byte[CENHDR];
+    
+    do
+      {
+	if (pos < 0)
+	  throw new ZipException
+	    ("central directory not found, probably not a zip file: " + name);
+	raf.seek(pos--);
+      }
+    while (readLeInt(raf, ebs) != ENDSIG);
+    
+    if (raf.skipBytes(ENDTOT - ENDNRD) != ENDTOT - ENDNRD)
+      throw new EOFException(name);
+    int count = readLeShort(raf, ebs);
+    if (raf.skipBytes(ENDOFF - ENDSIZ) != ENDOFF - ENDSIZ)
+      throw new EOFException(name);
+    int centralOffset = readLeInt(raf, ebs);
+
+    entries = new HashMap(count+count/2);
+    raf.seek(centralOffset);
+    
+    byte[] buffer = new byte[16];
+    for (int i = 0; i < count; i++)
+      {
+      	raf.readFully(ebs);
+	if (readLeInt(ebs, 0) != CENSIG)
+	  throw new ZipException("Wrong Central Directory signature: " + name);
+
+	int method = readLeShort(ebs, CENHOW);
+	int dostime = readLeInt(ebs, CENTIM);
+	int crc = readLeInt(ebs, CENCRC);
+	int csize = readLeInt(ebs, CENSIZ);
+	int size = readLeInt(ebs, CENLEN);
+	int nameLen = readLeShort(ebs, CENNAM);
+	int extraLen = readLeShort(ebs, CENEXT);
+	int commentLen = readLeShort(ebs, CENCOM);
+	
+	int offset = readLeInt(ebs, CENOFF);
+
+	int needBuffer = Math.max(nameLen, commentLen);
+	if (buffer.length < needBuffer)
+	  buffer = new byte[needBuffer];
+
+	raf.readFully(buffer, 0, nameLen);
+	String name = new String(buffer, 0, 0, nameLen);
+
+	ZipEntry entry = new ZipEntry(name);
+	entry.setMethod(method);
+	entry.setCrc(crc & 0xffffffffL);
+	entry.setSize(size & 0xffffffffL);
+	entry.setCompressedSize(csize & 0xffffffffL);
+	entry.setDOSTime(dostime);
+	if (extraLen > 0)
+	  {
+	    byte[] extra = new byte[extraLen];
+	    raf.readFully(extra);
+	    entry.setExtra(extra);
+	  }
+	if (commentLen > 0)
+	  {
+	    raf.readFully(buffer, 0, commentLen);
+	    entry.setComment(new String(buffer, 0, commentLen));
+	  }
+	entry.offset = offset;
+	entries.put(name, entry);
+      }
+  }
 
-protected void finalize() throws IOException
-{
-	/* We don't need to call super.finalize(),
-	 * since super class is java.lang.Object, and
-	 * java.lang.Object.finalize() just returns
-	 * to caller.
-	 */
-	close();
-}
+  /**
+   * Closes the ZipFile.  This also closes all input streams given by
+   * this class.  After this is called, no further method should be
+   * called.
+   * 
+   * @exception IOException if a i/o error occured.
+   */
+  public void close() throws IOException
+  {
+    synchronized (raf)
+      {
+	closed = true;
+	entries = null;
+	raf.close();
+      }
+  }
+
+  /**
+   * Calls the <code>close()</code> method when this ZipFile has not yet
+   * been explicitly closed.
+   */
+  protected void finalize() throws IOException
+  {
+    if (!closed && raf != null) close();
+  }
+
+  /**
+   * Returns an enumeration of all Zip entries in this Zip file.
+   */
+  public Enumeration entries()
+  {
+    try
+      {
+	return new ZipEntryEnumeration(getEntries().values().iterator());
+      }
+    catch (IOException ioe)
+      {
+	return null;
+      }
+  }
+
+  /**
+   * Checks that the ZipFile is still open and reads entries when necessary.
+   *
+   * @exception IllegalStateException when the ZipFile has already been closed.
+   * @exception IOEexception when the entries could not be read.
+   */
+  private HashMap getEntries() throws IOException
+  {
+    synchronized(raf)
+      {
+	if (closed)
+	  throw new IllegalStateException("ZipFile has closed: " + name);
+
+	if (entries == null)
+	  readEntries();
+
+	return entries;
+      }
+  }
+
+  /**
+   * Searches for a zip entry in this archive with the given name.
+   *
+   * @param the name. May contain directory components separated by
+   * slashes ('/').
+   * @return the zip entry, or null if no entry with that name exists.
+   */
+  public ZipEntry getEntry(String name)
+  {
+    try
+      {
+	HashMap entries = getEntries();
+	ZipEntry entry = (ZipEntry) entries.get(name);
+	return entry != null ? (ZipEntry) entry.clone() : null;
+      }
+    catch (IOException ioe)
+      {
+	return null;
+      }
+  }
+
+
+  //access should be protected by synchronized(raf)
+  private byte[] locBuf = new byte[LOCHDR];
+
+  /**
+   * Checks, if the local header of the entry at index i matches the
+   * central directory, and returns the offset to the data.
+   * 
+   * @param entry to check.
+   * @return the start offset of the (compressed) data.
+   *
+   * @exception IOException if a i/o error occured.
+   * @exception ZipException if the local header doesn't match the 
+   * central directory header
+   */
+  private long checkLocalHeader(ZipEntry entry) throws IOException
+  {
+    synchronized (raf)
+      {
+	raf.seek(entry.offset);
+	raf.readFully(locBuf);
+	
+	if (readLeInt(locBuf, 0) != LOCSIG)
+	  throw new ZipException("Wrong Local header signature: " + name);
+
+	if (entry.getMethod() != readLeShort(locBuf, LOCHOW))
+	  throw new ZipException("Compression method mismatch: " + name);
+
+	if (entry.getName().length() != readLeShort(locBuf, LOCNAM))
+	  throw new ZipException("file name length mismatch: " + name);
+
+	int extraLen = entry.getName().length() + readLeShort(locBuf, LOCEXT);
+	return entry.offset + LOCHDR + extraLen;
+      }
+  }
+
+  /**
+   * Creates an input stream reading the given zip entry as
+   * uncompressed data.  Normally zip entry should be an entry
+   * returned by getEntry() or entries().
+   *
+   * @param entry the entry to create an InputStream for.
+   * @return the input stream.
+   *
+   * @exception IOException if a i/o error occured.
+   * @exception ZipException if the Zip archive is malformed.  
+   */
+  public InputStream getInputStream(ZipEntry entry) throws IOException
+  {
+    HashMap entries = getEntries();
+    String name = entry.getName();
+    ZipEntry zipEntry = (ZipEntry) entries.get(name);
+    if (zipEntry == null)
+      throw new NoSuchElementException(name);
+
+    long start = checkLocalHeader(zipEntry);
+    int method = zipEntry.getMethod();
+    InputStream is = new BufferedInputStream(new PartialInputStream
+      (raf, start, zipEntry.getCompressedSize()));
+    switch (method)
+      {
+      case ZipOutputStream.STORED:
+	return is;
+      case ZipOutputStream.DEFLATED:
+	return new InflaterInputStream(is, new Inflater(true));
+      default:
+	throw new ZipException("Unknown compression method " + method);
+      }
+  }
+  
+  /**
+   * Returns the name of this zip file.
+   */
+  public String getName()
+  {
+    return name;
+  }
+
+  /**
+   * Returns the number of entries in this zip file.
+   */
+  public int size()
+  {
+    try
+      {
+	return getEntries().size();
+      }
+    catch (IOException ioe)
+      {
+	return 0;
+      }
+  }
+  
+  private static class ZipEntryEnumeration implements Enumeration
+  {
+    private final Iterator elements;
+
+    public ZipEntryEnumeration(Iterator elements)
+    {
+      this.elements = elements;
+    }
+
+    public boolean hasMoreElements()
+    {
+      return elements.hasNext();
+    }
+
+    public Object nextElement()
+    {
+      /* We return a clone, just to be safe that the user doesn't
+       * change the entry.  
+       */
+      return ((ZipEntry)elements.next()).clone();
+    }
+  }
+
+  private static class PartialInputStream extends InputStream
+  {
+    private final RandomAccessFile raf;
+    long filepos, end;
+
+    public PartialInputStream(RandomAccessFile raf, long start, long len)
+    {
+      this.raf = raf;
+      filepos = start;
+      end = start + len;
+    }
+    
+    public int available()
+    {
+      long amount = end - filepos;
+      if (amount > Integer.MAX_VALUE)
+	return Integer.MAX_VALUE;
+      return (int) amount;
+    }
+    
+    public int read() throws IOException
+    {
+      if (filepos == end)
+	return -1;
+      synchronized (raf)
+	{
+	  raf.seek(filepos++);
+	  return raf.read();
+	}
+    }
 
-private static native Ptr openZipFile0(String fname);
-private static native void closeZipFile0(Ptr zip);
-private static native ZipEntry getZipEntry0(Ptr zip, String zname);
-private static native Vector getZipEntries0(Ptr zip);
-private static native byte[] getZipData0(Ptr zip, ZipEntry ze);
-private static native int getZipFileSize0(Ptr zip);
+    public int read(byte[] b, int off, int len) throws IOException
+    {
+      if (len > end - filepos)
+	{
+	  len = (int) (end - filepos);
+	  if (len == 0)
+	    return -1;
+	}
+      synchronized (raf)
+	{
+	  raf.seek(filepos);
+	  int count = raf.read(b, off, len);
+	  if (count > 0)
+	    filepos += len;
+	  return count;
+	}
+    }
 
+    public long skip(long amount)
+    {
+      if (amount < 0)
+	throw new IllegalArgumentException();
+      if (amount > end - filepos)
+	amount = end - filepos;
+      filepos += amount;
+      return amount;
+    }
+  }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/ZipInputStream.java kaffe/libraries/javalib/java/util/zip/ZipInputStream.java
--- kaffe_orig/libraries/javalib/java/util/zip/ZipInputStream.java	2002-01-04 18:12:28.000000000 +1300
+++ kaffe/libraries/javalib/java/util/zip/ZipInputStream.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,218 +1,371 @@
+/* java.util.zip.ZipInputStream
+   Copyright (C) 2001, 2002, 2003 Free Software Foundation, Inc.
 
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+This file is part of GNU Classpath.
 
-package java.util.zip;
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-import java.io.IOException;
-import java.io.InputStream;
-import kaffe.util.UTF8;
-import kaffe.util.zip.SwitchInflater;
 
-public class ZipInputStream extends InflaterInputStream
-	implements ZipConstants {
+package java.util.zip;
 
-  private byte sigbuf[] = new byte[4];
-  private byte zheader[] = new byte[LOC_RECSZ];
-  private byte dheader[] = new byte[DATA_RECSZ];
-  private boolean gotSig;
-  private SwitchInflater sinf;
-  private ZipEntry entry;
+import java.io.EOFException;
+import java.io.InputStream;
+import java.io.IOException;
 
-  public ZipInputStream(InputStream in) {
-    super(in, new SwitchInflater(true, true));
-    sinf = (SwitchInflater)inf;
-    sinf.reset();
-    sinf.setMode(true);
-    sinf.setLength(Integer.MAX_VALUE);
+/**
+ * This is a FilterInputStream that reads the files in an zip archive
+ * one after another.  It has a special method to get the zip entry of
+ * the next file.  The zip entry contains information about the file name
+ * size, compressed size, CRC, etc.
+ *
+ * It includes support for STORED and DEFLATED entries.
+ *
+ * @author Jochen Hoenicke
+ */
+public class ZipInputStream extends InflaterInputStream implements ZipConstants
+{
+  private CRC32 crc = new CRC32();
+  private ZipEntry entry = null;
+
+  private int csize;
+  private int size;
+  private int method;
+  private int flags;
+  private int avail;
+  private boolean entryAtEOF;
+
+  /**
+   * Creates a new Zip input stream, reading a zip archive.
+   */
+  public ZipInputStream(InputStream in)
+  {
+    super(in, new Inflater(true));
+  }
+
+  private void fillBuf() throws IOException
+  {
+    avail = len = in.read(buf, 0, buf.length);
+  }
+
+  private int readBuf(byte[] out, int offset, int length) throws IOException
+  {
+    if (avail <= 0)
+      {
+	fillBuf();
+	if (avail <= 0)
+	  return -1;
+      }
+    if (length > avail)
+      length = avail;
+    System.arraycopy(buf, len - avail, out, offset, length);
+    avail -= length;
+    return length;
+  }
+  
+  private void readFully(byte[] out) throws IOException
+  {
+    int off = 0;
+    int len = out.length;
+    while (len > 0)
+      {
+	int count = readBuf(out, off, len);
+	if (count == -1)
+	  throw new EOFException();
+	off += count;
+	len -= count;
+      }
+  }
+  
+  private final int readLeByte() throws IOException
+  {
+    if (avail <= 0)
+      {
+	fillBuf();
+	if (avail <= 0)
+	  throw new ZipException("EOF in header");
+      }
+    return buf[len - avail--] & 0xff;
   }
 
-  public ZipEntry getNextEntry() throws IOException {
-
-    closeEntry();
-
-    synchronized (this) {
-
-      // Read next signature
-      int sig = readSig();
-      switch (sig) {
-      case (int)CEN_HEADSIG:		// central dir: no more entries
+  /**
+   * Read an unsigned short in little endian byte order.
+   */
+  private final int readLeShort() throws IOException 
+  {
+    return readLeByte() | (readLeByte() << 8);
+  }
+
+  /**
+   * Read an int in little endian byte order.
+   */
+  private final int readLeInt() throws IOException 
+  {
+    return readLeShort() | (readLeShort() << 16);
+  }
+
+  /**
+   * Open the next entry from the zip archive, and return its description.
+   * If the previous entry wasn't closed, this method will close it.
+   */
+  public ZipEntry getNextEntry() throws IOException
+  {
+    if (crc == null)
+      throw new IOException("Stream closed.");
+    if (entry != null)
+      closeEntry();
+
+    int header = readLeInt();
+    if (header == CENSIG)
+      {
+	/* Central Header reached. */
+	close();
 	return null;
-      case (int)LOC_HEADSIG:		// another entry
-	break;
-      default:				// unexpected
-	throw new IOException("Bogus signature: 0x" + Integer.toHexString(sig));
       }
-
-      // Read remainder of local header
-      readFully(zheader, sigbuf.length, zheader.length - sigbuf.length);
-
-      // Read filename; assume UTF-8 encoding
-      byte[] nameBuf = new byte[get16(zheader, LOC_FILENAMELEN)];
-      readFully(nameBuf, 0, nameBuf.length);
-
-      // Read extra field
-      byte[] extra = new byte[get16(zheader, LOC_EXTRAFIELDLEN)];
-      readFully(extra, 0, extra.length);
-
-      // Setup new entry
-      entry = new ZipEntry(UTF8.decode(nameBuf));
-      entry.version = get16(zheader, LOC_VERSIONEXTRACT);
-      entry.flag    = get16(zheader, LOC_FLAGS);
-
-      entry.setMethod(get16(zheader, LOC_METHOD));
-      entry.setDosTime(get32(zheader, LOC_TIME));
-      entry.setCrc(get32(zheader, LOC_CRC) & 0xffffffffL);
-
-      entry.setCompressedSize(get32(zheader, LOC_COMPRESSEDSIZE) & 0xffffffffL);
-      entry.setSize(get32(zheader, LOC_UNCOMPRESSEDSIZE) & 0xffffffffL);
-
-      entry.setExtra( extra );
-      entry.setComment("");
-      entry.offset = 0;
-
-      // Select the loader, simple or inflater.
-      if (entry.method == STORED) {
-	sinf.setMode(true);
-	sinf.setLength((int)entry.csize);
+    if (header != LOCSIG)
+      throw new ZipException("Wrong Local header signature: "
+			     + Integer.toHexString(header));
+    /* skip version */
+    readLeShort();
+    flags = readLeShort();
+    method = readLeShort();
+    int dostime = readLeInt();
+    int crc = readLeInt();
+    csize = readLeInt();
+    size = readLeInt();
+    int nameLen = readLeShort();
+    int extraLen = readLeShort();
+
+    if (method == ZipOutputStream.STORED && csize != size)
+      throw new ZipException("Stored, but compressed != uncompressed");
+
+
+    byte[] buffer = new byte[nameLen];
+    readFully(buffer);
+    String name = new String(buffer);
+    
+    entry = createZipEntry(name);
+    entryAtEOF = false;
+    entry.setMethod(method);
+    if ((flags & 8) == 0)
+      {
+	entry.setCrc(crc & 0xffffffffL);
+	entry.setSize(size & 0xffffffffL);
+	entry.setCompressedSize(csize & 0xffffffffL);
       }
-      else {
-	sinf.setMode(false);
+    entry.setDOSTime(dostime);
+    if (extraLen > 0)
+      {
+	byte[] extra = new byte[extraLen];
+	readFully(extra);
+	entry.setExtra(extra);
       }
 
-      //System.out.println("ZipEntry (Post LOC): " + entry + ", meth="
-      // + entry.method + ", size=" + entry.size + ", csize=" + entry.csize
-      // + ", crc=" + entry.crc);
-
-      return entry;
-    }
+    if (method == ZipOutputStream.DEFLATED && avail > 0)
+      {
+	System.arraycopy(buf, len - avail, buf, 0, avail);
+	len = avail;
+	avail = 0;
+	inf.setInput(buf, 0, len);
+      }
+    return entry;
   }
 
-  public void closeEntry() throws IOException {
-    synchronized (this) {
-
-      // Don't do this twice
-      if (entry == null)
-	return;
-
-      // Cleanup
-      try {
-
-	// Skip remaining compressed data
-	byte[] buf = new byte[512];
-	while (read(buf, 0, buf.length) != -1);
-
-	// Reset inflate state machine
-	sinf.reset();
-	sinf.setMode(true);
-	sinf.setLength(Integer.MAX_VALUE);
-
-	// In the case where closeEntry() is called after reading
-	// a compressed entry, we need to read the DATA header that
-	// follows, if any, and update the ZipEntry with the info
-	// from the DATA header. This is so that users can find out
-	// the compressed and uncompressed sizes of data written in
-	// a compressed entry.
-	if (entry.method == DEFLATED && peekSig() == (int)DATA_HEADSIG) {
-
-	  // Consume signature
-	  readSig();
-
-	  // Read remainder of data header
-	  readFully(dheader, sigbuf.length, dheader.length - sigbuf.length);
-
-	  // Read CRC
-	  int data_crc = get32(dheader, DATA_CRC);
-	  entry.setCrc(data_crc & 0xffffffffL);
-
-	  // Read compressed size
-	  int data_csize = get32(dheader, DATA_COMPRESSEDSIZE);
-	  entry.setCompressedSize(data_csize & 0xffffffffL);
-
-	  // Read uncompressed size
-	  int data_size = get32(dheader, DATA_UNCOMPRESSEDSIZE);
-	  if (data_crc == 0 && data_size != 0) {
-	      throw new IOException(
-		"CRC error: data_crc=0, data_csize=" + data_csize + ",data_size=" + data_size);
+  private void readDataDescr() throws IOException
+  {
+    if (readLeInt() != EXTSIG)
+      throw new ZipException("Data descriptor signature not found");
+    entry.setCrc(readLeInt() & 0xffffffffL);
+    csize = readLeInt();
+    size = readLeInt();
+    entry.setSize(size & 0xffffffffL);
+    entry.setCompressedSize(csize & 0xffffffffL);
+  }
+
+  /**
+   * Closes the current zip entry and moves to the next one.
+   */
+  public void closeEntry() throws IOException
+  {
+    if (crc == null)
+      throw new IOException("Stream closed.");
+    if (entry == null)
+      return;
+
+    if (method == ZipOutputStream.DEFLATED)
+      {
+	if ((flags & 8) != 0)
+	  {
+	    /* We don't know how much we must skip, read until end. */
+	    byte[] tmp = new byte[2048];
+	    while (read(tmp) > 0)
+	      ;
+	    /* read will close this entry */
+	    return;
 	  }
-	  entry.setSize(data_size & 0xffffffffL);
-
-	  //System.out.println("ZipEntry (Post DATA): " + entry
-	  // + ", meth=" + entry.method + ", size=" + entry.size
-	  // + ", csize=" + entry.csize + ", crc=" + entry.crc);
-	}
-      } finally {
-	entry = null;
+	csize -= inf.getTotalIn();
+	avail = inf.getRemaining();
       }
-    }
-  }
-
-  public int read(byte[] b, int off, int len) throws IOException {
-    return super.read(b, off, len);
-  }
 
-  public long skip(long n) throws IOException {
-    return super.skip(n);
-  }
+    if (avail > csize && csize >= 0)
+      avail -= csize;
+    else
+      {
+	csize -= avail;
+	avail = 0;
+	while (csize != 0)
+	  {
+	    long skipped = in.skip(csize & 0xffffffffL);
+	    if (skipped <= 0)
+	      throw new ZipException("zip archive ends early.");
+	    csize -= skipped;
+	  }
+      }
 
-  public void close() throws IOException {
-    closeEntry();
-    super.close();
-  }
+    size = 0;
+    crc.reset();
+    if (method == ZipOutputStream.DEFLATED)
+      inf.reset();
+    entry = null;
+    entryAtEOF = true;
+  }
+
+  public int available() throws IOException
+  {
+    return entryAtEOF ? 0 : 1;
+  }
+
+  /**
+   * Reads a byte from the current zip entry.
+   * @return the byte or -1 on EOF.
+   * @exception IOException if a i/o error occured.
+   * @exception ZipException if the deflated stream is corrupted.
+   */
+  public int read() throws IOException
+  {
+    byte[] b = new byte[1];
+    if (read(b, 0, 1) <= 0)
+      return -1;
+    return b[0] & 0xff;
+  }
+
+  /**
+   * Reads a block of bytes from the current zip entry.
+   * @return the number of bytes read (may be smaller, even before
+   * EOF), or -1 on EOF.
+   * @exception IOException if a i/o error occured.
+   * @exception ZipException if the deflated stream is corrupted.
+   */
+  public int read(byte[] b, int off, int len) throws IOException
+  {
+    if (len == 0)
+      return 0;
+    if (crc == null)
+      throw new IOException("Stream closed.");
+    if (entry == null)
+      return -1;
+    boolean finished = false;
+    switch (method)
+      {
+      case ZipOutputStream.DEFLATED:
+	len = super.read(b, off, len);
+	if (len < 0)
+	  {
+	    if (!inf.finished())
+	      throw new ZipException("Inflater not finished!?");
+	    avail = inf.getRemaining();
+	    if ((flags & 8) != 0)
+	      readDataDescr();
+
+	    if (inf.getTotalIn() != csize
+		|| inf.getTotalOut() != size)
+	      throw new ZipException("size mismatch: "+csize+";"+size+" <-> "+inf.getTotalIn()+";"+inf.getTotalOut());
+	    inf.reset();
+	    finished = true;
+	  }
+	break;
+	
+      case ZipOutputStream.STORED:
 
-  private int get16(byte[] buf, int base) {
-    int val = (int)buf[base] & 0xFF;
-    val |= ((int)buf[base+1] & 0xFF) << 8;
-    return (val);
-  }
+	if (len > csize && csize >= 0)
+	  len = csize;
+	
+	len = readBuf(b, off, len);
+	if (len > 0)
+	  {
+	    csize -= len;
+	    size -= len;
+	  }
 
-  private int get32(byte[] buf, int base) {
-    return  buf[base] & 0xFF
-	| ((buf[base+1] & 0xFF) << 8)
-	| ((buf[base+2] & 0xFF) << 16)
-	| ((buf[base+3] & 0xFF) << 24);
-  }
+	if (csize == 0)
+	  finished = true;
+	else if (len < 0)
+	  throw new ZipException("EOF in stored block");
+	break;
+      }
 
-  private void readFully(byte[] buf, int off, int len) throws IOException {
-    int nread;
+    if (len > 0)
+      crc.update(b, off, len);
 
-    for (int remain = len; remain > 0; remain -= nread) {
-      nread = read(buf, off, remain);
-      if (nread == -1) {
-	if (remain != 0) {
-	  throw new IOException("truncated file (only read "
-	    + (len - remain) + "/" + len + ")");
-	}
-	return;
+    if (finished)
+      {
+	if ((crc.getValue() & 0xffffffffL) != entry.getCrc())
+	  throw new ZipException("CRC mismatch");
+	crc.reset();
+	entry = null;
+	entryAtEOF = true;
       }
-      off += nread;
-    }
-  }
-
-  private int readSig() throws IOException {
-    int sig = peekSig();
-    gotSig = false;
-    return sig;
+    return len;
   }
 
-  private int peekSig() throws IOException {
-    if (!gotSig) {
-      readFully(sigbuf, 0, sigbuf.length);
-      gotSig = true;
-    }
-    return get32(sigbuf, 0);
+  /**
+   * Closes the zip file.
+   * @exception IOException if a i/o error occured.
+   */
+  public void close() throws IOException
+  {
+    super.close();
+    crc = null;
+    entry = null;
+    entryAtEOF = true;
   }
 
-  protected ZipEntry createZipEntry(String name) {
-	// XXX FIXME what is this supposed to do?
-	return null;
+  /**
+   * Creates a new zip entry for the given name.  This is equivalent
+   * to new ZipEntry(name).
+   * @param name the name of the zip entry.
+   */
+  protected ZipEntry createZipEntry(String name) 
+  {
+    return new ZipEntry(name);
   }
 }
-
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/util/zip/ZipOutputStream.java kaffe/libraries/javalib/java/util/zip/ZipOutputStream.java
--- kaffe_orig/libraries/javalib/java/util/zip/ZipOutputStream.java	2001-12-03 16:42:07.000000000 +1300
+++ kaffe/libraries/javalib/java/util/zip/ZipOutputStream.java	2003-09-27 23:01:41.000000000 +1200
@@ -1,12 +1,40 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* java.util.zip.ZipOutputStream
+   Copyright (C) 2001 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
 
 package java.util.zip;
 
@@ -14,329 +42,357 @@
 import java.io.OutputStream;
 import java.util.Enumeration;
 import java.util.Vector;
-import kaffe.util.UTF8;
-
-// Reference: ftp://ftp.uu.net/pub/archiving/zip/doc/appnote-970311-iz.zip
-
-public class ZipOutputStream extends DeflaterOutputStream
-	implements ZipConstants {
-
-  public static final int STORED = Deflater.NO_COMPRESSION;
-  public static final int DEFLATED = Deflater.DEFLATED;
-
-private static final int ZIPVER_1_0 = 0x000a;
-private static final int ZIPVER_2_0 = 0x0014;
-
-private int method = Deflater.DEFLATED;
-private int level = Deflater.DEFAULT_COMPRESSION;
-private ZipEntry curr;
-private Vector dir;
-private OutputStream strm;
-private int dout;
-private CRC32 crc;
-
-class Storer
-  extends Deflater {
-
-private int total;
-private byte[] buf;
-private int off;
-private int len;
-
-Storer() {
-    total = 0;
-    off = 0;
-    len = 0;
-}
-
-public int deflate(byte[] b, int p, int l) {
-	if (l >= len) {
-		l = len;
-	}
-	System.arraycopy(buf, off, b, p, l);
-	total += l;
-	off += l;
-	len -= l;
-	return (l);
-}
-
-public synchronized void setInput(byte b[], int o, int l)
-{
-	buf = b;
-	off = o;
-	len = l;
-}
-
-public boolean needsInput() {
-	return (len > 0 ? false : true);
-}
-
-public boolean finished() {
-	return (len > 0 ? false : true);
-}
-
-public int getTotalIn() {
-	return (total);
-}
-
-public int getTotalOut() {
-	return (total);
-}
-
-public void reset() {
-}
-
-}
-
-public ZipOutputStream(OutputStream out)
-{
-	super(out);
-	strm = out;
-	curr = null;
-	dir = new Vector();
-	dout = 0;
-	crc = new CRC32();
-}
-
-public void close() throws IOException
-{
-	finish();
-	super.close();
-}
 
-public void closeEntry() throws IOException
-{
-	if (curr == null) {
-		return;
-	}
-
-	super.finish();
-	int in = def.getTotalIn();
-	int out = def.getTotalOut();
-	long crcval = crc.getValue();
-	def.reset();
-	crc.reset();
-
-	if (curr.csize != -1 && curr.csize != out) {
-		throw new ZipException("compress size set incorrectly");
-	}
-	if (curr.size != -1 && curr.size != in) {
-		throw new ZipException("uncompress size set incorrectly");
-	}
-	if (curr.crc != -1 && curr.crc != crcval) {
-		throw new ZipException("crc set incorrectly");
-	}
-
-	curr.csize = out;
-	curr.size = in;
-	curr.crc = crcval;
-
-	dout += curr.csize;
-
-	// We only add the data descriptor when writing a compressed entry
-
-	if (curr.flag == 0x0008) {
-	    byte[] da = new byte[DATA_RECSZ];
-	    put32(da, DATA_SIGNATURE, (int)DATA_HEADSIG);
-	    put32(da, DATA_CRC, (int)curr.crc);
-	    put32(da, DATA_COMPRESSEDSIZE, (int) curr.csize);
-	    put32(da, DATA_UNCOMPRESSEDSIZE, (int) curr.size);
-	    strm.write(da);
-	    dout += DATA_RECSZ;
-	}
-
-	curr = null;
-}
-
-public void finish() throws IOException {
-	byte[] ch = new byte[CEN_RECSZ];
-	int count = 0;
-	int size = 0;
-
-	if (dir == null) {
-		return;
-	}
-
-	closeEntry();
-
-	// Write the central directory
-	for (Enumeration e = dir.elements(); e.hasMoreElements(); ) {
-		ZipEntry ze = (ZipEntry)e.nextElement();
-
-		// Convert name to UTF-8 binary
-		byte[] nameBuf = (ze.name != null) ?
-		    UTF8.encode(ze.name) : new byte[0];
-
-		// Write central directory entry
-		put32(ch, CEN_SIGNATURE, (int)CEN_HEADSIG);
-		int zipver = (ze.method == STORED ? ZIPVER_1_0 : ZIPVER_2_0);
-		put16(ch, CEN_VERSIONMADE, zipver);
-		put16(ch, CEN_VERSIONEXTRACT, zipver);
-		put16(ch, CEN_FLAGS, ze.flag);
-		put16(ch, CEN_METHOD, ze.method);
-		put32(ch, CEN_TIME, ze.dosTime);
-		put32(ch, CEN_CRC, (int)ze.crc);
-		put32(ch, CEN_COMPRESSEDSIZE, (int)ze.csize);
-		put32(ch, CEN_UNCOMPRESSEDSIZE, (int)ze.size);
-		put16(ch, CEN_FILENAMELEN, nameBuf.length);
-		put16(ch, CEN_EXTRAFIELDLEN, ze.extra == null ?
-			0 : ze.extra.length);
-		put16(ch, CEN_FILECOMMENTLEN, ze.comment == null ?
-			0 : ze.comment.length());
-		put16(ch, CEN_DISKNUMBER, 0);
-		put16(ch, CEN_INTERNALATTR, 0);
-		put32(ch, CEN_EXTERNALATTR, 0);
-		put32(ch, CEN_LCLOFFSET, (int)ze.offset);
-
-		strm.write(ch);
-		size += CEN_RECSZ;
-
-		// Write name
-		strm.write(nameBuf);
-		size += nameBuf.length;
-
-		// Write any extra stuff
-		if (ze.extra != null) {
-		    strm.write(ze.extra);
-		    size += ze.extra.length;
-		}
-
-		count++;
-	}
-
-	// Flag error if no entries were written.
-	if (count == 0) {
-	        throw new ZipException("ZIP file must have at least one entry");
-	}
-
-	byte[] ce = new byte[END_RECSZ];
-	put32(ce, END_SIGNATURE, (int)END_ENDSIG);
-	put16(ce, END_DISKNUMBER, 0);
-	put16(ce, END_CENDISKNUMBER, 0);
-	put16(ce, END_TOTALCENONDISK, count);
-	put16(ce, END_TOTALCEN, count);
-	put32(ce, END_CENSIZE, size);
-	put32(ce, END_CENOFFSET, dout);
-	put16(ce, END_COMMENTLEN, 0);
-
-	strm.write(ce);
-
-	dir = null;
-}
-
-public void putNextEntry(ZipEntry ze) throws IOException
-{
-	closeEntry();	// Close previous entry
-
-	if (ze.method == -1) {
-		ze.method = method;
-	}
-	if (ze.method == STORED) {
-		if (ze.size == -1) {
-			throw new ZipException("size not set in stored entry");
-		}
-		ze.csize = ze.size;
-		if (ze.crc == -1) {
-			throw new ZipException("crc not set in stored entry");
-		}
-		ze.flag = 0;
-	} else {
-		ze.flag = 0x0008;
-	}
-
-	if (curr == null || curr.method != ze.method) {
-		if (ze.method == STORED) {
-			def = new Storer();
-		}
-		else {
-			def = new Deflater(level, true);
-		}
-	}
-
-	// Convert name to UTF-8 binary
-	byte[] nameBuf = (ze.name != null) ?
-	    UTF8.encode(ze.name) : new byte[0];
-
-	byte[] lh = new byte[LOC_RECSZ];
-	put32(lh, LOC_SIGNATURE, (int)LOC_HEADSIG);
-	put16(lh, LOC_VERSIONEXTRACT,
-		ze.method == STORED ? ZIPVER_1_0 : ZIPVER_2_0);
-	put16(lh, LOC_FLAGS, ze.flag);
-	put16(lh, LOC_METHOD, ze.method);
-	put32(lh, LOC_TIME, ze.dosTime);
-
-	if (ze.method == STORED) {
-		put32(lh, LOC_CRC, (int)ze.crc);
-		put32(lh, LOC_COMPRESSEDSIZE, (int)ze.csize);
-		put32(lh, LOC_UNCOMPRESSEDSIZE, (int)ze.size);
-	} else {
-		put32(lh, LOC_CRC, 0);
-		put32(lh, LOC_COMPRESSEDSIZE, 0);
-		put32(lh, LOC_UNCOMPRESSEDSIZE, 0);
-	}
-
-	put16(lh, LOC_FILENAMELEN, nameBuf.length);
-	put16(lh, LOC_EXTRAFIELDLEN, ze.extra == null ? 0 : ze.extra.length);
-
-	strm.write(lh);
-
-	ze.offset = dout;
-	dout += LOC_RECSZ;
-
-	// Write name
-	strm.write(nameBuf);
-	dout += nameBuf.length;
-
-	// Write any extra stuff
-	if (ze.extra != null) {
-		strm.write(ze.extra);
-		dout += ze.extra.length;
-	}
-
-	// Add entry to list of entries we need to write at the end.
-	dir.addElement(ze);
-
-	curr = ze;
-}
-
-public void setComment(String comment)
-{
-	// Currently ignored.
-}
-
-public void setLevel(int lvl)
-{
-	if ((lvl < Deflater.NO_COMPRESSION || lvl > Deflater.BEST_COMPRESSION)
-	    && lvl != Deflater.DEFAULT_COMPRESSION) {
-		throw new IllegalArgumentException("bad compression level");
-	}
-	level = lvl;
-}
-
-public void setMethod(int m)
-{
-	if (m != DEFLATED && m != STORED) {
-		throw new IllegalArgumentException("bad compression method");
-	}
-	method = m;
-}
-
-public synchronized void write(byte[] buf, int off, int len) throws IOException
+/**
+ * This is a FilterOutputStream that writes the files into a zip
+ * archive one after another.  It has a special method to start a new
+ * zip entry.  The zip entries contains information about the file name
+ * size, compressed size, CRC, etc.
+ *
+ * It includes support for STORED and DEFLATED entries.
+ *
+ * This class is not thread safe.
+ *
+ * @author Jochen Hoenicke 
+ */
+public class ZipOutputStream extends DeflaterOutputStream implements ZipConstants
 {
-	super.write(buf, off, len);
-	crc.update(buf, off, len);
-}
-
-private void put16(byte[] zheader, int pos, int val) {
-	zheader[pos] = (byte)val;
-	zheader[pos+1] = (byte)(val >>> 8);
-}
-
-private void put32(byte[] zheader, int pos, int val) {
-	zheader[pos] = (byte)val;
-	zheader[pos+1] = (byte)(val >>> 8);
-	zheader[pos+2] = (byte)(val >>> 16);
-	zheader[pos+3] = (byte)(val >>> 24);
-}
-
+  private Vector entries = new Vector();
+  private CRC32 crc = new CRC32();
+  private ZipEntry curEntry = null;
+
+  private int curMethod;
+  private int size;
+  private int offset = 0;
+
+  private byte[] zipComment = new byte[0];
+  private int defaultMethod = DEFLATED;
+
+  /**
+   * Our Zip version is hard coded to 1.0 resp. 2.0
+   */
+  private final static int ZIP_STORED_VERSION   = 10;
+  private final static int ZIP_DEFLATED_VERSION = 20;
+
+  /**
+   * Compression method.  This method doesn't compress at all.
+   */
+  public final static int STORED      =  0;
+  /**
+   * Compression method.  This method uses the Deflater.
+   */
+  public final static int DEFLATED    =  8;
+
+  /**
+   * Creates a new Zip output stream, writing a zip archive.
+   * @param out the output stream to which the zip archive is written.
+   */
+  public ZipOutputStream(OutputStream out)
+  {
+    super(out, new Deflater(Deflater.DEFAULT_COMPRESSION, true));
+  }
+
+  /**
+   * Set the zip file comment.
+   * @param comment the comment.
+   * @exception IllegalArgumentException if encoding of comment is
+   * longer than 0xffff bytes.
+   */
+  public void setComment(String comment)
+  {
+    byte[] commentBytes;
+    commentBytes = comment.getBytes();
+    if (commentBytes.length > 0xffff)
+      throw new IllegalArgumentException("Comment too long.");
+    zipComment = commentBytes;
+  }
+  
+  /**
+   * Sets default compression method.  If the Zip entry specifies
+   * another method its method takes precedence.
+   * @param method the method.
+   * @exception IllegalArgumentException if method is not supported.
+   * @see #STORED
+   * @see #DEFLATED
+   */
+  public void setMethod(int method)
+  {
+    if (method != STORED && method != DEFLATED)
+      throw new IllegalArgumentException("Method not supported.");
+    defaultMethod = method;
+  }
+
+  /**
+   * Sets default compression level.  The new level will be activated
+   * immediately.  
+   * @exception IllegalArgumentException if level is not supported.
+   * @see Deflater
+   */
+  public void setLevel(int level)
+  {
+    def.setLevel(level);
+  }
+  
+  /**
+   * Write an unsigned short in little endian byte order.
+   */
+  private final void writeLeShort(int value) throws IOException 
+  {
+    out.write(value & 0xff);
+    out.write((value >> 8) & 0xff);
+  }
+
+  /**
+   * Write an int in little endian byte order.
+   */
+  private final void writeLeInt(int value) throws IOException 
+  {
+    writeLeShort(value);
+    writeLeShort(value >> 16);
+  }
+
+  /**
+   * Starts a new Zip entry. It automatically closes the previous
+   * entry if present.  If the compression method is stored, the entry
+   * must have a valid size and crc, otherwise all elements (except
+   * name) are optional, but must be correct if present.  If the time
+   * is not set in the entry, the current time is used.
+   * @param entry the entry.
+   * @exception IOException if an I/O error occured.
+   * @exception ZipException if stream was finished.
+   */
+  public void putNextEntry(ZipEntry entry) throws IOException
+  {
+    if (entries == null)
+      throw new ZipException("ZipOutputStream was finished");
+
+    int method = entry.getMethod();
+    int flags = 0;
+    if (method == -1)
+      method = defaultMethod;
+
+    if (method == STORED)
+      {
+	if (entry.getCompressedSize() >= 0)
+	  {
+	    if (entry.getSize() < 0)
+	      entry.setSize(entry.getCompressedSize());
+	    else if (entry.getSize() != entry.getCompressedSize())
+	      throw new ZipException
+		("Method STORED, but compressed size != size");
+	  }
+	else
+	  entry.setCompressedSize(entry.getSize());
+
+	if (entry.getSize() < 0)
+	  throw new ZipException("Method STORED, but size not set");
+	if (entry.getCrc() < 0)
+	  throw new ZipException("Method STORED, but crc not set");
+      }
+    else if (method == DEFLATED)
+      {
+	if (entry.getCompressedSize() < 0
+	    || entry.getSize() < 0 || entry.getCrc() < 0)
+	  flags |= 8;
+      }
+
+    if (curEntry != null)
+      closeEntry();
+
+    if (entry.getTime() < 0)
+      entry.setTime(System.currentTimeMillis());
+
+    entry.flags = flags;
+    entry.offset = offset;
+    entry.setMethod(method);
+    curMethod = method;
+    /* Write the local file header */
+    writeLeInt(LOCSIG);
+    writeLeShort(method == STORED
+		 ? ZIP_STORED_VERSION : ZIP_DEFLATED_VERSION);
+    writeLeShort(flags);
+    writeLeShort(method);
+    writeLeInt(entry.getDOSTime());
+    if ((flags & 8) == 0)
+      {
+	writeLeInt((int)entry.getCrc());
+	writeLeInt((int)entry.getCompressedSize());
+	writeLeInt((int)entry.getSize());
+      }
+    else
+      {
+	writeLeInt(0);
+	writeLeInt(0);
+	writeLeInt(0);
+      }
+    byte[] name = entry.getName().getBytes();
+    if (name.length > 0xffff)
+      throw new ZipException("Name too long.");
+    byte[] extra = entry.getExtra();
+    if (extra == null)
+      extra = new byte[0];
+    writeLeShort(name.length);
+    writeLeShort(extra.length);
+    out.write(name);
+    out.write(extra);
+
+    offset += LOCHDR + name.length + extra.length;
+
+    /* Activate the entry. */
+
+    curEntry = entry;
+    crc.reset();
+    if (method == DEFLATED)
+      def.reset();
+    size = 0;
+  }
+
+  /**
+   * Closes the current entry.
+   * @exception IOException if an I/O error occured.
+   * @exception ZipException if no entry is active.
+   */
+  public void closeEntry() throws IOException
+  {
+    if (curEntry == null)
+      throw new ZipException("No open entry");
+
+    /* First finish the deflater, if appropriate */
+    if (curMethod == DEFLATED)
+      super.finish();
+
+    int csize = curMethod == DEFLATED ? def.getTotalOut() : size;
+
+    if (curEntry.getSize() < 0)
+      curEntry.setSize(size);
+    else if (curEntry.getSize() != size)
+      throw new ZipException("size was "+size
+			     +", but I expected "+curEntry.getSize());
+
+    if (curEntry.getCompressedSize() < 0)
+      curEntry.setCompressedSize(csize);
+    else if (curEntry.getCompressedSize() != csize)
+      throw new ZipException("compressed size was "+csize
+			     +", but I expected "+curEntry.getSize());
+
+    if (curEntry.getCrc() < 0)
+      curEntry.setCrc(crc.getValue());
+    else if (curEntry.getCrc() != crc.getValue())
+      throw new ZipException("crc was " + Long.toHexString(crc.getValue())
+			     + ", but I expected " 
+			     + Long.toHexString(curEntry.getCrc()));
+
+    offset += csize;
+
+    /* Now write the data descriptor entry if needed. */
+    if (curMethod == DEFLATED && (curEntry.flags & 8) != 0)
+      {
+	writeLeInt(EXTSIG);
+	writeLeInt((int)curEntry.getCrc());
+	writeLeInt((int)curEntry.getCompressedSize());
+	writeLeInt((int)curEntry.getSize());
+	offset += EXTHDR;
+      }
+
+    entries.addElement(curEntry);
+    curEntry = null;
+  }
+
+  /**
+   * Writes the given buffer to the current entry.
+   * @exception IOException if an I/O error occured.
+   * @exception ZipException if no entry is active.
+   */
+  public void write(byte[] b, int off, int len) throws IOException
+  {
+    if (curEntry == null)
+      throw new ZipException("No open entry.");
+
+    switch (curMethod)
+      {
+      case DEFLATED:
+	super.write(b, off, len);
+	break;
+	
+      case STORED:
+	out.write(b, off, len);
+	break;
+      }
+
+    crc.update(b, off, len);
+    size += len;
+  }
+
+  /**
+   * Finishes the stream.  This will write the central directory at the
+   * end of the zip file and flush the stream.
+   * @exception IOException if an I/O error occured.
+   */
+  public void finish() throws IOException
+  {
+    if (entries == null)
+      return;
+    if (curEntry != null)
+      closeEntry();
+
+    int numEntries = 0;
+    int sizeEntries = 0;
+    
+    Enumeration enum = entries.elements();
+    while (enum.hasMoreElements())
+      {
+	ZipEntry entry = (ZipEntry) enum.nextElement();
+	
+	int method = entry.getMethod();
+	writeLeInt(CENSIG);
+	writeLeShort(method == STORED
+		     ? ZIP_STORED_VERSION : ZIP_DEFLATED_VERSION);
+	writeLeShort(method == STORED
+		     ? ZIP_STORED_VERSION : ZIP_DEFLATED_VERSION);
+	writeLeShort(entry.flags);
+	writeLeShort(method);
+	writeLeInt(entry.getDOSTime());
+	writeLeInt((int)entry.getCrc());
+	writeLeInt((int)entry.getCompressedSize());
+	writeLeInt((int)entry.getSize());
+
+	byte[] name = entry.getName().getBytes();
+	if (name.length > 0xffff)
+	  throw new ZipException("Name too long.");
+	byte[] extra = entry.getExtra();
+	if (extra == null)
+	  extra = new byte[0];
+	String strComment = entry.getComment();
+	byte[] comment = strComment != null
+	  ? strComment.getBytes() : new byte[0];
+	if (comment.length > 0xffff)
+	  throw new ZipException("Comment too long.");
+
+	writeLeShort(name.length);
+	writeLeShort(extra.length);
+	writeLeShort(comment.length);
+	writeLeShort(0); /* disk number */
+	writeLeShort(0); /* internal file attr */
+	writeLeInt(0);   /* external file attr */
+	writeLeInt(entry.offset);
+
+	out.write(name);
+	out.write(extra);
+	out.write(comment);
+	numEntries++;
+	sizeEntries += CENHDR + name.length + extra.length + comment.length;
+      }
+
+    writeLeInt(ENDSIG);
+    writeLeShort(0); /* disk number */
+    writeLeShort(0); /* disk with start of central dir */
+    writeLeShort(numEntries);
+    writeLeShort(numEntries);
+    writeLeInt(sizeEntries);
+    writeLeInt(offset);
+    writeLeShort(zipComment.length);
+    out.write(zipComment);
+    out.flush();
+    entries = null;
+  }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/kaffe/util/zip/SwitchInflater.java kaffe/libraries/javalib/kaffe/util/zip/SwitchInflater.java
--- kaffe_orig/libraries/javalib/kaffe/util/zip/SwitchInflater.java	2003-09-26 14:19:13.000000000 +1200
+++ kaffe/libraries/javalib/kaffe/util/zip/SwitchInflater.java	2003-09-27 23:06:53.000000000 +1200
@@ -37,7 +37,7 @@
   public synchronized boolean needsInput()
   {
     if (stored) {
-      return (len > 0 ? false : true);
+      return (Len > 0 ? false : true);
     }
     else {
       return super.needsInput();
@@ -59,12 +59,12 @@
 		if (l >= maxlen) {
 			l = maxlen;
 		}
-		if (l >= len) {
-			l = len;
+		if (l >= Len) {
+			l = Len;
 		}
-		System.arraycopy(buf, off, b, o, l);
-		off += l;
-		len -= l;
+		System.arraycopy(Buf, Off, b, o, l);
+		Off += l;
+		Len -= l;
 		maxlen -= l;
 	}
 	else {
@@ -74,9 +74,9 @@
   }
 
   public synchronized void reset() {
-    int olen = len;
+    int olen = Len;
     super.reset();
-    len = olen;
+    Len = olen;
   }
 
   public synchronized void setMode(boolean stored) {
